*
************************************************************************
*
        Subroutine ARRAYINT(KEY, E,CS,N,T,INTS0,RES)
*       --------------------------------------------
* REAL*8
*
*  To get RES value for arrays E(N),CS(N) at point T depending
*  ----------------------------------------------------------
*  from INTS int scheme 
*  -------------------
*
* KEY defines how to treat situation when T is not covered by E array
* ---
* KEY = 0   :  stop when T < E(1)  or T > E(N)
*     = 1   :  assign RES=0.0 if T < E(1) and RES=CS(N) if T > E(N)
* 
* INT has the usual meaning as in ENDF/B format
*
* Attention (!)
* ---------
* Input arrays E(N) and CS(N) should be in increased order
*
*
       implicit real*8(A-H,O-Z)
       Dimension E(N), CS(N)
       if(KEY.lt.0.or.KEY.gt.1) then
       Print *,'                        E R R O R         '
       Print *,'Subroutine  ARRAYINT:  KEY=',KEY,' is not acceptable !'
       print *,'                            press any key...'
       pause
       stop
       endif
       INTS=INTS0
*
       If(T.lt.E(1)) goto 8000
       If(T.gt.E(N)) goto 9000
*
       Do i=1,N
       i1=i
       If( T.le.E(i) ) goto 1000
       Enddo
            goto 9500
1000   if(i1.eq.1) then  ! means that T=E(1)
       RES=CS(1)
       Return
       Endif       
          X1=E(i1-1)
          X2=E(i1)
          Y1=CS(i1-1)
          Y2=CS(i1)
          WL=T
       CALL INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
       RES=RESINT
       Return
* 
* 
* T < E(1)
* --------
8000   if(key.eq.0) then
       Write(6,*)'                        E R R O R        '
       Write(6,8001) T,E(1),key
8001   Format(1x,'Subroutine  ARRAYINT:'/1x,
     # ' Requested energy T=',e12.5,' is less than minimal array '
     # ,'E(1) value=',e12.5
     #  //1x,'              CHANGE THE DATA or KEY number !!'/1x,
     # ' now  KEY is equal to', i5)
       print *,'                            press any key...'
       pause
       stop
       endif
c         
       RES=0.0
       Print 8002,T,RES
8002   Format(1x,'ARRAYINT(N): for T =',e12.5,' result ',
     # 'is set to',e12.5,' (min)')
       Return
* 
* T > E(N)
* --------
9000   if(key.eq.0) then
       Write(6,*)'                        E R R O R        '
       Write(6,9001) T,E(N),key
9001   Format(1x,'Subroutine  ARRAYINT:'/1x,
     # ' Requested energy T=',e12.5,' is more than MAXIMAL array '
     # ,'E(N) value=',e12.5
     #  //1x,'              CHANGE THE DATA or KEY number !!'/1x,
     # ' now  KEY is equal to', i5)
       print *,'                            press any key...'
       pause
       stop
       endif
c         
       RES=CS(N)
       Print 9002,T,RES
9002   Format(1x,'ARRAYINT(X): for T =',e12.5,' result ',
     # 'is set to',e12.5,' (MAX)')
       Return
*
9500   Write(6,9501)
9501   Format(1x,'Subroutine  ARRAYINT:  Strange E R R O R')
       print *,'                            press any key...'
       pause
       stop
       End
