*
************************************************************************
*
        Subroutine DATATAB
*       ------------------
c A, W (amu), Ro (g/cm3) , <I> (eV) for elements
c
c Data from SRIM code
c  <I> is mean ionization potential (eV) checked by data in figures 
c  presented in http://www.srim.org/SRIM/SRIMPICS/IONIZ.htm,
c  except data noted below
c
c subroutine called from PRECALCULATION
c
      implicit real*8(A-H,O-Z)
      Common/DATATAB1/WTAB1(101),ROTAB1(101),RITAB1(101),IATAB1(101)
      Dimension IATAB(92), WTAB(92), ROTAB(92), RITAB(92)
*
*  H
      Data IATAB( 1),  WTAB( 1),  ROTAB( 1),  RITAB( 1)
     & /        1   ,    1.0079,   0.071486,    19.60/
* He
      Data IATAB( 2),  WTAB( 2),  ROTAB( 2),  RITAB( 2)
     & /        4   ,    4.0026,   0.125880,    39.00/
* Li
      Data IATAB( 3),  WTAB( 3),  ROTAB( 3),  RITAB( 3)
     & /        7   ,    6.9410,   0.534000,    42.20/
* Be
      Data IATAB( 4),  WTAB( 4),  ROTAB( 4),  RITAB( 4)
     & /        9   ,    9.0122,   1.848000,    63.70/
*  B
      Data IATAB( 5),  WTAB( 5),  ROTAB( 5),  RITAB( 5)
     & /       11   ,   10.8110,   2.350200,    76.00/
*  C
      Data IATAB( 6),  WTAB( 6),  ROTAB( 6),  RITAB( 6)
     & /       12   ,   12.0110,   2.253000,    79.10/
*  N
      Data IATAB( 7),  WTAB( 7),  ROTAB( 7),  RITAB( 7)
     & /       14   ,   14.0070,   1.026000,    84.20/
*  O
      Data IATAB( 8),  WTAB( 8),  ROTAB( 8),  RITAB( 8)
     & /       16   ,   15.9990,   1.426000,    96.00/
*  F
      Data IATAB( 9),  WTAB( 9),  ROTAB( 9),  RITAB( 9)
     & /       19   ,   18.9980,   1.111100,   107.00/
* Ne
      Data IATAB(10),  WTAB(10),  ROTAB(10),  RITAB(10)
     & /       20   ,   20.1797,   1.204000,   133.00/
* Na
      Data IATAB(11),  WTAB(11),  ROTAB(11),  RITAB(11)
     & /       23   ,   22.9898,   0.970000,   149.00/
* Mg
      Data IATAB(12),  WTAB(12),  ROTAB(12),  RITAB(12)
     & /       24   ,   24.3050,   1.736600,   156.00/
* Al
      Data IATAB(13),  WTAB(13),  ROTAB(13),  RITAB(13)
     & /       27   ,   26.9815,   2.702000,   170.00/
* Si
      Data IATAB(14),  WTAB(14),  ROTAB(14),  RITAB(14)
     & /       28   ,   28.0860,   2.321200,   171.00/
*  P
      Data IATAB(15),  WTAB(15),  ROTAB(15),  RITAB(15)
     & /       31   ,   30.9737,   1.821900,   173.00/
*  S
      Data IATAB(16),  WTAB(16),  ROTAB(16),  RITAB(16)
     & /       32   ,   32.0660,   2.068600,   184.00/
* Cl
      Data IATAB(17),  WTAB(17),  ROTAB(17),  RITAB(17)
     & /       35   ,   35.4530,   1.895600,   178.00/
* Ar
      Data IATAB(18),  WTAB(18),  ROTAB(18),  RITAB(18)
     & /       40   ,   39.9480,   1.650400,   190.00/
*  K
      Data IATAB(19),  WTAB(19),  ROTAB(19),  RITAB(19)
     & /       39   ,   39.0983,   0.863180,   190.00/
* Ca
      Data IATAB(20),  WTAB(20),  ROTAB(20),  RITAB(20)
     & /       40   ,   40.0800,   1.540000,   198.00/
* Sc
      Data IATAB(21),  WTAB(21),  ROTAB(21),  RITAB(21)
     & /       45   ,   44.9560,   2.989000,   225.00/
* Ti
      Data IATAB(22),  WTAB(22),  ROTAB(22),  RITAB(22)
     & /       48   ,   47.9000,   4.518900,   231.00/
*  V
      Data IATAB(23),  WTAB(23),  ROTAB(23),  RITAB(23)
     & /       51   ,   50.9420,   5.960000,   249.00/
* Cr
      Data IATAB(24),  WTAB(24),  ROTAB(24),  RITAB(24)
     & /       52   ,   51.9960,   7.200000,   265.00/
* Mn
      Data IATAB(25),  WTAB(25),  ROTAB(25),  RITAB(25)
     & /       55   ,   54.9380,   7.434100,   275.00/
* Fe
      Data IATAB(26),  WTAB(26),  ROTAB(26),  RITAB(26)
     & /       56   ,   55.8470,   7.865800,   286.00/
* Co
      Data IATAB(27),  WTAB(27),  ROTAB(27),  RITAB(27)
     & /       59   ,   58.9330,   8.900000,   306.00/
* Ni
      Data IATAB(28),  WTAB(28),  ROTAB(28),  RITAB(28)
     & /       58   ,   58.6900,   8.895500,   321.00/
* Cu
      Data IATAB(29),  WTAB(29),  ROTAB(29),  RITAB(29)
     & /       63   ,   63.5460,   8.920000,   332.00/
* Zn
      Data IATAB(30),  WTAB(30),  ROTAB(30),  RITAB(30)
     & /       64   ,   65.3900,   7.140000,   330.00/
* Ga
      Data IATAB(31),  WTAB(31),  ROTAB(31),  RITAB(31)
     & /       69   ,   69.7200,   5.904000,   334.00/
* Ge
      Data IATAB(32),  WTAB(32),  ROTAB(32),  RITAB(32)
     & /       74   ,   72.6100,   5.350000,   335.00/
* As
      Data IATAB(33),  WTAB(33),  ROTAB(33),  RITAB(33)
     & /       75   ,   74.9220,   5.727000,   353.00/
* Se
      Data IATAB(34),  WTAB(34),  ROTAB(34),  RITAB(34)
     & /       80   ,   78.9600,   4.810000,   351.00/
* Br
      Data IATAB(35),  WTAB(35),  ROTAB(35),  RITAB(35)
     & /       79   ,   79.9040,   3.199000,   317.00/
* Kr
      Data IATAB(36),  WTAB(36),  ROTAB(36),  RITAB(36)
     & /       84   ,   83.8000,   2.602100,   348.00/
* Rb
      Data IATAB(37),  WTAB(37),  ROTAB(37),  RITAB(37)
     & /       85   ,   85.4700,   1.532000,   364.00/
* Sr
      Data IATAB(38),  WTAB(38),  ROTAB(38),  RITAB(38)
     & /       88   ,   87.6200,   2.600000,   366.00/
*  Y
      Data IATAB(39),  WTAB(39),  ROTAB(39),  RITAB(39)
     & /       89   ,   88.9050,   4.469000,   375.00/
* Zr
      Data IATAB(40),  WTAB(40),  ROTAB(40),  RITAB(40)
     & /       90   ,   91.2200,   6.490000,   389.00/
* Nb
      Data IATAB(41),  WTAB(41),  ROTAB(41),  RITAB(41)
     & /       93   ,   92.9060,   8.570000,   417.00/
* Mo
      Data IATAB(42),  WTAB(42),  ROTAB(42),  RITAB(42)
     & /       98   ,   95.9400,  10.206000,   423.00/
* Tc
      Data IATAB(43),  WTAB(43),  ROTAB(43),  RITAB(43)
     & /       97   ,   97.0000,  11.500000,   428.00/
* Ru
      Data IATAB(44),  WTAB(44),  ROTAB(44),  RITAB(44)
     & /      102   ,  101.0700,  12.300000,   441.00/
* Rh
      Data IATAB(45),  WTAB(45),  ROTAB(45),  RITAB(45)
     & /      103   ,  102.9100,  12.399000,   468.00/
* Pd
      Data IATAB(46),  WTAB(46),  ROTAB(46),  RITAB(46)
     & /      106   ,  106.4000,  12.020000,   476.00/
* Ag
      Data IATAB(47),  WTAB(47),  ROTAB(47),  RITAB(47)
     & /      107   ,  107.8700,  10.473000,   488.00/
* Cd
      Data IATAB(48),  WTAB(48),  ROTAB(48),  RITAB(48)
     & /      114   ,  112.4000,   8.642000,   441.00/
* In
      Data IATAB(49),  WTAB(49),  ROTAB(49),  RITAB(49)
     & /      115   ,  114.8200,   7.300000,   481.00/
* Sn
      Data IATAB(50),  WTAB(50),  ROTAB(50),  RITAB(50)
     & /      120   ,  118.7100,   7.281600,   478.00/
* Sb
      Data IATAB(51),  WTAB(51),  ROTAB(51),  RITAB(51)
     & /      121   ,  121.7500,   6.684000,   472.00/
* Te
      Data IATAB(52),  WTAB(52),  ROTAB(52),  RITAB(52)
     & /      130   ,  127.6000,   6.250000,   485.00/
*  I
      Data IATAB(53),  WTAB(53),  ROTAB(53),  RITAB(53)
     & /      127   ,  126.9000,   4.937300,   455.00/
* Xe
      Data IATAB(54),  WTAB(54),  ROTAB(54),  RITAB(54)
     & /      132   ,  131.3000,   3.058900,   440.00/
* Cs
      Data IATAB(55),  WTAB(55),  ROTAB(55),  RITAB(55)
     & /      133   ,  132.9100,   1.878500,   488.00/
* Ba
      Data IATAB(56),  WTAB(56),  ROTAB(56),  RITAB(56)
     & /      138   ,  137.3270,   3.510000,   491.00/
* La
      Data IATAB(57),  WTAB(57),  ROTAB(57),  RITAB(57)
     & /      139   ,  138.9100,   6.173800,   472.00/
* Ce
      Data IATAB(58),  WTAB(58),  ROTAB(58),  RITAB(58)
     & /      140   ,  140.1200,   6.672400,   501.00/
* Pr
      Data IATAB(59),  WTAB(59),  ROTAB(59),  RITAB(59)
     & /      141   ,  140.9100,   6.773000,   513.00/
* Nd
      Data IATAB(60),  WTAB(60),  ROTAB(60),  RITAB(60)
     & /      142   ,  144.2400,   7.008000,   546.00/
* Pm
      Data IATAB(61),  WTAB(61),  ROTAB(61),  RITAB(61)
     & /      148   ,  148.0000,   6.475000,   560.00/
* Sm
      Data IATAB(62),  WTAB(62),  ROTAB(62),  RITAB(62)
     & /      152   ,  150.3600,   7.520000,   566.00/
* Eu
      Data IATAB(63),  WTAB(63),  ROTAB(63),  RITAB(63)
     & /      153   ,  151.9700,   5.244000,   580.00/
* Gd
      Data IATAB(64),  WTAB(64),  ROTAB(64),  RITAB(64)
     & /      158   ,  157.2500,   7.901000,   586.00/
* Tb
      Data IATAB(65),  WTAB(65),  ROTAB(65),  RITAB(65)
     & /      159   ,  158.9300,   8.230000,   614.00/
* Dy
      Data IATAB(66),  WTAB(66),  ROTAB(66),  RITAB(66)
     & /      164   ,  162.5000,   8.551000,   603.00/
* Ho
      Data IATAB(67),  WTAB(67),  ROTAB(67),  RITAB(67)
     & /      165   ,  164.9300,   8.795000,   641.00/
* Er
      Data IATAB(68),  WTAB(68),  ROTAB(68),  RITAB(68)
     & /      166   ,  167.2600,   9.066000,   661.00/
* Tm
      Data IATAB(69),  WTAB(69),  ROTAB(69),  RITAB(69)
     & /      169   ,  168.9300,   9.321000,   683.00/
* Yb
      Data IATAB(70),  WTAB(70),  ROTAB(70),  RITAB(70)
     & /      174   ,  173.0400,   6.960000,   684.00/
* Lu
      Data IATAB(71),  WTAB(71),  ROTAB(71),  RITAB(71)
     & /      175   ,  174.9700,   9.841000,   694.00/
* Hf
      Data IATAB(72),  WTAB(72),  ROTAB(72),  RITAB(72)
     & /      180   ,  178.4900,  13.310000,   675.00/
* Ta
      Data IATAB(73),  WTAB(73),  ROTAB(73),  RITAB(73)
     & /      181   ,  180.9500,  16.601000,   729.00/
*  W
      Data IATAB(74),  WTAB(74),  ROTAB(74),  RITAB(74)
     & /      184   ,  183.8500,  19.350000,   735.00/
* Re
      Data IATAB(75),  WTAB(75),  ROTAB(75),  RITAB(75)
     & /      187   ,  186.2000,  20.530001,   749.00/
* Os
      Data IATAB(76),  WTAB(76),  ROTAB(76),  RITAB(76)
     & /      192   ,  190.2000,  22.480000,   746.00/
* Ir
      Data IATAB(77),  WTAB(77),  ROTAB(77),  RITAB(77)
     & /      193   ,  192.2000,  22.421000,   757.00/
* Pt
      Data IATAB(78),  WTAB(78),  ROTAB(78),  RITAB(78)
     & /      195   ,  195.0800,  21.450001,   792.00/
* Au
      Data IATAB(79),  WTAB(79),  ROTAB(79),  RITAB(79)
     & /      197   ,  196.9700,  19.311001,   789.00/
* Hg
      Data IATAB(80),  WTAB(80),  ROTAB(80),  RITAB(80)
     & /      202   ,  200.5900,  13.546200,   800.00/
* Tl
      Data IATAB(81),  WTAB(81),  ROTAB(81),  RITAB(81)
     & /      205   ,  204.3800,  11.850000,   810.00/
* Pb
      Data IATAB(82),  WTAB(82),  ROTAB(82),  RITAB(82)
     & /      208   ,  207.1900,  11.343700,   787.00/
* Bi
      Data IATAB(83),  WTAB(83),  ROTAB(83),  RITAB(83)
     & /      209   ,  208.9800,   9.800000,   819.00/
* Po (no fig for <I>)
      Data IATAB(84),  WTAB(84),  ROTAB(84),  RITAB(84)
     & /      209   ,  210.0000,   9.251100,   830.00/
* At <I> is not well defined from SRIM data (see original files)
      Data IATAB(85),  WTAB(85),  ROTAB(85),  RITAB(85)
     & /      210   ,  210.0000,  10.000000,   756.95/
* Rn <I> is not well defined from SRIM data (see original files)
      Data IATAB(86),  WTAB(86),  ROTAB(86),  RITAB(86)
     & /      222   ,  222.0000,   9.910000,   736.54/
* Fr (no fig for <I>)
      Data IATAB(87),  WTAB(87),  ROTAB(87),  RITAB(87)
     & /      223   ,  223.0000,  10.000000,   827.00/
* Ra (no fig for <I>)
      Data IATAB(88),  WTAB(88),  ROTAB(88),  RITAB(88)
     & /      226   ,  226.0000,   5.022200,   826.00/
* Ac (no fig for <I>)
      Data IATAB(89),  WTAB(89),  ROTAB(89),  RITAB(89)
     & /      227   ,  227.0000,  10.000000,   841.00/
* Th (no fig for <I>)
      Data IATAB(90),  WTAB(90),  ROTAB(90),  RITAB(90)
     & /      232   ,  232.0000,  11.658000,   847.00/
* Pa (no fig for <I>)
      Data IATAB(91),  WTAB(91),  ROTAB(91),  RITAB(91)
     & /      231   ,  231.0000,  15.370000,   878.00/
*  U
      Data IATAB(92),  WTAB(92),  ROTAB(92),  RITAB(92)
     & /      238   ,  238.0300,  19.042999,   842.00/
c
c
      Do i=1,92
      IATAB1(i)=IATAB(i)
      WTAB1(i) =WTAB(i) 
      ROTAB1(i)=ROTAB(i)
      RITAB1(i)=RITAB(i)
      enddo
          Do i=93,101
          IATAB1(i)=0
          WTAB1(i) =0.0
          ROTAB1(i)=0.0
          RITAB1(i)=0.0
          enddo
      Return
      End   
