* 
*
************************************************************************
*
         Subroutine  DEDX_ZIEGLER_READ(IK, IR0, RO0, Ex, dEdx, Rp, NdE,
     #   dEdxN)
*        -------------------------------------------------------------
*
* for any SRIM version
*
c
c Ex,  dEdx  - energy and total stopping power   (Ziegler/SRIM)
c      dEdxN - nuclear stopping power            (Ziegler/SRIM)
c
         parameter (maxc=21)
         implicit real*8(A-H,O-Z)
         Character C12*12,C33*33,C7*7,CID3*3,CID2*2, C17*17
         Character C6*6, C80*80
         Character*500 CC,LineWas
         Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
         Common/Basic/Z1,A1,Z2,A2,AW,ROOO,RN0
         Common/Tlim0/Tlim
         Dimension Rp(1501), Ex(1501), dEdx(1501)
         Dimension dEdxN(1501)
         Dimension ExTMP(1501),dEdxETMP(1501), dEdxE(1501)
         Dimension ExTMP2(1501),dEdxETMP2(1501)
         If(IK.eq.1)               then
                     Zini=Z1
                     Aini=A1
                                   else
                     Zini=ZT(IK-1)
                     Aini=AT(IK-1)
                                   endif
                     IZT=Idint(Zini+0.001)
                     IAT=Idint(Aini+0.001)
*
* Rewrite file without "," 
         open(199,status='scratch')
         IR=199
*
         do while (.not.eof(IR0))
         Read(ir0,'(a)')cc

         do i=1,500;if(cc(i:i)==',') cc(i:i)='.'; enddo
         Call LetzteZ(cc,icc) 
         write(ir,'(a)')cc(1:icc)
         enddo 
         rewind IR
*                                                                          
*
* find "Ion ="
*
         Do 1 while (.not.eof(IR))
         Read(IR,'(a)')CC

         LineWas='Ion ='
         Call FindenUB(CC,LineWas,IPos)    
         If(Ipos/=0) goto 11
    1    Continue 
                                                            goto 90001 

* Get Z,A from SRIM output 
   11    Call ZieION(CC,Zzie,Azie)
*
*
* find "Target density"
*
         Do 20 while (.not.eof(IR))
         Read(IR,'(a)')CC

         LineWas='Target Density ='
         Call FindenUB(CC,LineWas,IPos)    
         If(Ipos/=0)                                Then   ! 1)

         Read(CC((Ipos+16):),*,err=80000)RO

         iro=idint(ro*1000.+0.01d0)
         iro0=idint(ro0*1000.+0.01d0)

            if(iRO.ne.iRO0) then               ! 2)
            print 18,IZT,IAT,RO0,RO
   18       format(1x,'  W A R N I N G !'/1x,
     #      'for ',i3,i4,' RO(input)=',g12.5,' BUT  Ziegler(RO)=',
     #      g12.5/1x,'The last one will be used to recover dEdx')
            print *,'                   press any key to continue'
            pause
                          endif                ! 2)
         goto 22
                                                    Endif  ! 1)
   20    Continue
                                                            goto 90005
*
*
* find line "Stopping units"
*
   22    do 30 while (.not.eof(IR))
         Read(IR,'(a)')CC

         LineWas='Stopping Units ='
         Call FindenUB(CC,LineWas,IPos)    
         If(Ipos/=0)                                        theN
             LineWas='Stopping Units =  MeV / (mg/cm2)'
             Call FindenUB(CC,LineWas,IPos2)    
             if(Ipos2==0)       then
             Print *,' Units of stopping power must be MeV/mg/cm2 !'
             print *,'                         press any key...'
             pause;stop;        endif
          goto 33
                                                            endiF
   30     Continue
                                                            goto 90006
*
*
* find line with "Energy"   "Elec."   "Nuclear"
*
   33    do 40 while (.not.eof(IR))
         Read(IR,'(a)')CC

         LineWas='Energy'
         Call FindenUB(CC,LineWas,IPos1)    
            LineWas='Elec.'
            Call FindenUB(CC,LineWas,IPos2)    
               LineWas='Nuclear'
               Call FindenUB(CC,LineWas,IPos3)    
         If(Ipos1/=0.and.Ipos2/=0.and.Ipos3/=0)  goto 44
   40    continue         
                                                            goto 90007
*
* omit one line
   44    read(IR,*)  
*
*
* Begin reading
*
* transformation of SRIM data 
*
         i=1
           Ex(1)=0.0
           dEdx(1)=0.0
           Rp(1)=0.0
           dEdxN(1)=0.0
c
c
         Do iii=1,1111111       ! ---c y c l e begins----

         read(IR,'(a)')CC
         if(CC(3:9).eq.'-------') goto 2000 

         read(CC,'(e7.0,1x, a3,   e12.0,   e11.0,    e8.0,1x, a2)')
     #             EN,       CID3, dEdx_el, dEdx_nuc, RRR,       CID2
*
         if(CID3.ne.'eV '.and.CID3.ne.'keV'.and.CID3.ne.'MeV'.
     #   and.CID3.ne.'GeV') call error0(' ev?',11111)
*
* energy ---> MeV
                            ENERGY_MULT=1.0
         if(CID3.eq.'eV ')  ENERGY_MULT=1.E-06
         if(CID3.eq.'keV')  ENERGY_MULT=1.E-03
         if(CID3.eq.'GeV')  ENERGY_MULT=1.E+03
*
         if(CID2.ne.'A '.and.CID2.ne.'um'.and.CID2.ne.'mm'
     #   .and.CID2.ne.'cm'.and.CID2.ne.'m ') call error0(' um?',11111)
*
* all units ---> cm
                           RANGE_MULT=1.
         if(CID2.eq.'A ')  RANGE_MULT=1.E-08     ! 1 A=10**-10 m
         if(CID2.eq.'um')  RANGE_MULT=1.E-04     ! 1 um=micron= 10**-6 m
         if(CID2.eq.'mm')  RANGE_MULT=0.1        ! 1 mm=0.001 m
         if(CID2.eq.'m ')  RANGE_MULT=100.       ! 1 m =100 cm 
* 1)
* MeV/(mg/cm2) ----> MeV/(g/cm2)
         dEdx_sum= 1000.*( dEdx_el+dEdx_nuc)
         dEdx_nuc2= 1000.*dEdx_nuc
* 2)
* MeV/(g/cm2) ----> MeV/cm
         dEdx_sum= dEdx_sum*RO
         dEdx_nuc2= dEdx_nuc2*RO
*
         Energy=EN* ENERGY_MULT
         Range= RRR* RANGE_MULT
*
* fill arrays
         i=i+1
                  if(i.gt.1501)  Call error0('DEDX',1501)
         Ex(i)=Energy
         dEdx(i)=dEdx_sum
         dEdxN(i)= dEdx_nuc2
         Rp(i)=Range
         Enddo                  ! ---c y c l e finished----
         call error0('_Zie',11111)
*
* end of reading
2000     NdE=i
         close(IR) ! IR=199
*
*
* General check of energies
* --------------------------
* the first energy should be around 1.1 eV, i.e. Ex(2)
* the last one around Tlim
       if( Ex(2) > 2.0e-06) goto 90008
       if( (Ex(NdE) < Tlim).and. (Tlim-Ex(NdE))/Tlim > 0.01) goto 90009
*
*
*
*
* Recalculate stopping if Z=Z', but A.ne.A'
*
         IZzie=Idint(Zzie+0.001)
         If(IZzie.ne.IZT) then
         Print 3000,Zini,Aini,Zzie,Azie
3000     Format(' SRIM data failure !!!'/1x,' Current incident ion is ',
     #   f5.1,f8.2/20x,'BUT'/' SRIM data are prepared for ',f5.1,f8.2)
         print *,'                           press any key...'
         pause
         stop
                          endif
* no recalculation if A-A' < 1
         If( abs(Azie-Aini).lt.1.0) Return
*
*Feb1307
*****         If(NK.ne.1) then
*****         Print 3100
*****3100     Format(70('*')/'*',25x,'W A R N I N G !',t70,'*'/'*',
*****     #   4x,' for compounds stopping power will not be recalculated',
*****     #   t70,'*'/70('*')//1x,
*****     #   'press any key to continue  calculations ...')
*****         pause
*****         Return
*****                     endif
*
* Recalculation
* 
* i) electronic stopping
*
         Do i=1,NdE
         ExTMP(i)=Ex(i)*Aini/Azie
         dEdxETMP(i)=dEdx(i)-dEdxN(i)
         Enddo  
c 
         if(Aini-Azie) 4000,4000,5000
c
c A' < A ==> lack of high energy data, get them by interp two last points
c
4000        Do i=1,NdE
            m=i
            if(ExTMP(NdE).le.Ex(i)) goto 4010
            Enddo
         call error0('4010',NdE)
4010         X1=ExTMP(NdE-1)
             X2=ExTMP(NdE)
             Y1=dEdxETMP(NdE-1)
             Y2=dEdxETMP(NdE)
             INTS=2
         j=NdE
         Do i=m,NdE
         j=j+1
                  if(j.gt.1501)  Call error0('j :1',1501)
         ExTMP(j)=Ex(i)
         WL=ExTMP(j)
         Call INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
         dEdxETMP(j)=RESINT
         Enddo
         NdETMP=j
         goto 7000
c 
c A' > A ==> lack of low energy data, get them by interp two first points
c
5000        Do i=2,NdE
            m=i-1
            if(ExTMP(2).le.Ex(i)) goto 5010  ! "2" is first non-zero value
            Enddo
         call error0('5010',NdE)
5010         X1=ExTMP(2)
             X2=ExTMP(3)
             Y1=dEdxETMP(2)
             Y2=dEdxETMP(3)
             INTS=2
         j=1
         ExTMP2(j)=0.0
         dEdxETMP2(j)=0.0
c
         Do i=2,m
         j=j+1
         ExTMP2(j)=Ex(i)
         WL=ExTMP2(j)
         Call INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
         dEdxETMP2(j)=RESINT
         Enddo
c
           Do i=2,NdE
           j=j+1
                  if(j.gt.1501)  Call error0('j :2',1501)
           ExTMP2(j)=ExTMP(i)
           dEdxETMP2(j)=dEdxETMP(i)
           Enddo
         NdETMP=j
           Do i=1,NdETMP
           ExTMP(i)=ExTMP2(i)
           dEdxETMP(i)=dEdxETMP2(i)
           Enddo
c
c recover old energy grid
c
7000     Do i=1,NdE
         E=Ex(i)
         Call ARRAYINT(0,ExTMP,dEdxETMP, NdETMP, E, 2, RES)
         dEdxE(i)=RES
         Enddo 
*
* ii) nuclear stopping
*
       Do i=2,NdE
       E=Ex(i)
       Call dEdXnuc_recalc(Zzie,Z2,Azie,A2,E,sNzie)
       Call dEdXnuc_recalc(Zini,Z2,Aini,A2,E,sNini)
       If(sNzie.eq.0.0) Call error0('snzi',0)
c
       dEdxN(i)=dEdxN(i)*sNini/sNzie
       Enddo
*
* total stopping 
                           open(22,file='renorm.sto') ! test printing
       Write(22,7500)Zini,Aini,Zzie,Azie,Z2,A2
7500   Format(' Incident ion  ', f5.1,f8.2/
     # ' SRIM data for ',f5.1,f8.2/25x,' Target ',f5.1,f8.2//
     #' Energy [MeV],   Stopping power [MeVcm2/mg]'//
     #'     E         dE/dx(elec)     dE/dx(nucl) '/44('-'))
*****     #' Energy [MeV],   Stopping power [MeV/cm]'//
*****     #'     E         dE/dx(elec)     dE/dx(nucl) '/44('-'))
c
       Do i=1,NdE

* ? 20 Sept 2017
       if( dEdxN(i) <= 0.0 ) dEdxN(i)=1.d-5
       if( dEdxE(i) <= 0.0 ) dEdxE(i)=1.d-5

       dEdx(i)=dEdxN(i)+dEdxE(i)
*Feb1307
       Write(22,'(1pe11.4,e14.3,e16.3)')Ex(i),dEdxE(i)/(1000.*RO),
     # dEdxN(i)/(1000.*RO)
       Enddo
c
       Return
c
c
80000    Print *,'-----Subroutine DEDX_ZIEGLER_READ ------'
         Print *,'  Error by reading  target density'
         print *,'                         press any key...'
         pause
         stop
90001    Print *,'------- End of SRIM output file ------'
         Print *,'  Phrase "Ion =" is not found'
         print *,'                         press any key...'
         pause
         stop
90005    Print *,'-------  End of SRIM output file ------'
         Print *,'  Phrase "Target density" is not found'
         print *,'                         press any key...'
         pause
         stop
90006    Print *,'-------  End of SRIM output file ------'
         Print *,'  Phrase "Stopping units" is not found'
         print *,'                         press any key...'
         pause
         stop
90007    Print *,'-------  End of SRIM output file ------'
         Print *,' Line with "Energy"  "Elec."  "Nuclear" is not found'
         print *,'                         press any key...'
         pause
         stop
90008    Print *,'-------  SRIM data ------'
         Print '(a,1pg12.5,a)',
     c     ' The first energy ', Ex(2),' MeV   is too high !'
         print *,'                         press any key...'
         pause
         stop
90009    Print *,'-------  SRIM data ------'
         Print '(a,1pg12.5,a)',
     c     ' The last energy ', Ex(NdE),' MeV   is too low !'
         print *,'                         press any key...'
         pause
         stop
         End
