* August 2017 
* New Subroutine 
*
* 06.06.2011
* V, 20 K (Bjorkas, NIMB 267 (2009) 3204 )
*
*
* 13.12.2010
* Ti, 100 K (Bacon, JNM 276 (2000) 1 )
*
*
* 28.10.2010 
* Zr, 600K ( Gao, JNM 294 (2001) 288; Voskoboinikov NIMB 242 (2006) 68 )
*
*
* 17.09.2010 
* Al hinzugefgt (Bacon 276 (2000) 1, aber die Resultate sind von Almazouzi)
*
*
* 01.09.2010
* fr Cu CMD(4) korrigiert
*
*
* 23.03.2009
*
* Ni : Bacon (2000)
* Fe und Cr: Voertler (2008)
*
*
*Feb0107:   EdMD is added
*
************************************************************************
*
        Subroutine MDPARAM(IZ0,MDname, NOTE)
*       --------------------------------------------
        implicit real*8(A-H,O-Z)
        Character*500 NOTE,CID(999), MDname
        Common/MERCURY/CMD(5),Ecrit,EdMD,MD
                                            do i=1,999; cid(i)=' ';enddo
*
*
* Explanation of the information required to use MD results in the code
* =====================================================================
*
*
*  CID(jj)=' Z  ID  Identifier  any other information '
*
*      jj: any unique number from 1 to 999. This number does not play 
*          any special role.  It should not be given in asceding or 
*          in descending oder, can go  not in succession (mozhet idti 
*          ne podryad, imet' propuski). See below the example for 
*          iron (2 times)
*
*            Z : atomic number of material (Integer)
*
*                ID:  the label in the code, where the corresponding
*                     information is presented. See below "if(ID=="
*
*                   Identifier: corresponds to the name (MDname), which 
*                               will be used in the input- file to identify 
*                               the MD results. (!) Should have at least
*                               one space before and after (!). It is the
*                               3rd (!) word in each CID( )- line.
*
*                       any other information: any information, which will
*                                              appear in the output
*
* The number of spaces in CID( ) is not important.
* 
* Al
        CID(13)='13  13  Bacon (2000) und Almazouzi (1999)'
* Ti
        CID(22)='22  22  Bacon'
* V
        CID(23)='23  23   Bjorkas et al'
*
* Cr is taken = Iron  ("2601")
        CID(24)='24  2601   Voertler  (= Iron)'
*
* Fe (1) 
        CID(2)='26  2601   Voertler'
* Fe (2) 
        CID(1)='26  2602   Stoller '
* Ni
        CID(28)='28  28     Bacon'
* Cu
        CID(29)='29  29       Caturla et al'
* Zr
        CID(40)='40  40   Gao et al'
* W
        CID(74)='74   74  Caturla et al'
*
*
*
        Call Identify_MD_results(IZ0,CID,999, MDname, ID,Note)
*
*
        If(ID.eq.  13) goto   13 
        If(ID.eq.  22) goto   22
        If(ID.eq.  23) goto   23
        If(ID.eq.2601) goto 2601
        If(ID.eq.2602) goto 2602
        If(ID.eq.  28) goto   28
        If(ID.eq.  29) goto   29
        If(ID.eq.  40) goto   40
        If(ID.eq.  74) goto   74
                                                             goto 99999
c
*
*
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
*
*       a) C(1)-C(3)
*       b) C(4):   eMD(keV) the lowest energy, below which the 
*                    efficiency is a constant
*       c) C(5):   eMD(keV) the highest energy, above which the
*                    efficiency is a constant
*       d) Ecrit (keV):   eMD < Ecrit: MD;  eMD > Ecrit: BCA
*       e) EdMD (MeV): Ed used in MD for the comparison with NRT
*
* Note! eMD is not the incident ion energy, eMD is equal (approximately)
*         to the damage energy (Tdamage) in the NRT formula
*
*
*
c Aluminium
c ----------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
c
  13    CMD(1) = 0.544725  ! = 8.07 / (0.8/(2*Ed=0.027keV))
        CMD(2) =-0.17      ! = 0.83-1.
        CMD(3) = 0.0
        CMD(4) = 0.0
        CMD(5) = 20.0      !
        Ecrit  = 20.0      !  wenn hier 40 eV ist die bereinstimmung
*                               mit Reaktoren Daten ist schlimmer                
        EdMD   = 27.0e-06
        return
c
c Titanium
c --------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
c
  22    CMD(1) = 0.601
        CMD(2) =-0.2    
        CMD(3) = 0.0
        CMD(4) = 0.0
        CMD(5) = 20.0      !
        Ecrit  = 20.0      !
        EdMD   = 40.0e-06
        return
c
c Vanadium
c --------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
c
  23    CMD(1) = 0.40247
        CMD(2) = -0.30720
        CMD(3) = 3.0751E-03
        CMD(4) = 5.1707923e-03
        CMD(5) =    20.00
        Ecrit  =    30.00
        EdMD   = 40.0e-06
        return
c
c Eisen und Chrom
c ----------------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
*
* Voertler
*
 2601   CMD(1) = 4.6/10.
        CMD(2) = 0.71-1.
        CMD(3) = 0.0
        CMD(4) = 0.0
        CMD(5) = 20.0      !
        Ecrit  = 40.0      !  Ecrit.ne.CMD(5)
        EdMD   = 40.0e-06
        return
*
* Stoller
*
 2602   CMD(1) = 0.5608
        CMD(2) =-0.3029
        CMD(3) = 3.227e-03
        CMD(4) = 0.0
        CMD(5) = 40.0
        Ecrit  = 40.0
        EdMD   = 40.0e-06
        return
c
c Nickel
c ------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
c
  28    CMD(1) = 4.37/10.
        CMD(2) = 0.74-1.
        CMD(3) = 0.0
        CMD(4) = 0.0
        CMD(5) = 30.0      !
        Ecrit  = 40.0      !  Ecrit.ne.CMD(5)
        EdMD   = 40.0e-06
        return
c
c Copper
c ------
c
  29    CMD(1) = 0.7066
        CMD(2) =-0.437
        CMD(3) = 2.28E-03 
cccc        CMD(4) = 0.451
        CMD(4) = 0.45277
        CMD(5) = 20.00
        Ecrit  = 20.00
        EdMD   = 30.0e-06
        return
c
c Zirconium
c ---------
c
  40    CMD(1) =  0.39277
        CMD(2) = -0.61669
        CMD(3) =  7.7334E-03
        CMD(4) =  0.22
        CMD(5) =  25.
        Ecrit  =  25.
        EdMD   = 40.0e-06
        return
c
c Tungsten
c --------
c
  74    CMD(1) = 1.0184
        CMD(2) =-0.667
        CMD(3) = 5.06E-03
        CMD(4) = 1.0
        CMD(5) = 31.02
        Ecrit  = 31.02
        EdMD   = 90.0e-06
        return
*
*
*
99999   Print 1,IZ0
        Write(33,1)IZ0 
    1   Format(/' Parameters for calculation of efficiency',
     #  ' of defect production '/'           according to MD',
     #  ' are ABSENT for Z=',i3,'  !!!'/20x,'Check Subr. MDPARAM !'/)
        Print *,'Chiao !'
        Print *,'                      press any key...'
        pause
        stop
        end
