*
************************************************************************
*
        Subroutine PRECALCULATION
*       -------------------------
        parameter (maxc=21,maxc1=22,maxe=50001)
        implicit real*8(A-H,O-Z)
        Character INPNAM_XS*500, INPNAM_DEDX*500, OUTNAM*500
        Character CTASK_NAME*80, C50*500, cformat*500
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/PKA/ALPHA2(MAXC1,MAXC),E0(MAXC1,MAXC)
        COMMON/NRT1/ANRT(MAXC1),BNRT(MAXC1),GNRT(MAXC1)
        Common/Edmin/Edmin 
        Common/PARAM01/IDSDT
        Common/FILENAMES/INPNAM_XS(MAXC1,MAXC),INPNAM_DEDX(MAXC1),
     #  OUTNAM
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
        Common/DATATAB1/WTAB(101),ROTAB(101),RITAB(101),IATAB(101)
        Common/ISTOP/ISTOP
        Common/VENUS/RI(MAXC)
        Common/EARTH/CTASK_NAME,C50
        Common/AUX1/rlambdaft12,rmft12,qft12
        Common/SATURN/TcritLAB(MAXC1)
        Common/EIN/EIN(MAXE),NH(MAXE),KEIN
        Common/events_printing/ieveprint
        Common/Sep0717/i_ecrit_input
        Common/Sep1317/inordlund
        Common/URANUS/carc,barc,MDarc
        Dimension TmpEn(MAXE)
*
                            AVO=6.022E+23     ! Avogadro
        IZ1=idint(Z1+0.001)
*
* Get masses, density and <I> 
        Call DATATAB
* 
* Get projectile A, if absent
        If(A1.le.0.0) then 
                      A1=WTAB(IZ1)
                      endif
                      If(A1.le.0.0) Call error0(' A1 ',000)
                      IA1=idint(A1+0.001) 
* 
* Get A for material components, if absent
        do i=1,nk
        If(AT(i).le.0.0) then 
                      IZT=idint(ZT(i)+0.001)              
                      AT(i)=WTAB(IZT)
                      endif
                      If(AT(i).le.0.0) Call error0(' AT ',i)
        enddo
*
* Density
        if(RO.le.0.0) then
                      IZT=idint(ZT(NK)+0.001)  ! check for NK=1 in sub read_inp
                      RO=ROTAB(IZT) 
                      endif
                      If(RO.le.0.0) Call error0(' RO ',NK)
* 
* Mean ionization potential for SPAR calculation, if chosen
        if(istop.eq.1) then
        do i=1,nk
        IZT=idint(ZT(i)+0.001)              
        RI(i)=RITAB(IZT)*1.E-6  ! eV --> MeV (SPAR)
        If(RI(i).le.0.0) Call error0(' RI ',i)
        enddo
                       endif
*
*
* Normalize fractions on unity
           sum=0.0
           do i=1,nk
           sum=sum+FR(i)
           enddo
           Do i=1,nk
           FR(I)=FR(I)/SUM
           Enddo
*
* Get effective Z and A
           Z2=0.0
           A2=0.0
        Do i=1,nk
        Z2=Z2+FR(I)*ZT(I)
        A2=A2+FR(I)*AT(I)
        Enddo
           AW=A2
*
* Atoms (molecules)
        RN0=AVO*RO/AW     ! at/cm3
        DA=(1./RN0)**0.33333333  ! ave dist betw at (not used)
*
* Min ED for the composite material
* ! Edmin is not minimal displacement energy
        Edmin=1.E+10
        do i=1,nk
        If(ED(i).lt.Edmin) Edmin=ED(i)
        enddo
*
* omit input energies < Edmin
        ke=0        
        Do i=1,KEIN
        If(EIN(i).ge.Edmin) then
        ke=ke+1
        TmpEn(ke)=EIN(i)
                            endif
        Enddo
        Do i=1,ke
        EIN(i)=TmpEn(i)
        Enddo
        KEIN=KE
*
        NK1=NK+1
* 
* NRT coefficients for effective material Z,A
        Do IK=1,NK1
         If(IK.eq.1) then
                     Z111=Z1
                     A111=A1
                     endif
         If(IK.ne.1) then
                     Z111=ZT(IK-1)
                     A111=AT(IK-1)
                     endif
        Call NRT_COEFF(Z111,Z2,A111,A2,ATRN,BTRN,GTRN)
        ANRT(IK)=ATRN
        BNRT(IK)=BTRN
        GNRT(IK)=GTRN
        Enddo
*
* For joint BCA-MD calculations define "critical" energy for each ion
       If(MD.eq.1) Call CRITICAL_ENERGY
*
*
* Data for Lindhard F(x) function
* -------------------------------
          PI=3.1415926
          EL=4.8E-10        ! electron charge
          A0=0.52918E-08    ! cm
*
* IK =1, 2...  1 = projectile, other material component
* MK =1, 2...    = material component
*
*
         DO IK=1,NK1
         If(IK.eq.1) then
                     Z111=Z1
                     A111=A1
                     endif
         If(IK.ne.1) then
                     Z111=ZT(IK-1)
                     A111=AT(IK-1)
                     endif
         DO MK=1,NK
         Z222=ZT(MK) 
         A222=AT(MK) 
c
* LNS:
          AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )
     #         /DSQRT(Z111**0.6666666+Z222**0.6666666)
* Firsov
          If(IDSDT.ne.0) 
     #    AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )
     #         /(   ( DSQRT(Z111)+DSQRT(Z222) )**0.666666666   )
*
*
          E0(IK,MK)=Z111*Z222*(EL**2)*(A111+A222)/(AA*A222)
            E0(IK,MK)=E0(IK,MK)/1.6E-06    !  erg ---> MeV
          ALPHA2(IK,MK)=4.*A111*A222/((A111+A222)**2)
          PIA2=Pi*(AA**2)            
          ENDDO 
          ENDDO 
*
*********************************************************************
* open main output file and write basic information 
*
        open(33,file=OUTNAM)
        Write(33,*)' I O T A   C O D E'
        Write(33,'(a80)')CTASK_NAME
        Write(33,*)' '
*
        Write(33,1000)IZ1,A1
 1000   Format(1x,'Primary ion (Z,A)',i3,f8.2) 
        Write(33,1001)
 1001   Format(' Material      at %    Ed (eV)')
        Do IK=1,NK
        IZ=Idint(ZT(IK)+0.0001)
        FR0=FR(IK)*100.
        Write(33,1002)IZ,AT(ik),FR0,ED(IK)*1.e+06
 1002   Format(i3,f8.2,f9.2,f9.1)
        Enddo
        If(IDSDT.eq.0) Write(33,1003)rlambdaft12,rmft12,qft12
 1003   Format(' F(t1/2) function: LNS   L=',f6.3,
     #  '  m=',f6.3,'  q=',f6.3)
        If(IDSDT.ne.0) Write(33,1004)
 1004   Format(' F(t1/2) function: Burenkov et al')
*

        If(MD==0) goto 8000
*
* MD and arc-dpa
*
         If(MDarc==0)                                        Then ! 1)
* MD
          Write(33,'(/t27,a)')'Joint BCA-MD simulation'
                                                 Call LetzteZ(C50,ic50) 
          Write(33,'(2a)')' Parameterized MD results : ',C50(1:ic50)

          If(i_ecrit_input==1) then
          Write(33,'(a,f7.2,2a)')
     c   ' MD results are used below eMD energy (Ecrit) =',ECRIT,' keV',
     c   ' (from input)'
                               else
          Write(33,'(a,f7.2,a)')
     c   ' MD results are used below eMD energy (Ecrit) =',ECRIT,' keV'
                               endif
                                                            Else  ! 1)
* arc-dpa
          Write(33,'(/t27,a)')'BCA + arc-dpa simulation'
          If(inordlund==0) then
           Write(33,'(a,t32,a,f8.5,a,f9.5,a)')
     c      ' arc-dpa : systematics','( Carc=',carc,' Barc=',barc,' )'
                           else 
           Write(33,'(a,t32,a,f8.5,a,f9.5,a)')
     c      ' arc-dpa : Nordlund','( Carc=',carc,' Barc=',barc,' )'
                           endif 
          If(i_ecrit_input==1) then
          Write(33,'(a,f7.2,a)')
     c   ' arc-dpa model is used below eMD energy (Ecrit) =',ECRIT,
     c  ' keV (from input)'
                               else
          Write(33,'(a,f7.2,a)')
     c   ' arc-dpa model is used below eMD energy (Ecrit) =',ECRIT,
     c  ' keV'
                               endif
                                                            Endif ! 1)
*
       if(TcritLAB(1)*1000..lt.1.e+3)                          then
        Write(33,7021)TcritLAB(1)*1000.,TcritLAB(2)*1000.
7021    Format(' Corresponding projectile energy =',f7.2,' keV, target i
     con energy =',f7.2,' keV')
                                                               else
        Write(33,7022)TcritLAB(1)*1000.,TcritLAB(2)*1000.
7022    Format(' Corresponding projectile energy =',g12.5,' keV, target 
     cion energy =',f7.2,' keV')
                                                              endif

        If(TcritLAB(1).ge.100.) Write(33,7023)TcritLAB(1)
7023    Format(70('*')/'*         Energy Tcrit =',g12.5,' MeV',
     #  ' is not realistic',T70,'*'/70('*'))
*
        If(MDarc==0)                                         Then ! 2)
             Write(33,703)(CMD(i),i=1,3)
703          Format(' efficiency(MD)=',f7.4,'*( eMD**(',f8.4,') ) +',
     #       1pe10.3,'*eMD')
             Write(33,704)CMD(4),CMD(5)
704          Format(' constant efficiency(MD) below',f7.3,
     c' keV and above',f7.2,' keV'/)
                                                             Else ! 2)
      Write(33,'(2a/)')' efficiency(arc)=(1.-Carc)*',
     c  ' { [( 0.8d0/(2.*Ed(keV)) ) *Tdam]**Barc }+Carc'
                                                             Endif ! 2)

 8000   If(istop.eq.-1) Write(33,*)' Stopping power: Ziegler, SRIM'
        If(istop.eq. 1) Write(33,*)' Stopping power: Armstrong, SPAR'
*
*
          Write(33,1005)RO,RN0
 1005     Format(' Density =',f8.4,' g/cm3    n0=',1pe12.5,' 1/cm3')
          Write(33,1006)Z2,A2
 1006     Format(' Z(eff) =',f6.2,'    A(eff)=',f7.2)
          Write(33,1007)
 1007     Format(' Note. Nuclear nonelastic interactions ',
     #    'are not considered here')
*
* Write general information in "events" file
        If(ieveprint/=0) then
                              open(99,file='events')
                         else
                              open(99,status='scratch')
                         endif
        Write(99,*)' RECORDS OF SUCCESFUL INRTERACTIONS RESULTING',
     #  ' IN ATOM DISPLACEMENTS'
        Write(99,*)' '
        Write(99,'(a80)')CTASK_NAME
        Write(99,*)' '
        Write(99,1000)IZ1,A1
        Write(99,1008)
 1008   Format(4x,' Material      at %    Ed (eV)')
        Do IK=1,NK
        Write(99,1009)IK,Idint(ZT(IK)+0.0001),AT(ik), FR(IK)*100.,
     #                ED(IK)*1.e+06
 1009   Format(i2,')',i4,f8.2,f9.2,f9.1)
        Write(99,*)' '
        Enddo
        Return
        End 
