*
*
************************************************************************
*
        Subroutine READ_INPUT(Cinp)
*       ---------------------
* + write general information in output file
c
        parameter (maxc=21,maxc1=22,maxe=50001)
        implicit real*8(A-H,O-Z)
        Character CTASK_NAME*80, cgnu*1
        Character INPNAM_XS*500, INPNAM_DEDX*500, OUTNAM*500,OUTNAM2*500
        Character*500 OUTNAM3, MDNAME, ctmp
        Character NF(MAXC)*500,  C50*500, C80*80, Cinp*500, CLine*500
        Common/FILENAMES/INPNAM_XS(MAXC1,MAXC),INPNAM_DEDX(MAXC1),
     #  OUTNAM
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/EIN/EIN(MAXE),NH(MAXE),KEIN
        Common/OPTIONS1/igraph0,maxplay
        Common/CUT1/rmaxpl,itot,icut
        Common/PARAM01/IDSDT
        Common/MERCURY/CMD(5),Ecrit,EdMD,MD
        Common/ISTOP/ISTOP
        Common/EARTH/CTASK_NAME,C50
        Common/SATURN/TcritLAB(MAXC1)
        Common/EIN2/XXX(maxe),YYY(maxe),ZZZ(maxe),COSX(maxe),COSY(maxe),
     $              COSZ(maxe)
        Common/keytpka/keytpka
        Common/Tlim0/Tlim
        Common/events_printing/ieveprint
        Common/parpar/par_st1,par_st2
        Common/Sep0717/i_ecrit_input
        Common/URANUS/carc,barc,MDarc
        Common/Sep1317/inordlund
        Common/Sep2117/alphaS,PartMD
        Common/Sep2217/IDSDToriginal
*
        Open(333,file='inform.txt')    
c
* Input file
        open(1,file=Cinp,status='old',err=90002)
c
* now CTASK_NAME is not used
        CTASK_NAME=' '
                                                Call Letztez(Cinp,icinp)
        Write(333,2900)Cinp(1:icinp)
c
*
* 1. Read
*    ----
c
c find line with graph printing option and maxplay
        call star(1)
c dS/dT
c IDSDT=0, 10(=0), 11-15 LNS expression; 
c      =1                Burenkov et al
c
c Tlim maximal energy for SL_LNS code
c
*    ieveprint =0 : "events" file will not be printed
*
        read(1,'(a)')CLine;          Call Delete_exlamation_point(Cline)
                                            Call gnu_comment(Cline,cgnu)
*
* par_st1, par_st2 define the accuracy of calculations in Subr. Model
*  in alter Version par_st1=0.1, par_st2=0.05
*
* old algorithm keytpka=-1, new =+1, if =0 (default) =new algorithm (+1)
*
        Call GetInputValues1(CLine,
     c                       IDSDT,par_st1,par_st2,ieveprint,keytpka)
 
                                                    IDSDToriginal=IDSDT
*
* now igraph0 is fixed
        igraph0=1
*
c
c MAXPLAY: maximal number of attempts to get the recoil energy by
c MC "exception " method  for recoil spectra simulation
c          < 0 old and slow algorithm is used. It is the same as
c              for AMXPLAY > 0 described in Manual, Aug 2004
c          > 0 or =0 new fast algorithm  
*
* July 2017: MAXPLAY is fixed
        maxplay=500000
*
*
          if(keytpka==-1)               then
          maxplay=-maxplay
          rmaxpl=-dfloat(maxplay) 
                                        else
c new algorithm (fast)
          rmaxpl= dfloat(maxplay) 
                                        endif
c
c now Tlim is fixed (if you want increase it change also other
c                    instructions in other Subroutines
        Tlim=5200.
*
        Write(333,3000)IDSDToriginal,Tlim,par_st1,par_st2,ieveprint,
     c                                               keytpka, maxplay
c
c Define f(t^1/2) function parametrs 
        Call FT12CHOICE(IDSDT)
c
c
        If(IDSDT.ne.0.and.IDSDT.ne.1) then
        Print *,'           E R R O R  in INPUT file       '
        Print *,'  IDSDT parameter is incorrect'
        Print *,'                          press any key...'
        pause
        stop
        endif
*
*
* 2. Read
*    ----
c
c find line with Z1, A1 of projectile and file for stopping power
*                                   if Ziegler, SRIM data will be used
        call star(1)
        read(1,'(a)')CLine
                                     Call Delete_exlamation_point(Cline)
                                          If(iwords(CLine)<2) goto 90004
* Now if the file with stopping power exists =Ziegler,
*  if absent = SPAR
*
        If(iwords(CLine)==3) then
* Ziegler
        Call Lesen_ein_Wort(CLine,3,INPNAM_DEDX(1),ice)
        istop=-1
                             else
* SPAR  
        istop=1
                             endif
*
        read(Cline,*,err=9929)Z1,A1
*
*
* 3. Read
*    ----
c
c find line with RO (density of the material), number of material components
c and name of MD results, if they will be applied
        call star(1)
        read(1,'(a)')CLine
                                     Call Delete_exlamation_point(Cline)
                                          If(iwords(CLine)<2) goto 90007
        read(Cline,*,err=90005)RO, NK
c
        If(NK.gt.MAXC) then 
        Print *,'Number of components > ',MAXC,' !'
        print *,'                       press any key...'
        pause; stop
        endif
c
c 
        If(RO.le.0. .and. NK.ne.1) then
        Print *,' '
        Print *,
     #  '      NO  default density for compounds !!!'
        print *,'                           press any key...'
        pause; stop
        endif
*
* if there is more than 2 entries here, they are interpreted
*  as information about MD calculations
       if(iwords(Cline) >=3)                                     THEN

        MD=1
        Call Lesen_ein_Wort(CLine,3,MDname,imdn)
                                                        carc=0.;barc=0.0
                                           MDarc=0
        If(MDname=='arc-dpa'.or.MDname=='arc'.or.MDname=='arcdpa')
     c                                     MDarc=1
*
* alphaS is used in Subr. Smoothtransition
cccc    PartMD=dexp( -(1.-alphaS)/alphaS )
* 3 %
        PartMD= 3. *0.01
        alphaS=1.d0/(1.d0-dlog(PartMD))

                                                 i_ecrit_input=0 
        if(iwords(Cline) >= 4)  then
           Call Lesen_ein_Wort(CLine,4,CTMP,ictmp)
           Read(CTMP,*,end=90008,err=90008)Ecrit_input 
                                                 i_ecrit_input=1
           If(Ecrit_input<=0.0) i_ecrit_input=0 
                                endif 

* Part of MD (or arc-dpa) processes at T=Tcrit
        if(iwords(Cline) >= 5)  then
           Call Lesen_ein_Wort(CLine,5,CTMP,ictmp)
           Read(CTMP,*,end=90009,err=90009)PartMD  ! percent

        PartMD=0.01d0 *PartMD
            if(PartMD > 1.0d0) PartMD= 1.0d0
            if(PartMD <= 0.0d0) PartMD= 0.0d0

        if(PartMD/=0.0d0) alphaS=1.d0/(1.d0-dlog(PartMD))
                                endif 
*
        Call Print_auxiliary_information_about_alphaS_PartMD
     c                                             (MDarc,alphaS,PartMD) 

                                                                 ELSE
        MD=0
            Do itcritlab=1,maxc1
            TcritLAB(itcritlab)=-1.E+6
            Enddo
                                                                 ENDIF
        If(MD.ne.0 .and. NK.ne.1) then
        Print *,
     #  'Joint BCA-MD calculations are not tested for compounds yet !'
        Print *,
     #  '  (!!!)  See comments *noalloy in Subr MODEL and READ_INP'
        print *,'                        press any key...'
        pause; stop
        endif
*
*
* 5.(or more) Read
*             ----
c
c find lines with the description of material componets
        Do IK=1,NK
        call star(1)
        read(1,'(a)')CLine
                                     Call Delete_exlamation_point(Cline)
                                          If(iwords(CLine)<4) goto 90006
        read(Cline,*,err=90000)ZZ,AA, FR0, ED0
* default Ed (Ed=0) without MD
                       If(MD==0.and.ED0<=0.0) ED0=40.0  ! default = 40 eV

        If(iwords(CLine)==4.and.istop==-1.or.
     c     iwords(CLine)==5.and.istop==+1)       then
       Print *,' '
       Print *,
     c ' In this version is not possible to mix Ziegler and SPAR data !'
       print *,'                           press any key...'
       pause
       stop;                                    endif
*
        if(iwords(CLine)==5) 
     c     Call Lesen_ein_Wort(CLine,5,INPNAM_DEDX(IK+1),ice)

        IZ=idint(ZZ+0.001)
*
*
*
* Parameters for MD efficiency from Subr. MDPARAM orc arc-dpa parameters
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*noalloy
        If(MD.eq.1)                                            Then ! 1)
          If(MDarc==0)                                 THen ! 2)
* MD results
* ----------
                          Call MDPARAM(IZ,MDname,C50)
                                                       ELse ! 2)
*
* arc-dpa
* -------
        Call arc_parameters(IZ,ECRIT,Edarc,inordlund)
        EdMD=Edarc*1.e-6

                                                       ENdif ! 2)

        Call Print_auxiliary_information_about_Ed(ED0,EdMD)

        ED0=EdMD*1.e+6
*
* redefine ECRIT, if available in input
        If(i_ecrit_input==1) ECRIT=Ecrit_input
                                                               Endif ! 1)
*
*
        ZT(IK)=ZZ
        AT(IK)=AA
        FR(IK)=FR0
        ED(IK)=ED0 * 1.e-06    ! eV --> MeV
c
*
*
        Enddo ! Do IK=1,NK
       
*
* 6.(or more) Read
*             ----
*
* Output file name
*
        call star(1)
        read(1,'(a)')CLine
                                     Call Delete_exlamation_point(Cline)
        Call Output_filenames(Cline,OUTNAM,OUTNAM2,OUTNAM3)
*
*
*
*
*Feb1207
* initialize the position
        Do ie=1,maxe 
        XXX(ie)=0.0
        YYY(ie)=0.0
        ZZZ(ie)=0.0
        COSX(ie)=0.0
        COSY(ie)=0.0
        COSZ(ie)=1.0
        Enddo
*
*
* Read
* ----
*
*
* Lines with energies, MC events (and position)
*
        ir=0; KEIN=0
        Do 7777 while (.not.eof(1))
                                  call star(1)
*
        read(1,'(a)')CLine;          Call Delete_exlamation_point(Cline)
*
        If(iwords(Cline)==8)                             Then
        Call Read_E_HIST_POS(ir,X0,Y0,Z0,COSX0,COSY0,COSZ0,iestop)
                        XXX(ir)=X0
                        YYY(ir)=Y0
                        ZZZ(ir)=Z0
                        COSX(ir)=COSX0
                        COSY(ir)=COSY0
                        COSZ(ir)=COSZ0
                                                         Else
        Call Energies_and_number_MC_events(Cline,ir,iestop)
                                                         Endif
*
                                                if(iestop==1) goto 8000

 7777   Continue  !  Do 7777 while (.not.eof(1))

 8000   Close(1)
        If(KEIN==0) goto 90012
        
        Do ir=1,KEIN;   If(TLIM.lt.EIN(ir)) goto 90011;  Enddo 
     
        Write(333,'(/a)')' Input energies and MC numbers'
        do ir=1,KEIN
        Write(333,'(1pg16.8,i8)')EIN(ir),NH(ir);enddo
        Write(333,*)
*
*
****************************************************************************
* open part of output files (units 44,55)
* (main output file is open in subr precalculation)
*
        open(44,file=OUTNAM2)
        open(55,file=OUTNAM3)
                                              Call LetzteZ(OUTNAM,ioutn)
        Write(44,2000)cgnu,OUTNAM(1:ioutn),cgnu
 2000   Format(a,' See explanation of (1), (2),...',
     #  ' in main output file:  "',a,'"'/a)
*
        If(NK==1)                                       then   ! 1)
          If(MDarc==0)                       then
        Write(44,2002)cgnu,cgnu
 2002   Format(a,
     #  ' E(MeV)        (1)       (2)',
     #  '       (3)       (4)       (5)       (6)          (7)',
     c'       (8)=Tdamage (keV)'/a,106('-'))

        Write(55,2003)cgnu,cgnu,cgnu,cgnu,cgnu,cgnu,cgnu
 2003   Format(a,' Efficiency (4)/(1)= N(direct counting)/N(NRT), i.e. = 
     c "(4)"/"(1)", see first output file'/a/a/a/
     ca,'              (4)/(1)      (4)           (1)        (8)'/
     ca,'  T0(MeV)   Efficiency  N(dir.count.)   N(NRT)    Tdamage(keV)',
     c/a,64('-'))
                                             else
        Write(44,20021)cgnu,cgnu
20021   Format(a,
     #  ' E(MeV)        (1)       (2)',
     #  '       (3)       (4)       (5)       (6)          (7)',
     c'       (8)=Tdamage (keV)   (9)=arc-dpa'/a,121('-'))

        Write(55,20031)cgnu,cgnu,cgnu,cgnu,cgnu,cgnu,cgnu
20031   Format(a,' Efficiency (4)/(1)= N(direct counting)/N(NRT), i.e. = 
     c "(4)"/"(1)", see first output file'/a/a,' Efficiency (9)/(1)= arc
     c-dpa formula/N(NRT), i.e. = "(9)"/"(1)", ibidem'/a/
     ca,'              (4)/(1)      (4)           (1)        (8)',
     c'          (9)/(1)        (9)'/
     ca,'  T0(MeV)   Efficiency  N(dir.count.)   N(NRT)    Tdamage(keV)',
     c'  Efficiency    arc-dpa'/a,87('-'))
                                             endif 
                                                        else   ! 1)
        Write(44,20022)cgnu,cgnu
20022   Format(a,
     #  ' E(MeV)        (1)       (2)',
     #  '       (3)       (4)       (5)       (6)          (7)',
     c/a,88('-'))
        Write(55,20032)cgnu,cgnu,cgnu,cgnu,cgnu,cgnu,cgnu
20032   Format(a,' Efficiency (4)/(1)= N(direct counting)/N(NRT), i.e. = 
     c "(4)"/"(1)", see first output file'/a/a/a/
     ca,'              (4)/(1)      (4)           (1)'/
     ca,'  T0(MeV)   Efficiency  N(dir.count.)   N(NRT)',
     c/a,50('-'))
                                                        endif  ! 1)
*
*        
*
        Print *,' Wait a bit...'
        Return
*
 2900 Format('  input file = "',a,'"')
 3000 Format('  input data'/'       IDSDT =',i2/'        Tlim =',f8.1/
     c'     par_st1 =',g12.5/'     par_st2 =',g12.5/  
     c'   ieveprint =',i5/'     keytpka =',i5/'     maxplay =',i9)
 9919   Call error0(' MD ',9919)
 9929   Call error0('Z,A ',9929)
90000   print 90001
90001   Format(/'  E R R O R  in input file INPUT !!!'
     #  /'  Possible reason:  dE/dx model chosen is inconsistent ',
     #  /'                    with the file names introduced in INPUT'  
     #  /'  Note:   SPAR option - names should be omitted'
     #  /'          SRIM option - names should be given')
        print *,'                              press any key...'
        pause;   stop
90002   print 90003,Cinp(1:70)
90003   Format(/' The following input file is ABSENT:'/a70/'!!!'/)
        print *,'                              press any key...'
        pause;  stop
90004   call error0('badr',90004)
90005   call error0('badr',90005)
90006   call error0('badr',90006)
90007   call error0('badr',90007)
90008   Print *,' Error by reading of Ecrit energy !'
        call error0('badr',90008)
90009   Print *,' Error by reading of PartMD (%) !'
        call error0('badr',90009)
90011   Print *,'           E R R O R  in INPUT file      '
        Print *,'Input energy  ',EIN(ir),'  > TLIM ! '
        Print *,'                      press any key...'
        pause; stop
90012   Print *,'           E R R O R  in INPUT file      '
        Print *,' Initial energie(s) is/(are) not enetered !'
        Print *,'                      press any key...'
        pause; stop
        End
