*
* July 2017
*
* Previously this code should be run before IOTA code with the same
* input. Now it is the part of IOTA
*
* It prepares the cross-sections for the transferring of the 
* energy T to PKA and other data 
*  
* Ver *Jan04
*
* Pay attention ! Zeff, Aeff here are equal to Z2,A2 in main IOTA code
*
* Atom concentration is defined for the fractions normalized to unity.
* (see AW=)
* 
*
*  OUTPUT DATA:
*  1 col: energy
*  2 col: N0 * ( Int[Ed to Tmax] nu(T)sig(T)dt )  (units: 1/cm)
*         cascade function Nu(T) is calculated for effective Z,A
*         of the composite target material, nu(T) includes 0.8/2Ed 
*
*  3 col: N0 * ( Int[ 0 to Tmax]   T* sig(T)dt )  (units: MeV/cm)
*  4 col: N0 * ( Int[ 0 to Ed  ]   T* sig(T)dt )  (units: MeV/cm)
*  5 col: N0 * ( Int[Ed to Tmax]   T* sig(T)dt )  (units: MeV/cm)
*  6 col:      ( Int[Ed to Tmax]      sig(T)dt )  (units: barn  )

c
c Double precision !
c
        Subroutine SL_LNS5
        parameter (maxc=21,maxc1=22)
        IMPLICIT REAL*8(A-H,O-Z)
        Character INPNAM_XS*500, INPNAM_DEDX*500, OUTNAM*500
        REAL*8 NAIGUS
        EXTERNAL F,FTRN, CS
        Common/FILENAMES/INPNAM_XS(MAXC1,MAXC),INPNAM_DEDX(MAXC1),
     c  OUTNAM
        Common/BasicSL/Z1,A1,Z2,A2,AW,RO,RN0
        Common/ZAEFFSL/Zeff,Aeff
        Common/ZAINISL/Zini,Aini
        Common/Z2A2SL/ZT(MAXC),AT(MAXC),FR(MAXC),ED0(MAXC),NK
C
        COMMON/NRT1SL/ATRN,BTRN,GTRN
        COMMON/NRT2SL/COEFF
        COMMON/ED1SL/ED
        Common/Tlim0/Tlim
        Common/PARAM01SL/IDSDT
        Common/AUX1SL/rlambdaft12,rmft12,qft12
        DIMENSION TARRAY(1499)
c          
c======================================================================
*
* define initial energies
          CALL T0_DEFINITION(TARRAY,NTAR)  
*
          ACCUR=0.01
          MAXN=15
C
c======================================================================
          NK1=NK+1
c
*
* IK =1, 2...  1 = projectile, other material component
* MK =1, 2...    = material component
*
cycle for primary ion
          Do 8888 IK=1,NK1
          If(IK.eq.1) then
                      Z1=Zini
                      A1=Aini
                      endif
          If(IK.ne.1) then
                      Z1=ZT(IK-1)
                      A1=AT(IK-1)
*Mar24
* Omit this calculation Z,A materials = Z,A projectile.Data are alredy
* prepared
cccc2017          If(  dabs(Z1-Zini).lt.0.001d0 
cccc2017     *   .and. dabs(A1-Aini).lt.0.001d0) goto 8888 
                      endif
cycle for PKA
          Do MK=1,NK 
                      Z2=ZT(MK)
                      A2=AT(MK)
* pay attention !  Z2,A2 is PKA moving in Zeff,Aeff material 
          CALL NRT_COEFF(Z2,Zeff,A2,Aeff,ATRN,BTRN,GTRN)  
C
          ED=ED0(MK)
C
          PI=3.1415926
c
c
          EL=4.8E-10        ! electron charge
          A0=0.52918E-08    ! cm
          DA=(1./RN0)**0.33333333  ! dist between atoms
* LNS:
          AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )
     #         /SQRT(Z1**0.6666666+Z2**0.6666666)
* Firsov
          If(IDSDT.ne.0) 
     #    AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )
     #         /(   ( SQRT(Z1)+SQRT(Z2) )**0.666666666   )
*
*
          E0=Z1*Z2*(EL**2)*(A1+A2)/(AA*A2)
            E0=E0/1.6E-06    !  erg ---> MeV
          ALPHA2=4.*A1*A2/((A1+A2)**2)
          PIA2=Pi*(AA**2)            
*
* output file name
          Call Define_Filename_for_SL_LNS(Z1,A1,Z2,A2,INPNAM_XS(IK,MK))

         open(900,file=INPNAM_XS(IK,MK),status='new',err=1)
                                                             goto 100 
* File exists, but it can contain not all energies up to Tlim
* (it happens, when the code was interrupted before)
    1    open(900,file=INPNAM_XS(IK,MK))
         Call Check_Tlim(Tlim,keyOK)
                                     if(keyOK==1) goto 8000
         rewind 900
*
  100    Write(900,111)Z1,A1,Z2,A2,Zeff,Aeff
         Write(900,222)
         If(IDSDT.eq.0) Write(900,223)rlambdaft12,rmft12,qft12
         If(IDSDT.ne.0) Write(900,224)
c
c
          Print *,' '
          If(IDSDT.eq.0) Print *,'            LNS F(t1/2) function'
          If(IDSDT.ne.0) Print *,'            Burenkov F(t1/2) function'
*
          Print *,' '
          Print 333,Z1,A1,Z2,A2
333       Format(' INTERACTION  ',2f6.1,' +',2f6.1,'    energies:')
*
                                                     i2i2=0
          DO 7777 III=1,NTAR
c
          T0=TARRAY(III)
          If(T0.gt.Tlim) goto 8500
*
          If(T0.le.0.1) Print 443
443       Format(\'.')
*
          If(T0.gt.0.1) then
          if(i2i2.eq.0) then
                        print *,' '
                        print *,'low energies were treated.'
                        endif
          i2i2=1
          Print 444,T0
444       Format(1pg10.2\)
          endif
C
          EPS= T0/E0
C
          Tmax=ALPHA2*T0
C
          COEFF=ALPHA2*E0/EPS
*
            XminNRT= DSQRT( EPS*ED /(ALPHA2*E0) )
            XminT  = DSQRT( 0.0d0 /(ALPHA2*E0) )
            Xmax= DSQRT( EPS*Tmax/(ALPHA2*E0) )
c
c
c int nu(T)dS/dt
                                DSDX=0.0
         If(XminNRT.lt.Xmax) then
           RES = NAIGUS(XminNRT,Xmax,FTRN,ACCUR,MAXN,IER)
           DSDX=RES*RN0 * PIA2* COEFF
         endif
c
c int TdS/dt from 0 to Tmax
                                DEDX_nuc_total=0.0
         If(XminT.lt.Xmax) then
           RES = NAIGUS(XminT,Xmax,F,ACCUR,MAXN,IER)
           DEDX_nuc_total=RES*RN0 * PIA2* COEFF
         endif
c
c int TdS/dt from 0 to Ed (or to Tmax, if it is less Ed)
                                DEDX_nuc_0_Ed=0.0
         If(0.0d+0.lt.XminNRT) then
           X10=0.0d+0
           X20=DMIN1( XminNRT, Xmax)
           RES = NAIGUS(X10,X20,F,ACCUR,MAXN,IER)
           DEDX_nuc_0_Ed=RES*RN0 * PIA2* COEFF
         endif
c
c int TdS/dt from Ed to Tmax
                                DEDX_nuc_Ed_Tmax=0.0
         If(XminNRT.lt.Xmax) then
           RES = NAIGUS(XminNRT,Xmax,F,ACCUR,MAXN,IER)
           DEDX_nuc_Ed_Tmax=RES*RN0 * PIA2* COEFF
         endif
c
c int dS/dt from Ed to Tmax (!!! cross-section integration)
c units: barn
                                CS_Ed_Tmax=0.0
         If(XminNRT.lt.Xmax) then
           RES = NAIGUS(XminNRT,Xmax,CS,ACCUR,MAXN,IER)
           CS_Ed_Tmax=RES* PIA2* COEFF *1.E+24  ! cm2--> barn
         endif
*
*  1 col: energy
*  2 col: N0 * ( Int[Ed to Tmax] nu(T)sig(T)dt )  (units: 1/cm)
*  3 col: N0 * ( Int[ 0 to Tmax]   T* sig(T)dt )  (units: MeV/cm)
*  4 col: N0 * ( Int[ 0 to Ed  ]   T* sig(T)dt )  (units: MeV/cm)
*  5 col: N0 * ( Int[Ed to Tmax]   T* sig(T)dt )  (units: MeV/cm)
*  6 col:      ( Int[Ed to Tmax]      sig(T)dt )  (units: barn  )
          Write(900,'(6g12.5)')T0,DSDX,DEDX_nuc_total,
     #    DEDX_nuc_0_Ed, DEDX_nuc_Ed_Tmax,  CS_Ed_Tmax
c
C
C This is nuclear stopping power
CCC         DTDX_Ziegler_units= DTDX/(RO*1000.)
C
7777     Continue !   DO 7777 III=1,NTAR
           goto 8500

*
8000                                  Call Letztez(INPNAM_XS(IK,MK),icc)
                 Write(333,8001)INPNAM_XS(IK,MK)(1:icc)
8001             Format(1x,' File ',a<icc>,' exists already! Check: OK')
8500     Close (900)
*
         Enddo ! Do MK=1,NK 
*
8888     Continue !  End of  Do IK=1,NK 
c
c
         Return

  111    Format(2f6.1,5x,2f6.1,'    Z1, A1 + Z2,A2  for Zeff,Aeff=',
     c   2f6.1,'      (7 lines:comments)')
  222    Format(' 1 col: energy'/
     *' 2 col: N0 * ( Int[Ed to Tmax] nu(T)sig(T)dt )  (units: 1/cm)'/
     *' 3 col: N0 * ( Int[ 0 to Tmax]   T* sig(T)dt )  (units: MeV/cm)'/
     *' 4 col: N0 * ( Int[ 0 to Ed  ]   T* sig(T)dt )  (units: MeV/cm)'/
     *' 5 col: N0 * ( Int[Ed to Tmax]   T* sig(T)dt )  (units: MeV/cm)'/
     *' 6 col:      ( Int[Ed to Tmax]   sig(T)dt    )  (units: barn  )')
  223   Format(' LNS  F(t1/2) FUNCTION IS USED.    Lambda=',f6.3,
     *  '  m=',f6.3,'  q=',f6.3)
  224    Format(' BURENKOV ET AL F(t1/2) FUNCTION IS USED  ')
         End
