*
* IOTA-2017
*
*
**************************************************************************
*
* IOTA code
* ---------
*
*
* Maximal number of the material component is 21. To increase this 
* value change parameter(maxc= to N desirable value in all routines
* and maxc1= to N+1
*
* Maximal energy = 5 GeV
*  
*
c
c 
c Watcom random number generator is used now. To use other one
c change function RANDOMG
c
*
* Last changes 05/04/2007
*
c
       PROGRAM IOTA 2017
       parameter (maxe=50001)
       implicit real*8(A-H,O-Z)
       Character Cinp*500
       Common/EIN/EIN(MAXE),NH(MAXE),KEIN
       COMMON/RECSTORE/ATOM(50003,9),NKO(50003),INDIC(50003),
     !                 KGEN(50003),NREC
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
c          
       Cinp=' ';call getarg(1,Cinp); if(Cinp==' ') Cinp='input'
        
c======================================================================
c
c
c
*
* read input data file
         CALL READ_INPUT(Cinp)
*
* prepare basic data for calculations
         CALL PRECALCULATION
*
*
         Call SL_LNS50
*
* read cross-sections and dE/dx
         CALL READ_DATA
*
* make interpolation between data points
         CALL INCREASE_DATA_ARRAY
*
* calculate dE/dx by SPAR routine
         CALL DEDX_SPAR
*
*
c
c========================================================================
c
* Cycle for energies
* ------------------
        Do IE=1,KEIN
        T00=EIN(IE)
        NHIST=NH(IE)
c
            If(T00.gt.5000.) then
            Print *,' T0 exceeds the allowable maximum. Change the code'
            Call error0('    ',5000)
            Endif
        Call WRITE99A(T00,IE,NHIST)
*
*
        Call INITIALIZE_AND_ZEROIZE(T00)
*       
* Cycle for events
* ----------------
        Do 7 IH=1,Nhist         
cccc
cccc For all display types
cccc        Print 1000,IH,T00
cccc 1000   Format('*************  history =',I10,'     E=',g12.5)
cccc
         write(*,'(a1, a,1pg12.5,a, 0pi8,$)') char(13),'  Energy ',T00,
     c   ' MeV      events', iH
 
*
        Call DISPERS(1)
* 
* Primary ion movement
*                    IDE corresponds to the energy of the primary
*                        particle which attenuates in material
        Call FIRST_ION
     $            (IK,IE,T00,T0,P0,P0X,P0Y,P0Z,X0,Y0,Z0,IDE,IGEN,IDION)
*
        Call MODEL(IK,T0,P0,P0X,P0Y,P0Z,X0,Y0,Z0,IDE,IGEN,IDION) 
        if(NREC.le.0) goto 6
* 
* Secondary recoils movement
   2    Call STORE_OUT(MK,T1,P1,P1X,P1Y,P1Z,X1,Y1,Z1,IDE,IGEN1,IDION1)
*
cc                                         if(nrec.lt.0.and.md.eq.0) then
cc                                         print *,'strange error'
cc                                         stop
cc                                         endif
        if(NREC.lt.0) goto 6
        IK=MK+1
        Call MODEL(IK,T1,P1,P1X,P1Y,P1Z,X1,Y1,Z1,IDE,IGEN1,IDION1) 
        if(NREC.le.0) goto 6
        goto 2
*
*
*
   6    Call DISPERS(2)
        Write(99,1001)Nhist-IH
   7    Continue  
        Write(*,*)
*
* Integration of nu(T)dS/dT along the trajectory
        Call  LindInt(T00) 
ccccc   Print *,'*****  Finished !'
*
        Call Print(T00,Nhist)
c            
        Enddo !   Do IE=1,KEIN
*
        Call end_of_calculation
                                                              close(333)
        Stop                  
 1001   Format('end of history, remained:',i7) 
        End
*
************************************************************************
*  
        Subroutine AFTER_INTERACTION(IK,LK,T,P0, P0X, P0Y, P0Z, TPVA,
     $                               PVA,PVAX,PVAY,PVAZ)
*       -------------------------------------------------------------
        parameter (maxc=21,maxc1=22)
        implicit real*8(A-H,O-Z)
        real*8 M0,M2
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/PKA/ALPHA2(MAXC1,MAXC),E0(MAXC1,MAXC)
* 
        T0=T
        T2=TPVA
                    M0=A1
        If(IK.ne.1) M0=AT(IK-1)
                    M2=AT(LK)
        T1=T0-T2
check
        if(T1.le.0.0) T1=1.e-10
        P2=dsqrt(2.*M2*T2)
        P1=dsqrt(2.*M0*T1)
        COSTETA=P0Z/P0
        SINTETA=GETSIN(COSTETA)
*
* angle for PKA in rotated c.s.
        COSAL=(P0**2+P2**2-P1**2)/(2.*P0*P2)
        SINAL=GETSIN(COSAL)
* angle for primary ion in rotated c.s.
        COSFI=(P1**2+P0**2-P2**2)/(2.*P1*P0)
        SINFI=GETSIN(COSFI)
*
* impulses in rotated c.s. 
*
        P0XS=0.
        P0YS=0.
        P0ZS=P0
*
        FI2=6.2831852*Randomg(0)
*
* px1',py1',pz1', etc
        P1XS=P1*SINFI*dcos(FI2)
        P1YS=P1*SINFI*DSIN(FI2)
        P1ZS=P1*COSFI
*
        P2XS=P0XS-P1XS
        P2YS=P0YS-P1YS
        P2ZS=P0ZS-P1ZS
ccccccheck
ccccc        PPP=dsqrt(P2ZS**2+P2XS**2+P2YS**2)  !
ccccc        Write(6,*)'Check 1:  ',PPP,P2      !
*
* transform to initial c.s.
        CALL TRANSFORM_ROTATE_TO_USUAL(P0X,P0Y,P0Z,P1XS,P1YS,P1ZS,
     $  P1X,P1Y,P1Z)
*
        P2X=P0X-P1X  
        P2Y=P0Y-P1Y  
        P2Z=P0Z-P1Z
ccccc        CALL TRANSFORM_ROTATE_TO_USUAL(P0X,P0Y,P0Z,P2XS,P2YS,P2ZS,
ccccc     $  P2X,P2Y,P2Z)
*
ccccccheck 2
cccccc       Write(6,*)'Check 2     '
cccccc       Write(6,*)P0X-P1X,P2X  !
cccccc       Write(6,*)P0Y-P1Y,P2Y  !
cccccc       Write(6,*)P0Z-P1Z,P2Z  !
cccccccheck 3
cccccc       Write(6,*)'Check 3 ---  '
cccccc       Write(6,*)dsqrt(P1X**2+P1Y**2+P1Z**2), P1 !
cccccc       Write(6,*)dsqrt(P2X**2+P2Y**2+P2Z**2), P2 !
*
*
       T=T1
       P0=P1
       P0X=P1X
       P0Y=P1Y
       P0Z=P1Z
*
       PVA=P2  
       PVAX=P2X
       PVAY=P2Y
       PVAZ=P2Z
       RETURN
       END
*
*
************************************************************************
*  
        Subroutine arc_parameters(IZ,ECRIT, Edarc,inordlund)
        implicit real*8(A-H,O-Z)
        Character*9999 CDataSystematics,CDataNordlund
        Common/URANUS/carc,barc,MDarc
        Dimension zR(101), carcR(101), barcR(101), edR(101)
*
* Global values
* =============
*
* Critical eMD energy (keV)
        Ecrit=40.
*
* The value for all materials, which are not presented below (gases).
*  It is the averaged value
         carc_GLOBAL=0.43 
*
* The value for all materials
         barc_GLOBAL=-0.82 
*
* The value for all materials, which are not presented below (gases).
*   Why 40? and not 25? See works for MgO und UO2
          Ed_GLOBAL=40.
*
                                                     Edarc=Ed_GLOBAL
                                                     carc=carc_GLOBAL
                                                     barc=barc_GLOBAL
                                                          inordlund=0
                 do i=1,101; zR(i)=-1.e9; carcR(i)=zr(i); barcR(i)=zR(i) 
                                                     edR(i)=zR(i); enddo
*
* Data from systematics,  Nucl. Energy and Technol., N4, 2017
*  (These data have the 2nd priority)
* ===========================================================
*
*        Z    carc          Ed       origin Ed ("S"=systematic)
* -------------------------------------------------------------
                                                CDataSystematics='
     Z   3   0.33509      18.685     S    
     Z   4   0.45542      31.188     S    
     Z   5   0.58068      46.096     S    
     Z   6   0.71101      69.279     S    
     Z  11   0.32036      17.306     S    
     Z  12   0.44444      20.000       Exp
     Z  13   0.44262      27.000       Exp
     Z  14   0.49778      36.926     S    
     Z  15   0.35512      20.466     S    
     Z  16   0.35543      20.022     S    
     Z  19   0.33092      16.347     S    
     Z  20   0.41430      22.840     S    
     Z  21   0.52773      32.614     S    
     Z  22   0.83333      30.000       Exp
     Z  23   0.51351      57.000       Exp
     Z  24   0.36832      40.000       Exp
     Z  25   0.32635      32.502     S    
     Z  26   0.31008      40.000       Exp
     Z  27   0.26087      36.000       Exp
     Z  28   0.23239      33.000       Exp
     Z  29   0.30303      30.000       Exp
     Z  30   0.36709      29.000       Exp
     Z  31   0.33209      23.330     S    
     Z  32   0.43291      34.709     S    
     Z  33   0.40273      30.514     S    
     Z  34   0.34681      22.944     S    
     Z  35   0.30933      18.546     S    
     Z  37   0.31041      17.471     S    
     Z  38   0.38197      23.975     S    
     Z  39   0.50444      36.001     S    
     Z  40   0.70175      40.000       Exp
     Z  41   0.62903      78.000       Exp
     Z  42   0.46099      65.000       Exp
     Z  43   0.46905      57.754     S    
     Z  44   0.46709      59.675     S    
     Z  45   0.42192      51.213     S    
     Z  46   0.31783      41.000       Exp
     Z  47   0.31452      39.000       Exp
     Z  48   0.44776      30.000       Exp
     Z  49   0.23040      12.000       Exp
     Z  50   0.69814      19.548     S    
     Z  51   0.40164      21.815     S    
     Z  52   0.37566      19.687     S    
     Z  53   0.32869      15.970     S    
     Z  55   0.31796      15.120     S    
     Z  56   0.39568      21.797     S    
     Z  57   0.47266      28.711     S    
     Z  58   0.45722      27.616     S    
     Z  59   0.45809      27.401     S    
     Z  60   0.45756      27.907     S    
     Z  61   0.46872      30.474     S    
     Z  62   0.42498      26.739     S    
     Z  63   0.39944      24.274     S    
     Z  64   0.48811      34.777     S    
     Z  65   0.48551      35.647     S    
     Z  66   0.46013      34.271     S    
     Z  67   0.46461      35.725     S    
     Z  68   0.46725      36.991     S    
     Z  69   0.44464      35.917     S    
     Z  70   0.38042      26.783     S    
     Z  71   0.50001      44.240     S    
     Z  72   0.57400      60.901     S    
     Z  73   0.72000      90.000       Exp
     Z  74   0.60000      90.000       Exp
     Z  75   0.86957      60.000       Exp
     Z  76   0.61863      68.711     S    
     Z  77   0.49972      58.457     S    
     Z  78   0.35772      44.000       Exp
     Z  79   0.43000      43.000       Exp
     Z  80   0.27995      19.947     S    
     Z  81   0.31510      24.187     S    
     Z  82   0.32972      25.000       Exp
     Z  83   0.31152      23.120     S    
     Z  84   0.29478      21.771     S    
     Z  85   0.29505      22.351     S    
     Z  87   0.39321      34.097     S    
     Z  88   0.31160      24.419     S    
     Z  89   0.37170      33.423     S    
     Z  90   0.41604      44.000       Exp
     Z  91   0.41800      43.146     S    
     Z  92   0.38641      38.503     S    
     c                                                    '

*
*
* Nordlund data
*  (These data have the 1st priority)
* ===================================

                                              CDataNordlund='
     c      Z=26.;     Ed=40. 
     c      Carc=0.286 ;   Barc=-0.568   
     *
     c      Z=28.;     Ed=39. 
     c      Carc=0.2268273;  Barc=-1.006722 
     *
     c      Z=29.;     Ed=30. 
     c      Carc=0.1177;  Barc=-0.54799  
     *
     c      Z=46.;     Ed=41 
     c      Carc=0.1515293;  Barc=-0.877387 
     *
     c      Z=47.;     Ed=39. 
     c      Carc=0.257325;  Barc=-1.063006  
     *
     c      Z=74.;     Ed=70. 
     c      Carc=0.119;  Barc=-0.564  
     *
     c      Z=78.;     Ed=42. 
     c      Carc=0.1115884;  Barc=-1.1216135 
     *
     c      Z=79.;     Ed=43. 
     c      Carc=0.1304146;  Barc=-0.788966 
     c                                                         '

                        Call PurifyCData(CDataSystematics,CDataNordlund)


* Systematics data

      Read(CDataSystematics,*,end=1,err=1)
     x                                 (zR(i), carcR(i), edR(i),i=1,101)


    1 Do i=1,101
      izR=idint(zR(i)+0.0001d0)

      If(izR==IZ)                              then
                         carc=carcR(i)
                         Edarc=edR(i)  
                         goto 2;               endif
      Enddo   

    2            do i=1,101; zR(i)=-1.e9; carcR(i)=zr(i); barcR(i)=zR(i) 
                                                     edR(i)=zR(i); enddo
* Nordlund data

      Read(CDataNordlund,*,end=3,err=3)
     x                       (zR(i), edR(i), carcR(i), barcR(i),i=1,101)
    3 Do i=1,101
      izR=idint(zR(i)+0.0001d0)

      If(izR==IZ)                              then
                                                          inordlund=1
                         barc=barcR(i)  
                         carc=carcR(i)  
                         Edarc=edR(i)  
                         Return;                endif
      Enddo   

      Return
      End
*
************************************************************************
*
        Subroutine ARRAYINT(KEY, E,CS,N,T,INTS0,RES)
*       --------------------------------------------
* REAL*8
*
*  To get RES value for arrays E(N),CS(N) at point T depending
*  ----------------------------------------------------------
*  from INTS int scheme 
*  -------------------
*
* KEY defines how to treat situation when T is not covered by E array
* ---
* KEY = 0   :  stop when T < E(1)  or T > E(N)
*     = 1   :  assign RES=0.0 if T < E(1) and RES=CS(N) if T > E(N)
* 
* INT has the usual meaning as in ENDF/B format
*
* Attention (!)
* ---------
* Input arrays E(N) and CS(N) should be in increased order
*
*
       implicit real*8(A-H,O-Z)
       Dimension E(N), CS(N)
       if(KEY.lt.0.or.KEY.gt.1) then
       Print *,'                        E R R O R         '
       Print *,'Subroutine  ARRAYINT:  KEY=',KEY,' is not acceptable !'
       print *,'                            press any key...'
       pause
       stop
       endif
       INTS=INTS0
*
       If(T.lt.E(1)) goto 8000
       If(T.gt.E(N)) goto 9000
*
       Do i=1,N
       i1=i
       If( T.le.E(i) ) goto 1000
       Enddo
            goto 9500
1000   if(i1.eq.1) then  ! means that T=E(1)
       RES=CS(1)
       Return
       Endif       
          X1=E(i1-1)
          X2=E(i1)
          Y1=CS(i1-1)
          Y2=CS(i1)
          WL=T
       CALL INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
       RES=RESINT
       Return
* 
* 
* T < E(1)
* --------
8000   if(key.eq.0) then
       Write(6,*)'                        E R R O R        '
       Write(6,8001) T,E(1),key
8001   Format(1x,'Subroutine  ARRAYINT:'/1x,
     # ' Requested energy T=',e12.5,' is less than minimal array '
     # ,'E(1) value=',e12.5
     #  //1x,'              CHANGE THE DATA or KEY number !!'/1x,
     # ' now  KEY is equal to', i5)
       print *,'                            press any key...'
       pause
       stop
       endif
c         
       RES=0.0
       Print 8002,T,RES
8002   Format(1x,'ARRAYINT(N): for T =',e12.5,' result ',
     # 'is set to',e12.5,' (min)')
       Return
* 
* T > E(N)
* --------
9000   if(key.eq.0) then
       Write(6,*)'                        E R R O R        '
       Write(6,9001) T,E(N),key
9001   Format(1x,'Subroutine  ARRAYINT:'/1x,
     # ' Requested energy T=',e12.5,' is more than MAXIMAL array '
     # ,'E(N) value=',e12.5
     #  //1x,'              CHANGE THE DATA or KEY number !!'/1x,
     # ' now  KEY is equal to', i5)
       print *,'                            press any key...'
       pause
       stop
       endif
c         
       RES=CS(N)
       Print 9002,T,RES
9002   Format(1x,'ARRAYINT(X): for T =',e12.5,' result ',
     # 'is set to',e12.5,' (MAX)')
       Return
*
9500   Write(6,9501)
9501   Format(1x,'Subroutine  ARRAYINT:  Strange E R R O R')
       print *,'                            press any key...'
       pause
       stop
       End
*
*
************************************************************************
*
       Subroutine Check_Tlim(Tlim,keyOK)
       implicit real*8(A-H,O-Z)

       keyOK=0 !  means  Tlim is not found

       E=0.0
       Do 1111 while (.not.eof(900))
        Read(900,*,err=1111)E
1111   Continue
       If(E< 0.9999d0*Tlim) Return
       If(E> 1.0001d0*Tlim) Return

       keyOK=1

       Return
       End
*
************************************************************************
*  
       Real*8 Function CF(IK,MK,TREC)
*      -----------------------
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       COMMON/NRT1/ANRT(MAXC1),BNRT(MAXC1),GNRT(MAXC1)
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       Common/Sep0817/Tdamage
       EDkeV=ED(MK)*1000.
* NRT 
*  TT in keV
       TT=TREC*1000.
*
       Tdamage=TT/
     # (1.+ANRT(IK)*TT+BNRT(IK)*(TT**0.75)+GNRT(IK)*(TT**0.16666666666))     

         Beta2Ed=0.8d0/(2.d0*EDkeV) 

         CF=Beta2Ed*Tdamage
*
         IF(Tdamage.le.(1.d0/Beta2Ed)) CF=1.0d0
         IF(Tdamage.le.EdkeV         ) CF=0.0d0
c
        RETURN
        END
*
************************************************************************
*  
       Real*8 FUNCTION CF1(ED,ATRN,BTRN,GTRN,TREC)
*      ------------------------------------
       implicit real*8(A-H,O-Z)
* As CF, but for special purpose
*
       TT=TREC*1000.                                                       

       Tdamage=TT/
     # (1.+ATRN*TT+BTRN*(TT**0.75)+GTRN*(TT**0.16666666666))     

         Beta2Ed=0.8d0/(2.d0*ED*1000.) 

         CF1=Beta2Ed*Tdamage
*
         IF(Tdamage.le.(1.d0/Beta2Ed)) CF1=1.0d0
         IF(Tdamage.le.ED*1000.      ) CF1=0.0d0
c
        RETURN
        END
*
************************************************************************
*  
* Special function to incorporate MD result and arc-dpa model
*
       Real*8 Function CF2(IK,MK,TREC)
*      ------------------------
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       COMMON/NRT1/ANRT(MAXC1),BNRT(MAXC1),GNRT(MAXC1)
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
       Common/URANUS/carc,barc,MDarc
*Feb0107
cc       EDkeV=ED(MK)*1000.
       EDkeV=EdMD*1000.
*   
*
* mod NRT 
       TT=TREC*1000.   ! MeV --> keV
*
       Tdamage= TT/
     # (1.+ANRT(IK)*TT+BNRT(IK)*(TT**0.75)+GNRT(IK)*(TT**0.16666666666))     

        Beta2Ed=0.8d0/(2.d0*EDkeV) 

        CF2=Beta2Ed*Tdamage
*
        IF(Tdamage.le.(1.d0/Beta2Ed)) CF2=1.0d0
        IF(Tdamage.le.EDkeV         ) CF2=0.0d0

*                                                       
       eMD= TT/
     # (1.+ANRT(IK)*TT+BNRT(IK)*(TT**0.75)+GNRT(IK)*(TT**0.16666666666))     
*
       If(MDarc==1) goto 1
*
* MD results
* ==========
*
       Elow =CMD(4)
       Ehigh=CMD(5)
*
*
      if(eMD.lt.Elow)  eMD=Elow
      if(eMD.gt.Ehigh) eMD=Ehigh
      efficiency=CMD(1)*(  eMD**CMD(2)  ) + CMD(3)*eMD
*
*
* modified NRT
       CF2=efficiency*CF2
       Return 
*
* arc-dpa
* =======
*
    1                       efficiency_arc=1.0   
         If(Tdamage.gt.(1.d0/Beta2Ed)) 
     c      efficiency_arc=(1.-Carc)*((Beta2Ed*Tdamage)**Barc)+Carc
*
        CF2=CF2*efficiency_arc
  
        RETURN
        END
*
************************************************************************
*  
*Feb0107
       Real*8 Function CFEDMD(IK,TREC)
*      ------------------------
* only in PRINT subroutine with MD turned on
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       COMMON/NRT1/ANRT(MAXC1),BNRT(MAXC1),GNRT(MAXC1)
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
       Common/Sep0817/Tdamage
*
       EDkeV=EdMD*1000.
* NRT 
       TT=TREC*1000.
*
       Tdamage=TT/
     # (1.+ANRT(IK)*TT+BNRT(IK)*(TT**0.75)+GNRT(IK)*(TT**0.16666666666))     

         Beta2Ed=0.8d0/(2.d0*EDkeV) 

         CFEDMD=Beta2Ed*Tdamage
*
         IF(Tdamage.le.(1.d0/Beta2Ed)) CFEDMD=1.0d0
         IF(Tdamage.le.EdkeV         ) CFEDMD=0.0d0

        RETURN
        END
*
*
************************************************************************
*  
       Real*8 Function CFEDMD_arc(IK,TREC)
*      -----------------------------------
* only in PRINT subroutine with arc-dpa turned on
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       COMMON/NRT1/ANRT(MAXC1),BNRT(MAXC1),GNRT(MAXC1)
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
       Common/URANUS/carc,barc,MDarc
*
       EDkeV=EdMD*1000.
* NRT 
       TT=TREC*1000.
*
       Tdamage=TT/
     # (1.+ANRT(IK)*TT+BNRT(IK)*(TT**0.75)+GNRT(IK)*(TT**0.16666666666))     

         Beta2Ed=0.8d0/(2.d0*EDkeV) 

         CFEDMD_arc=Beta2Ed*Tdamage
*
         IF(Tdamage.le.(1.d0/Beta2Ed)) CFEDMD_arc=1.0d0
         IF(Tdamage.le.EdkeV         ) CFEDMD_arc=0.0d0


                                     efficiency_arc=1.0
         If(Tdamage.gt.(1.d0/Beta2Ed)) 
     c      efficiency_arc=(1.-Carc)*((Beta2Ed*Tdamage)**Barc)+Carc
*
        CFEDMD_arc=CFEDMD_arc*efficiency_arc

        RETURN
        END
*
************************************************************************
*  
        Real*8 Function COSDD(A,B)
*       ------------------
        implicit real*8(A-H,O-Z)
        Dimension A(3),B(3)
        COSDD=(A(1)*B(1)+A(2)*B(2)+A(3)*B(3))
     #  /(dSqrt(A(1)**2+A(2)**2+A(3)**2)*dSqrt(B(1)**2+B(2)**2+B(3)**2))
        Return
        End
*
************************************************************************
*  
        Subroutine COS_DEFINE(IK,MK,T0,TPVA,COST)
*       ----------------------------------------
        parameter (maxc=21,maxc1=22)
        implicit real*8(A-H,O-Z)
*
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/PKA/ALPHA2(MAXC1,MAXC),E0(MAXC1,MAXC)
*
* T(M2)=[ 2M1*M2/(M1+M2)**2 ]* (  1-COS( TETA(CM) )) * T
*
* TG(TETA(LC))=SIN(TETA(CM))/( M1/M2 + COS(TETA(CM)) )
* 
        T=T0
        TM2=TPVA
* cos(teta) in CM
        COSTCM=1.-TM2/(T*0.5*ALPHA2(IK,MK))
        if(COSTCM.gt.1.) COSTCM =0.99999999
        if(COSTCM.lt.-1.) COSTCM=-0.9999999
        SINTCM=dSqrt(1.-COSTCM**2)
                    A11=A1
        If(IK.ne.1) A11=AT(IK-1)
*
        TETA=ATAN(   SINTCM/( (A11/AT(MK))+COSTCM )   )
        COST=dcos(TETA) 
c       write(445,*)'COS(TCM),COST=',COSTCM,COST
*
        RETURN
        END
*
************************************************************************
*
       Subroutine CRITICAL_ENERGY
*      --------------------------
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
*
* Find critical energy for PKA from known Tdam-value
*
*
* search root Tdam(E)-Ecrit=0, it is supposed, that d^2Tdam/dE^2 < 0
*
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       COMMON/NRT1/ANRT(MAXC1),BNRT(MAXC1),GNRT(MAXC1)
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
       Common/SATURN/TcritLAB(MAXC1)
*
* Tcrit correspods to  Abs( Tdam(E)-Ecrit ) < Err1
        Err1=1.E-4
*
        NK1=NK+1
        If(Ecrit.le.0.0) Call Error0('Ecri',0) 
*
        Do 70000 IK=1,NK1
*
         X0=Ecrit
         If(Tdam(IK,X0)-Ecrit)1,8000,90000
*
    1    h=0.1
    2    XU=X0*(1.+h)
             RK=(Tdam(IK,XU)-Tdam(IK,X0))/(XU-X0)
             X1=X0-(Tdam(IK,X0)-Ecrit)/RK
* Tcrit > 0.1 GeV ?
         If(X1.ge.1.e+5) then
                         Tcrit=X1
                         Print 91000,Tcrit
                         goto 9000
                         endif
         If(abs(Tdam(IK,X1)-Ecrit).lt.err1) then
         Tcrit=X1
         goto 9000
                                        endif
         If(Tdam(IK,X1)-Ecrit)1000, 8500, 2000
 1000    h=0.1
         X0=X1
         goto 2 
 2000    h=h/2.
         goto 2
c
 8000    Tcrit=X0
         goto 9000
 8500    Tcrit=X1
         goto 9000
c
 9000    continue
*
* keV --> MeV
        TcritLAB(ik)=Tcrit*0.001
70000   continue
*
*                                                       
        Return
*
*
90000   Print *,'Tcrit search failed !  Tdam(Xinitial) must be < Ecrit'
        Print *,'                                  press any key...'
        pause
        stop
91000   Format(70('*')/'*         Energy Tcrit =',g12.5,' keV',
     #  ' is not realistic',T69,'*'/70('*'))
        End
C
************************************************************************
         REAL*8 FUNCTION CS(X) 
************************************************************************
         IMPLICIT REAL*8(A-H,O-Z)
         COMMON/NRT1SL/ATRN,BTRN,GTRN
         COMMON/NRT2SL/COEFF
         COMMON/ED1SL/ED
         Common/PARAM01/IDSDT
         Common/JUPITER/ALP1,ALP2,BET1,BET2,BET3,BET4
* f(x)
         If(IDSDT.eq.0) then
* LNS
         F=ALP1*(X**BET1)*(   ( 1.+( ALP2*(X**BET2) )**BET3)**BET4  )
         goto 1
                        else
* Burenkov
         F=FBUR(X)
                        endif
   1         TT=COEFF*(X**2)     ! TT (MeV)
c
         CS=F/TT
         Return
         End
*
************************************************************************
*
        Subroutine DATATAB
*       ------------------
c A, W (amu), Ro (g/cm3) , <I> (eV) for elements
c
c Data from SRIM code
c  <I> is mean ionization potential (eV) checked by data in figures 
c  presented in http://www.srim.org/SRIM/SRIMPICS/IONIZ.htm,
c  except data noted below
c
c subroutine called from PRECALCULATION
c
      implicit real*8(A-H,O-Z)
      Common/DATATAB1/WTAB1(101),ROTAB1(101),RITAB1(101),IATAB1(101)
      Dimension IATAB(92), WTAB(92), ROTAB(92), RITAB(92)
*
*  H
      Data IATAB( 1),  WTAB( 1),  ROTAB( 1),  RITAB( 1)
     & /        1   ,    1.0079,   0.071486,    19.60/
* He
      Data IATAB( 2),  WTAB( 2),  ROTAB( 2),  RITAB( 2)
     & /        4   ,    4.0026,   0.125880,    39.00/
* Li
      Data IATAB( 3),  WTAB( 3),  ROTAB( 3),  RITAB( 3)
     & /        7   ,    6.9410,   0.534000,    42.20/
* Be
      Data IATAB( 4),  WTAB( 4),  ROTAB( 4),  RITAB( 4)
     & /        9   ,    9.0122,   1.848000,    63.70/
*  B
      Data IATAB( 5),  WTAB( 5),  ROTAB( 5),  RITAB( 5)
     & /       11   ,   10.8110,   2.350200,    76.00/
*  C
      Data IATAB( 6),  WTAB( 6),  ROTAB( 6),  RITAB( 6)
     & /       12   ,   12.0110,   2.253000,    79.10/
*  N
      Data IATAB( 7),  WTAB( 7),  ROTAB( 7),  RITAB( 7)
     & /       14   ,   14.0070,   1.026000,    84.20/
*  O
      Data IATAB( 8),  WTAB( 8),  ROTAB( 8),  RITAB( 8)
     & /       16   ,   15.9990,   1.426000,    96.00/
*  F
      Data IATAB( 9),  WTAB( 9),  ROTAB( 9),  RITAB( 9)
     & /       19   ,   18.9980,   1.111100,   107.00/
* Ne
      Data IATAB(10),  WTAB(10),  ROTAB(10),  RITAB(10)
     & /       20   ,   20.1797,   1.204000,   133.00/
* Na
      Data IATAB(11),  WTAB(11),  ROTAB(11),  RITAB(11)
     & /       23   ,   22.9898,   0.970000,   149.00/
* Mg
      Data IATAB(12),  WTAB(12),  ROTAB(12),  RITAB(12)
     & /       24   ,   24.3050,   1.736600,   156.00/
* Al
      Data IATAB(13),  WTAB(13),  ROTAB(13),  RITAB(13)
     & /       27   ,   26.9815,   2.702000,   170.00/
* Si
      Data IATAB(14),  WTAB(14),  ROTAB(14),  RITAB(14)
     & /       28   ,   28.0860,   2.321200,   171.00/
*  P
      Data IATAB(15),  WTAB(15),  ROTAB(15),  RITAB(15)
     & /       31   ,   30.9737,   1.821900,   173.00/
*  S
      Data IATAB(16),  WTAB(16),  ROTAB(16),  RITAB(16)
     & /       32   ,   32.0660,   2.068600,   184.00/
* Cl
      Data IATAB(17),  WTAB(17),  ROTAB(17),  RITAB(17)
     & /       35   ,   35.4530,   1.895600,   178.00/
* Ar
      Data IATAB(18),  WTAB(18),  ROTAB(18),  RITAB(18)
     & /       40   ,   39.9480,   1.650400,   190.00/
*  K
      Data IATAB(19),  WTAB(19),  ROTAB(19),  RITAB(19)
     & /       39   ,   39.0983,   0.863180,   190.00/
* Ca
      Data IATAB(20),  WTAB(20),  ROTAB(20),  RITAB(20)
     & /       40   ,   40.0800,   1.540000,   198.00/
* Sc
      Data IATAB(21),  WTAB(21),  ROTAB(21),  RITAB(21)
     & /       45   ,   44.9560,   2.989000,   225.00/
* Ti
      Data IATAB(22),  WTAB(22),  ROTAB(22),  RITAB(22)
     & /       48   ,   47.9000,   4.518900,   231.00/
*  V
      Data IATAB(23),  WTAB(23),  ROTAB(23),  RITAB(23)
     & /       51   ,   50.9420,   5.960000,   249.00/
* Cr
      Data IATAB(24),  WTAB(24),  ROTAB(24),  RITAB(24)
     & /       52   ,   51.9960,   7.200000,   265.00/
* Mn
      Data IATAB(25),  WTAB(25),  ROTAB(25),  RITAB(25)
     & /       55   ,   54.9380,   7.434100,   275.00/
* Fe
      Data IATAB(26),  WTAB(26),  ROTAB(26),  RITAB(26)
     & /       56   ,   55.8470,   7.865800,   286.00/
* Co
      Data IATAB(27),  WTAB(27),  ROTAB(27),  RITAB(27)
     & /       59   ,   58.9330,   8.900000,   306.00/
* Ni
      Data IATAB(28),  WTAB(28),  ROTAB(28),  RITAB(28)
     & /       58   ,   58.6900,   8.895500,   321.00/
* Cu
      Data IATAB(29),  WTAB(29),  ROTAB(29),  RITAB(29)
     & /       63   ,   63.5460,   8.920000,   332.00/
* Zn
      Data IATAB(30),  WTAB(30),  ROTAB(30),  RITAB(30)
     & /       64   ,   65.3900,   7.140000,   330.00/
* Ga
      Data IATAB(31),  WTAB(31),  ROTAB(31),  RITAB(31)
     & /       69   ,   69.7200,   5.904000,   334.00/
* Ge
      Data IATAB(32),  WTAB(32),  ROTAB(32),  RITAB(32)
     & /       74   ,   72.6100,   5.350000,   335.00/
* As
      Data IATAB(33),  WTAB(33),  ROTAB(33),  RITAB(33)
     & /       75   ,   74.9220,   5.727000,   353.00/
* Se
      Data IATAB(34),  WTAB(34),  ROTAB(34),  RITAB(34)
     & /       80   ,   78.9600,   4.810000,   351.00/
* Br
      Data IATAB(35),  WTAB(35),  ROTAB(35),  RITAB(35)
     & /       79   ,   79.9040,   3.199000,   317.00/
* Kr
      Data IATAB(36),  WTAB(36),  ROTAB(36),  RITAB(36)
     & /       84   ,   83.8000,   2.602100,   348.00/
* Rb
      Data IATAB(37),  WTAB(37),  ROTAB(37),  RITAB(37)
     & /       85   ,   85.4700,   1.532000,   364.00/
* Sr
      Data IATAB(38),  WTAB(38),  ROTAB(38),  RITAB(38)
     & /       88   ,   87.6200,   2.600000,   366.00/
*  Y
      Data IATAB(39),  WTAB(39),  ROTAB(39),  RITAB(39)
     & /       89   ,   88.9050,   4.469000,   375.00/
* Zr
      Data IATAB(40),  WTAB(40),  ROTAB(40),  RITAB(40)
     & /       90   ,   91.2200,   6.490000,   389.00/
* Nb
      Data IATAB(41),  WTAB(41),  ROTAB(41),  RITAB(41)
     & /       93   ,   92.9060,   8.570000,   417.00/
* Mo
      Data IATAB(42),  WTAB(42),  ROTAB(42),  RITAB(42)
     & /       98   ,   95.9400,  10.206000,   423.00/
* Tc
      Data IATAB(43),  WTAB(43),  ROTAB(43),  RITAB(43)
     & /       97   ,   97.0000,  11.500000,   428.00/
* Ru
      Data IATAB(44),  WTAB(44),  ROTAB(44),  RITAB(44)
     & /      102   ,  101.0700,  12.300000,   441.00/
* Rh
      Data IATAB(45),  WTAB(45),  ROTAB(45),  RITAB(45)
     & /      103   ,  102.9100,  12.399000,   468.00/
* Pd
      Data IATAB(46),  WTAB(46),  ROTAB(46),  RITAB(46)
     & /      106   ,  106.4000,  12.020000,   476.00/
* Ag
      Data IATAB(47),  WTAB(47),  ROTAB(47),  RITAB(47)
     & /      107   ,  107.8700,  10.473000,   488.00/
* Cd
      Data IATAB(48),  WTAB(48),  ROTAB(48),  RITAB(48)
     & /      114   ,  112.4000,   8.642000,   441.00/
* In
      Data IATAB(49),  WTAB(49),  ROTAB(49),  RITAB(49)
     & /      115   ,  114.8200,   7.300000,   481.00/
* Sn
      Data IATAB(50),  WTAB(50),  ROTAB(50),  RITAB(50)
     & /      120   ,  118.7100,   7.281600,   478.00/
* Sb
      Data IATAB(51),  WTAB(51),  ROTAB(51),  RITAB(51)
     & /      121   ,  121.7500,   6.684000,   472.00/
* Te
      Data IATAB(52),  WTAB(52),  ROTAB(52),  RITAB(52)
     & /      130   ,  127.6000,   6.250000,   485.00/
*  I
      Data IATAB(53),  WTAB(53),  ROTAB(53),  RITAB(53)
     & /      127   ,  126.9000,   4.937300,   455.00/
* Xe
      Data IATAB(54),  WTAB(54),  ROTAB(54),  RITAB(54)
     & /      132   ,  131.3000,   3.058900,   440.00/
* Cs
      Data IATAB(55),  WTAB(55),  ROTAB(55),  RITAB(55)
     & /      133   ,  132.9100,   1.878500,   488.00/
* Ba
      Data IATAB(56),  WTAB(56),  ROTAB(56),  RITAB(56)
     & /      138   ,  137.3270,   3.510000,   491.00/
* La
      Data IATAB(57),  WTAB(57),  ROTAB(57),  RITAB(57)
     & /      139   ,  138.9100,   6.173800,   472.00/
* Ce
      Data IATAB(58),  WTAB(58),  ROTAB(58),  RITAB(58)
     & /      140   ,  140.1200,   6.672400,   501.00/
* Pr
      Data IATAB(59),  WTAB(59),  ROTAB(59),  RITAB(59)
     & /      141   ,  140.9100,   6.773000,   513.00/
* Nd
      Data IATAB(60),  WTAB(60),  ROTAB(60),  RITAB(60)
     & /      142   ,  144.2400,   7.008000,   546.00/
* Pm
      Data IATAB(61),  WTAB(61),  ROTAB(61),  RITAB(61)
     & /      148   ,  148.0000,   6.475000,   560.00/
* Sm
      Data IATAB(62),  WTAB(62),  ROTAB(62),  RITAB(62)
     & /      152   ,  150.3600,   7.520000,   566.00/
* Eu
      Data IATAB(63),  WTAB(63),  ROTAB(63),  RITAB(63)
     & /      153   ,  151.9700,   5.244000,   580.00/
* Gd
      Data IATAB(64),  WTAB(64),  ROTAB(64),  RITAB(64)
     & /      158   ,  157.2500,   7.901000,   586.00/
* Tb
      Data IATAB(65),  WTAB(65),  ROTAB(65),  RITAB(65)
     & /      159   ,  158.9300,   8.230000,   614.00/
* Dy
      Data IATAB(66),  WTAB(66),  ROTAB(66),  RITAB(66)
     & /      164   ,  162.5000,   8.551000,   603.00/
* Ho
      Data IATAB(67),  WTAB(67),  ROTAB(67),  RITAB(67)
     & /      165   ,  164.9300,   8.795000,   641.00/
* Er
      Data IATAB(68),  WTAB(68),  ROTAB(68),  RITAB(68)
     & /      166   ,  167.2600,   9.066000,   661.00/
* Tm
      Data IATAB(69),  WTAB(69),  ROTAB(69),  RITAB(69)
     & /      169   ,  168.9300,   9.321000,   683.00/
* Yb
      Data IATAB(70),  WTAB(70),  ROTAB(70),  RITAB(70)
     & /      174   ,  173.0400,   6.960000,   684.00/
* Lu
      Data IATAB(71),  WTAB(71),  ROTAB(71),  RITAB(71)
     & /      175   ,  174.9700,   9.841000,   694.00/
* Hf
      Data IATAB(72),  WTAB(72),  ROTAB(72),  RITAB(72)
     & /      180   ,  178.4900,  13.310000,   675.00/
* Ta
      Data IATAB(73),  WTAB(73),  ROTAB(73),  RITAB(73)
     & /      181   ,  180.9500,  16.601000,   729.00/
*  W
      Data IATAB(74),  WTAB(74),  ROTAB(74),  RITAB(74)
     & /      184   ,  183.8500,  19.350000,   735.00/
* Re
      Data IATAB(75),  WTAB(75),  ROTAB(75),  RITAB(75)
     & /      187   ,  186.2000,  20.530001,   749.00/
* Os
      Data IATAB(76),  WTAB(76),  ROTAB(76),  RITAB(76)
     & /      192   ,  190.2000,  22.480000,   746.00/
* Ir
      Data IATAB(77),  WTAB(77),  ROTAB(77),  RITAB(77)
     & /      193   ,  192.2000,  22.421000,   757.00/
* Pt
      Data IATAB(78),  WTAB(78),  ROTAB(78),  RITAB(78)
     & /      195   ,  195.0800,  21.450001,   792.00/
* Au
      Data IATAB(79),  WTAB(79),  ROTAB(79),  RITAB(79)
     & /      197   ,  196.9700,  19.311001,   789.00/
* Hg
      Data IATAB(80),  WTAB(80),  ROTAB(80),  RITAB(80)
     & /      202   ,  200.5900,  13.546200,   800.00/
* Tl
      Data IATAB(81),  WTAB(81),  ROTAB(81),  RITAB(81)
     & /      205   ,  204.3800,  11.850000,   810.00/
* Pb
      Data IATAB(82),  WTAB(82),  ROTAB(82),  RITAB(82)
     & /      208   ,  207.1900,  11.343700,   787.00/
* Bi
      Data IATAB(83),  WTAB(83),  ROTAB(83),  RITAB(83)
     & /      209   ,  208.9800,   9.800000,   819.00/
* Po (no fig for <I>)
      Data IATAB(84),  WTAB(84),  ROTAB(84),  RITAB(84)
     & /      209   ,  210.0000,   9.251100,   830.00/
* At <I> is not well defined from SRIM data (see original files)
      Data IATAB(85),  WTAB(85),  ROTAB(85),  RITAB(85)
     & /      210   ,  210.0000,  10.000000,   756.95/
* Rn <I> is not well defined from SRIM data (see original files)
      Data IATAB(86),  WTAB(86),  ROTAB(86),  RITAB(86)
     & /      222   ,  222.0000,   9.910000,   736.54/
* Fr (no fig for <I>)
      Data IATAB(87),  WTAB(87),  ROTAB(87),  RITAB(87)
     & /      223   ,  223.0000,  10.000000,   827.00/
* Ra (no fig for <I>)
      Data IATAB(88),  WTAB(88),  ROTAB(88),  RITAB(88)
     & /      226   ,  226.0000,   5.022200,   826.00/
* Ac (no fig for <I>)
      Data IATAB(89),  WTAB(89),  ROTAB(89),  RITAB(89)
     & /      227   ,  227.0000,  10.000000,   841.00/
* Th (no fig for <I>)
      Data IATAB(90),  WTAB(90),  ROTAB(90),  RITAB(90)
     & /      232   ,  232.0000,  11.658000,   847.00/
* Pa (no fig for <I>)
      Data IATAB(91),  WTAB(91),  ROTAB(91),  RITAB(91)
     & /      231   ,  231.0000,  15.370000,   878.00/
*  U
      Data IATAB(92),  WTAB(92),  ROTAB(92),  RITAB(92)
     & /      238   ,  238.0300,  19.042999,   842.00/
c
c
      Do i=1,92
      IATAB1(i)=IATAB(i)
      WTAB1(i) =WTAB(i) 
      ROTAB1(i)=ROTAB(i)
      RITAB1(i)=RITAB(i)
      enddo
          Do i=93,101
          IATAB1(i)=0
          WTAB1(i) =0.0
          ROTAB1(i)=0.0
          RITAB1(i)=0.0
          enddo
      Return
      End   
*
************************************************************************
*
       Subroutine dEdXNUC_RECALC(Z1,Z2,A1,A2,E,sN)
*      -------------------------------------------
       implicit real*8(A-H,O-Z)
c Z1,A1: projectile, Z2,A2: target
c 
c
c      Real*8 Z,EL,RL,rksi,eps,t,sNd
c
c E (MeV)
c
       Z=(Z1**0.666666d0+Z2**0.6666666d0)**1.5d0
c
       EL=3.07358d-05*Z1*Z2*(Z**0.33333333d0)*( (A1/A2)+1.d0 )
c (no coeff, n0)
       RL=(Z**0.6666666d0) *(  (A1+A2)**2  )/(A1*A2)
c
       rksi=1.309d0
c
       eps=E/EL                              
       t=((2.d0*rksi)**0.6666666d0)*(eps**0.8888888d0)
c
       sNd=(EL/RL)*(1.d0/eps)*
     # (  -dsqrt(t)/dsqrt(1.+t)   +dlog(dsqrt(t)+dsqrt(1.d0+t))  )
c
       sN=sNd
       Return
       End
*
*
************************************************************************
*
       Subroutine DEDX_SPAR
*      --------------------
* Calculation of dE/dx by SPAR (Armstrong, Chandler) routine
*
* This subroutine should be executed after 
*     subr INCREASE_DATA_ARRAY, where NMAX is calculated
*
* units for stopping power [MeV/cm], range [cm]
*
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       Character OUTSPAR*12, C5*5
       Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
*
       Common/SKY1/dEdx(MAXC1,10002),dEdxN1(MAXC1,10002),
     # Rp1(MAXC1,10002)
*
       Common/STARS1/ dSdX1(MAXC1,MAXC,10002), 
     # dEdXNuc1(MAXC1,MAXC,10002), 
     # dEdXNuc0Ed1(MAXC1,MAXC,10002), dEdXNucEdTm1(MAXC1,MAXC,10002), 
     # CST1(MAXC1,MAXC,10002), NMAX
       Common/ISTOP/ISTOP
       Common/VENUS/RI(MAXC)
       Dimension TmpE(10002),dxdE(10002)
*
       if(istop.ne.1) return
* 
*
* Condensed matter supposed
      If(RO.le.0.01)  goto 91000
*
* Mean <I> for compound (only for printing)
           RIL=0.d0
           Do i=1,NK
           RIL= RIL+FR(i)*ZT(i)*dlog( RI(i) )
           Enddo
           RIL=2.718281828**(RIL/Z2)
*
      jj=2 ! condensed element
          if(NK.ne.1) then
* check if all components are isotopes of the same element
          IZT0=idint( ZT(1)+0.001)
          do i=1,NK
          IZT=idint( ZT(i)+0.001)
          if(IZT.ne.IZT0) then
                          jj=4   ! condensed compound
                          goto 1
                          endif
          IZT0=IZT
          enddo
                      endif
    1     continue
*
*
      NK1=NK+1
*
*
*
      Do  IK=1,NK1   
*     ------------
* IK - id of the moving ion,   IK=1: primary particle
*
*
* Projectile
      if(IK.eq.1) then
                     ZPR=Z1
                     APR=A1
                  else
                     ZPR=ZT(IK-1)
                     APR=AT(IK-1)
                  endif
*
        IZA=1000*idint(ZPR+0.001)+idint(APR+0.001)
        Write(C5,'(i5)')IZA
        outspar=C5//'.sto'
        open(21,file=outspar)

        Write(21,90001)ZPR,APR,IK,Z2,A2,JJ,RO,RN0,RIL*1.e+6
        Write(21,90002)
        Write(21,90003)
*
*
        Do I=1,999999999
*
* J=(lg(E)+6)*1000+1  means that energy can changes from 10**-6 MeV
* If 10002 array dimension will be increased change also 1000 below
* and in other subroutines (i.e. MODEL)
        RLG=dfloat(I-1)/1000. -6.
        E=10.**RLG   ! Energy (MeV)
! NMAX is already defined in subr INCREASE_DATA_ARRAY and check < 5 GeV is done 
       If(I.gt.NMAX) goto 7000
! Attention. NMAX is the same for all material components, it is
* supposed that SL_NLS code which is executed before IOTA code 
* was stopped at the same energy for all components
*
         Call SPAR0(ZPR, APR, E, dEdxTOTS, dEdxNS, JJ)
*
* total stopping power
          dEdx(IK,i)  =dEdxTOTS
* nuclear stopping
          dEdxN1(IK,i)=dEdxNS
* 
* calculate total path from 1/ dE/dx integration (lin-lin)
            TmpE(i)=E
                                dxdE(i)=0.0
            if(dEdxTOTS.ne.0.0) dxdE(i)=1./dEdxTOTS
       if(i.eq.1) then 
                  Rp1(IK,i)   =0.0
                  else
       Rp1(IK,i)=Rp1(IK,i-1)+(TmpE(i)-TmpE(i-1))*
     #           (dxdE(i)+dxdE(i-1))/2.
                 endif
*
*
        Enddo    !  Do I1=1,999999999
 7000   continue
*
* write results 
* units for printing MeV/mg/cm2, cm
                   prc=1./(1000.*RO)
c MeV/cm (?)
c                  prc=1.
        Do i=1,NMAX
        Write(21,90004) TmpE(i), prc*(dEdx(IK,i)-dEdxN1(IK,i)) ,
     #                            prc*dEdxN1(IK,i), Rp1(IK,i)
        Enddo
        close(21)
*
*
        Enddo    !  Do IK=1,NK1
*       -----------------------
*
*
               iiii=1
c        if(iiii.eq.1) stop
        Return
c
c
90001   Format(' Stopping power from SPAR (Armstrong, Chandler)'/
     #  ' projectile ',f6.1,f8.2,'       IK =',i3,
     #  /' medium     ',f6.1,f8.2,'    condensed   JJ =',i2,
     #  /' density =',f8.3,' g/cm3     n0 =',1pe12.5,' cm-3'
     #  /' mean ioniz pot = ',0pf8.2,' eV')
90002   Format(/' units  E [MeV],  dE/dx [MeV/mg/cm2],  R [cm] ')
90003   Format(/'     E        dE/dx(electr)  dE/dx(nucl)',
     #  '       R (total) '/ 61('-'))
90004   Format(1pe12.5,2e14.5,e17.5)
c
91000   Print 91001
91001   Format(/' Gaseous target is not allowed ! '
     #  /20x,'Change subr DEDXSPAR  !!')
        print *,'                        press any key...'
        pause
        stop
c
        End
* 
*
************************************************************************
*
         Subroutine  DEDX_ZIEGLER_READ(IK, IR0, RO0, Ex, dEdx, Rp, NdE,
     #   dEdxN)
*        -------------------------------------------------------------
*
* for any SRIM version
*
c
c Ex,  dEdx  - energy and total stopping power   (Ziegler/SRIM)
c      dEdxN - nuclear stopping power            (Ziegler/SRIM)
c
         parameter (maxc=21)
         implicit real*8(A-H,O-Z)
         Character C12*12,C33*33,C7*7,CID3*3,CID2*2, C17*17
         Character C6*6, C80*80
         Character*500 CC,LineWas
         Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
         Common/Basic/Z1,A1,Z2,A2,AW,ROOO,RN0
         Common/Tlim0/Tlim
         Dimension Rp(1501), Ex(1501), dEdx(1501)
         Dimension dEdxN(1501)
         Dimension ExTMP(1501),dEdxETMP(1501), dEdxE(1501)
         Dimension ExTMP2(1501),dEdxETMP2(1501)
         If(IK.eq.1)               then
                     Zini=Z1
                     Aini=A1
                                   else
                     Zini=ZT(IK-1)
                     Aini=AT(IK-1)
                                   endif
                     IZT=Idint(Zini+0.001)
                     IAT=Idint(Aini+0.001)
*
* Rewrite file without "," 
         open(199,status='scratch')
         IR=199
*
         do while (.not.eof(IR0))
         Read(ir0,'(a)')cc

         do i=1,500;if(cc(i:i)==',') cc(i:i)='.'; enddo
         Call LetzteZ(cc,icc) 
         write(ir,'(a)')cc(1:icc)
         enddo 
         rewind IR
*                                                                          
*
* find "Ion ="
*
         Do 1 while (.not.eof(IR))
         Read(IR,'(a)')CC

         LineWas='Ion ='
         Call FindenUB(CC,LineWas,IPos)    
         If(Ipos/=0) goto 11
    1    Continue 
                                                            goto 90001 

* Get Z,A from SRIM output 
   11    Call ZieION(CC,Zzie,Azie)
*
*
* find "Target density"
*
         Do 20 while (.not.eof(IR))
         Read(IR,'(a)')CC

         LineWas='Target Density ='
         Call FindenUB(CC,LineWas,IPos)    
         If(Ipos/=0)                                Then   ! 1)

         Read(CC((Ipos+16):),*,err=80000)RO

         iro=idint(ro*1000.+0.01d0)
         iro0=idint(ro0*1000.+0.01d0)

            if(iRO.ne.iRO0) then               ! 2)
            print 18,IZT,IAT,RO0,RO
   18       format(1x,'  W A R N I N G !'/1x,
     #      'for ',i3,i4,' RO(input)=',g12.5,' BUT  Ziegler(RO)=',
     #      g12.5/1x,'The last one will be used to recover dEdx')
            print *,'                   press any key to continue'
            pause
                          endif                ! 2)
         goto 22
                                                    Endif  ! 1)
   20    Continue
                                                            goto 90005
*
*
* find line "Stopping units"
*
   22    do 30 while (.not.eof(IR))
         Read(IR,'(a)')CC

         LineWas='Stopping Units ='
         Call FindenUB(CC,LineWas,IPos)    
         If(Ipos/=0)                                        theN
             LineWas='Stopping Units =  MeV / (mg/cm2)'
             Call FindenUB(CC,LineWas,IPos2)    
             if(Ipos2==0)       then
             Print *,' Units of stopping power must be MeV/mg/cm2 !'
             print *,'                         press any key...'
             pause;stop;        endif
          goto 33
                                                            endiF
   30     Continue
                                                            goto 90006
*
*
* find line with "Energy"   "Elec."   "Nuclear"
*
   33    do 40 while (.not.eof(IR))
         Read(IR,'(a)')CC

         LineWas='Energy'
         Call FindenUB(CC,LineWas,IPos1)    
            LineWas='Elec.'
            Call FindenUB(CC,LineWas,IPos2)    
               LineWas='Nuclear'
               Call FindenUB(CC,LineWas,IPos3)    
         If(Ipos1/=0.and.Ipos2/=0.and.Ipos3/=0)  goto 44
   40    continue         
                                                            goto 90007
*
* omit one line
   44    read(IR,*)  
*
*
* Begin reading
*
* transformation of SRIM data 
*
         i=1
           Ex(1)=0.0
           dEdx(1)=0.0
           Rp(1)=0.0
           dEdxN(1)=0.0
c
c
         Do iii=1,1111111       ! ---c y c l e begins----

         read(IR,'(a)')CC
         if(CC(3:9).eq.'-------') goto 2000 

         read(CC,'(e7.0,1x, a3,   e12.0,   e11.0,    e8.0,1x, a2)')
     #             EN,       CID3, dEdx_el, dEdx_nuc, RRR,       CID2
*
         if(CID3.ne.'eV '.and.CID3.ne.'keV'.and.CID3.ne.'MeV'.
     #   and.CID3.ne.'GeV') call error0(' ev?',11111)
*
* energy ---> MeV
                            ENERGY_MULT=1.0
         if(CID3.eq.'eV ')  ENERGY_MULT=1.E-06
         if(CID3.eq.'keV')  ENERGY_MULT=1.E-03
         if(CID3.eq.'GeV')  ENERGY_MULT=1.E+03
*
         if(CID2.ne.'A '.and.CID2.ne.'um'.and.CID2.ne.'mm'
     #   .and.CID2.ne.'cm'.and.CID2.ne.'m ') call error0(' um?',11111)
*
* all units ---> cm
                           RANGE_MULT=1.
         if(CID2.eq.'A ')  RANGE_MULT=1.E-08     ! 1 A=10**-10 m
         if(CID2.eq.'um')  RANGE_MULT=1.E-04     ! 1 um=micron= 10**-6 m
         if(CID2.eq.'mm')  RANGE_MULT=0.1        ! 1 mm=0.001 m
         if(CID2.eq.'m ')  RANGE_MULT=100.       ! 1 m =100 cm 
* 1)
* MeV/(mg/cm2) ----> MeV/(g/cm2)
         dEdx_sum= 1000.*( dEdx_el+dEdx_nuc)
         dEdx_nuc2= 1000.*dEdx_nuc
* 2)
* MeV/(g/cm2) ----> MeV/cm
         dEdx_sum= dEdx_sum*RO
         dEdx_nuc2= dEdx_nuc2*RO
*
         Energy=EN* ENERGY_MULT
         Range= RRR* RANGE_MULT
*
* fill arrays
         i=i+1
                  if(i.gt.1501)  Call error0('DEDX',1501)
         Ex(i)=Energy
         dEdx(i)=dEdx_sum
         dEdxN(i)= dEdx_nuc2
         Rp(i)=Range
         Enddo                  ! ---c y c l e finished----
         call error0('_Zie',11111)
*
* end of reading
2000     NdE=i
         close(IR) ! IR=199
*
*
* General check of energies
* --------------------------
* the first energy should be around 1.1 eV, i.e. Ex(2)
* the last one around Tlim
       if( Ex(2) > 2.0e-06) goto 90008
       if( (Ex(NdE) < Tlim).and. (Tlim-Ex(NdE))/Tlim > 0.01) goto 90009
*
*
*
*
* Recalculate stopping if Z=Z', but A.ne.A'
*
         IZzie=Idint(Zzie+0.001)
         If(IZzie.ne.IZT) then
         Print 3000,Zini,Aini,Zzie,Azie
3000     Format(' SRIM data failure !!!'/1x,' Current incident ion is ',
     #   f5.1,f8.2/20x,'BUT'/' SRIM data are prepared for ',f5.1,f8.2)
         print *,'                           press any key...'
         pause
         stop
                          endif
* no recalculation if A-A' < 1
         If( abs(Azie-Aini).lt.1.0) Return
*
*Feb1307
*****         If(NK.ne.1) then
*****         Print 3100
*****3100     Format(70('*')/'*',25x,'W A R N I N G !',t70,'*'/'*',
*****     #   4x,' for compounds stopping power will not be recalculated',
*****     #   t70,'*'/70('*')//1x,
*****     #   'press any key to continue  calculations ...')
*****         pause
*****         Return
*****                     endif
*
* Recalculation
* 
* i) electronic stopping
*
         Do i=1,NdE
         ExTMP(i)=Ex(i)*Aini/Azie
         dEdxETMP(i)=dEdx(i)-dEdxN(i)
         Enddo  
c 
         if(Aini-Azie) 4000,4000,5000
c
c A' < A ==> lack of high energy data, get them by interp two last points
c
4000        Do i=1,NdE
            m=i
            if(ExTMP(NdE).le.Ex(i)) goto 4010
            Enddo
         call error0('4010',NdE)
4010         X1=ExTMP(NdE-1)
             X2=ExTMP(NdE)
             Y1=dEdxETMP(NdE-1)
             Y2=dEdxETMP(NdE)
             INTS=2
         j=NdE
         Do i=m,NdE
         j=j+1
                  if(j.gt.1501)  Call error0('j :1',1501)
         ExTMP(j)=Ex(i)
         WL=ExTMP(j)
         Call INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
         dEdxETMP(j)=RESINT
         Enddo
         NdETMP=j
         goto 7000
c 
c A' > A ==> lack of low energy data, get them by interp two first points
c
5000        Do i=2,NdE
            m=i-1
            if(ExTMP(2).le.Ex(i)) goto 5010  ! "2" is first non-zero value
            Enddo
         call error0('5010',NdE)
5010         X1=ExTMP(2)
             X2=ExTMP(3)
             Y1=dEdxETMP(2)
             Y2=dEdxETMP(3)
             INTS=2
         j=1
         ExTMP2(j)=0.0
         dEdxETMP2(j)=0.0
c
         Do i=2,m
         j=j+1
         ExTMP2(j)=Ex(i)
         WL=ExTMP2(j)
         Call INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
         dEdxETMP2(j)=RESINT
         Enddo
c
           Do i=2,NdE
           j=j+1
                  if(j.gt.1501)  Call error0('j :2',1501)
           ExTMP2(j)=ExTMP(i)
           dEdxETMP2(j)=dEdxETMP(i)
           Enddo
         NdETMP=j
           Do i=1,NdETMP
           ExTMP(i)=ExTMP2(i)
           dEdxETMP(i)=dEdxETMP2(i)
           Enddo
c
c recover old energy grid
c
7000     Do i=1,NdE
         E=Ex(i)
         Call ARRAYINT(0,ExTMP,dEdxETMP, NdETMP, E, 2, RES)
         dEdxE(i)=RES
         Enddo 
*
* ii) nuclear stopping
*
       Do i=2,NdE
       E=Ex(i)
       Call dEdXnuc_recalc(Zzie,Z2,Azie,A2,E,sNzie)
       Call dEdXnuc_recalc(Zini,Z2,Aini,A2,E,sNini)
       If(sNzie.eq.0.0) Call error0('snzi',0)
c
       dEdxN(i)=dEdxN(i)*sNini/sNzie
       Enddo
*
* total stopping 
                           open(22,file='renorm.sto') ! test printing
       Write(22,7500)Zini,Aini,Zzie,Azie,Z2,A2
7500   Format(' Incident ion  ', f5.1,f8.2/
     # ' SRIM data for ',f5.1,f8.2/25x,' Target ',f5.1,f8.2//
     #' Energy [MeV],   Stopping power [MeVcm2/mg]'//
     #'     E         dE/dx(elec)     dE/dx(nucl) '/44('-'))
*****     #' Energy [MeV],   Stopping power [MeV/cm]'//
*****     #'     E         dE/dx(elec)     dE/dx(nucl) '/44('-'))
c
       Do i=1,NdE

* ? 20 Sept 2017
       if( dEdxN(i) <= 0.0 ) dEdxN(i)=1.d-5
       if( dEdxE(i) <= 0.0 ) dEdxE(i)=1.d-5

       dEdx(i)=dEdxN(i)+dEdxE(i)
*Feb1307
       Write(22,'(1pe11.4,e14.3,e16.3)')Ex(i),dEdxE(i)/(1000.*RO),
     # dEdxN(i)/(1000.*RO)
       Enddo
c
       Return
c
c
80000    Print *,'-----Subroutine DEDX_ZIEGLER_READ ------'
         Print *,'  Error by reading  target density'
         print *,'                         press any key...'
         pause
         stop
90001    Print *,'------- End of SRIM output file ------'
         Print *,'  Phrase "Ion =" is not found'
         print *,'                         press any key...'
         pause
         stop
90005    Print *,'-------  End of SRIM output file ------'
         Print *,'  Phrase "Target density" is not found'
         print *,'                         press any key...'
         pause
         stop
90006    Print *,'-------  End of SRIM output file ------'
         Print *,'  Phrase "Stopping units" is not found'
         print *,'                         press any key...'
         pause
         stop
90007    Print *,'-------  End of SRIM output file ------'
         Print *,' Line with "Energy"  "Elec."  "Nuclear" is not found'
         print *,'                         press any key...'
         pause
         stop
90008    Print *,'-------  SRIM data ------'
         Print '(a,1pg12.5,a)',
     c     ' The first energy ', Ex(2),' MeV   is too high !'
         print *,'                         press any key...'
         pause
         stop
90009    Print *,'-------  SRIM data ------'
         Print '(a,1pg12.5,a)',
     c     ' The last energy ', Ex(NdE),' MeV   is too low !'
         print *,'                         press any key...'
         pause
         stop
         End
*
*
************************************************************************
*
        Subroutine Define_Filename_for_SL_LNS(Z1,A1,Z2,A2,INPNAM_XS)
        IMPLICIT REAL*8(A-H,O-Z)
        Character INPNAM_XS*500
        Common/Sep2217/IDSDT
*
        INPNAM_XS=' '
*ZZaaa_ZZaaa.IDSDT
*
        IZ1=idint(Z1+0.0001d0)
        IA1=idint(A1+0.0001d0)
        IZ2=idint(Z2+0.0001d0)
        IA2=idint(A2+0.0001d0)
*
        Write(INPNAM_XS(1:17),'(i2,i3,a1,i2,i3,a1,i5)')
     c          IZ1,IA1,'_',IZ2,IA2,'.',IDSDT

                                      Call ENTLUECKEN(INPNAM_XS,iletzte)
        Return
        End
*
*
************************************************************************
*
        Subroutine Delete_exlamation_point(Cline)
        Character*500 Cline
        do i=1,500
        if(Cline(i:i)=='!') then
                     do j=i,500; Cline(j:j)=' '; enddo; Return    
                            endif
        enddo
        Return
        End
*
*
***********************************************************************
*
           Subroutine delwords(A,N)
* Entfernen erste N Woerter aus A.   A =500
* Alle zu entfernen geht nicht!
           Character A*500
           if(N.le.0) Return
           NNN=500
           NW=0
           NNNmax=NNN-1
              If(a(1:1).ne.' ') NW=NW+1         
        Do 1 I=1,NNNmax
        If(a(i:i).eq.' '.and. a((i+1):(i+1)).ne.' ') NW=NW+1         
            if(NW.eq.(N+1)) then
            Do j=1,i
            a(j:j)=' '
            Enddo
            Return
                            endif
1       continue          
        Print *,'Alle Woerter koennten nicht entfernt werden !'
        Return
        End
*
************************************************************************
*
       Subroutine DISPERS(KEY)
*      -----------------------
       implicit real*8(A-H,O-Z)
       Common/SUNDI/DIVel1(405),DIFRENKEL(405),DIVel5
       Common/SUN/Vel1L(405),Tmean1,Vel2Tm(405),Vel3Pl(405),
     #            R1,R1p,Tplay1,Vel4(405),Nel(405)
       Common/MEMORY/NFRENKEL(405)
       Common/SUN2/ZV5,Vel5,NN(405)
*
       Common/DIMEMO/DV1(405),DFREN(405),DV5
*
       If(Key.eq.2) goto 2
* store data before the history
       Do i=1,405
       DV1(i)=Vel1L(i)
       DFREN(i)=dfloat(NFRENKEL(i))
       Enddo
       DV5=Vel5
       Return
* sum
  2     continue
        SUMV1=0.0
        SUMF=0.0
        Do i=1,405
        SUMV1=SUMV1+Vel1L(i)-DV1(i)   ! = result for the current history
        SUMF= SUMF +dfloat(NFRENKEL(i))-DFREN(i)
          DIVel1(i)    =DIVel1(i)   +SUMV1**2
          DIFRENKEL(i) =DIFRENKEL(i)+SUMF**2
        Enddo   
*
        DIVel5=DIVel5+ (Vel5-DV5)**2
        Return
        End
* 
*
************************************************************************
*
          SUBROUTINE E0_DEFINITION(EARRAY,N)  
*         ---------------------------------
          implicit real*8(A-H,O-Z)
          DIMENSION EARRAY(1499), TBAS(591)
*
          TBAS(1)=1.0d0
          TBAS(2)=1.2d0
          TBAS(3)=1.5d0
          TBAS(4)=2.0d0
          TBAS(5)=2.5d0
          TBAS(6)=5.0d0
          TBAS(7)=7.5d0
          imax=7
c
  1       j=0          
c
          RM=1.D-07
c
          Do irm=1,11
          RM=RM*10.d+0          
c
          Do i=1,imax
          j=j+1
                   If(j.gt.1499) then
                   Print *,' Dimension of EARRAY is not sufficient !'
                   stop
                   endif  
          EARRAY(j)=TBAS(i)*RM            
          Enddo
          Enddo
          N=j
cccc          write(333,111)(EARRAY(i),i=1,n)
cccc111       format(1x,1pe15.7)
cccc          stop
          return
          end
* 
*
************************************************************************
*
        Subroutine E_default(E1,E2, T,NT)
*       ---------------------------------
        implicit real*8(A-H,O-Z)
        Character*500 CLabel,C2,C3
        Dimension T(12345), EARRAY(1499)

        Call E0_DEFINITION(EARRAY,NNN)  

        if(E1 >= E2) goto 80001

        Do i=1,NNN
* energies coincide
        Write(C2,'(1pe14.5)')E1
        Write(C3,'(1pe14.5)')Earray(i)
        If(C2==C3) then; i1=i; NT=0; goto 1500; endif

        if(E1 < Earray(i)) then; i1=i; goto 1111;  endif
        Enddo
                                                             goto 80002
 1111   T(1)=E1; NT=1

 1500   do i=1,NNN
                                                           C2=' ';C3=' '
* energies coincide
        Write(C2,'(1pe14.5)')E2
        Write(C3,'(1pe14.5)')Earray(i)
        If(C2==C3) then; i2=i; goto 2222; endif

        if(E2 < Earray(i)) then
                              i2=i
                                goto 2222
                                   endif
        enddo
                                                             goto 80003
 2222   if(i2==1) goto 80004

        do i=i1,i2-1
         NT=NT+1;                             if(nt > 12345) goto 80004
           T(NT)=Earray(i)
             enddo

         NT=NT+1;                             if(nt > 12345) goto 80004
           T(NT)=E2
        Return

80001   CLabel=' 80001'; goto 88888
80002   CLabel=' 80002'; goto 88888
80003   CLabel=' 80003'; goto 88888
80004   CLabel=' 80004'; goto 88888
88888   Print '(a)','Energie(s) is entered incorrect!'
       Print '(2a/a)','Subr. E_default     Label ',
     c Clabel(1:7),'     Read rules in "read.me!"'
        print *,'                              press <Enter>...'   
        pause;   stop
        End
*
************************************************************************
*
        Subroutine END_OF_CALCULATION
*       -----------------------------
        Write(33,1)
  1     Format(33(1h*),'e*n*d',35(1h*))
        Return
        end
* 
*
************************************************************************
*
        Subroutine Energies_and_number_MC_events(Cline,ir,iestop)
*       ---------------------------------------------------------
        parameter (maxe=50001)
        implicit real*8(A-H,O-Z)
        Character*500 Cline,C,CLabel
        Common/EIN/EIN(MAXE),NH(MAXE),KEIN
        Common/Tlim0/Tlim
        Dimension T(12345),NHIST(12345)
                                                              iestop=0
                                                         many=0

* empty line => Return
        do i=1,500;  If(Cline(i:i)/=' ') goto 1111;   enddo
        Return
*
* "all" energies
 1111                                                           continue
        do i=1,500-2 
         If(Cline(i:(i+2))=='all'.or.Cline(i:(i+2))=='ALL'.or.
     c      Cline(i:(i+2))=='All')  then
        If(i>1) then 
                  Do j=1,i-1
                      If(Cline(j:j)/=' ') goto 80010;enddo; endif

        C='0.0 ... x.xxxxxxE+00' 
                                 Write(C(9:20),'(1pe12.5)')Tlim-200.d0
        C(21:(200+20))=Cline((i+3):(i+202))
                                    goto 1234
                                    endif
        enddo

        C=Cline
 1234                                                           continue

* search "x" or "X" or "*"   
                       multipl=0
        Do i=1,500     
        If(C(i:i)=='x'.or. C(i:i)=='X'.or. C(i:i)=='*') then
        if(i==1) goto 80011
        Do j=1,i-1; If(C(j:j)/=' ') goto 1300;enddo       
        goto 80011
 1300                                                           continue
                        C(i:i)=' '
                        im=i 
                        multipl=1
                        goto 2222;                      endif
        Enddo
 2222                                                         continue

        If(multipl==1)             then
           if(im >=2)  then
           do i=1,im-1;  If(C(i:i)/=' ') goto 3333;   enddo
                       endif        
* here alles bis "x" = empty
        C='0.0 ... x.xxxxxxE+00 ' 
                                  Write(C(9:21),'(1pe12.5)')Tlim-200.
        C(23:)=Cline(im:300)
        goto 1111 
                                   endif 

 3333                                                         continue

        Do i=1,500
        if(C(i:(i+1))=='..') then
               many=i
                C(i:(i+1))='  '
                                  do j=i+2,500
                                  if(C(j:j)=='.') then;  C(j:j)=' '
                                                  else;  goto 2; endif
                                  enddo
                             endif
         Enddo
*
* here no "." in C
    2    Num=iwords(C)
*
* ====================================================================
*
       If(many/=0)                                           Then ! 1)
*
* Case: many energies  (many /=0)
* -------------------------------
                                       luecke=0 
        do i=1,many;   If(C(i:i)/=' ') luecke=1;   enddo
*
        RHIST=0.0
        E1=0.0
        E2=0.0

        If(luecke==0)               Then
        if(Num>=2) then 
                         Read(C,*,err=80001,end=80001) E2,RHIST
                      else               
                         Read(C,*,err=80002,end=80002) E2
                      endif 
                                    Else 
        if(Num>=3) then 
                         Read(C,*,err=80003,end=80003) E1,E2,RHIST
                      else               
                         Read(C,*,err=80004,end=80004) E1,E2
                      endif 
                                    Endif  
        If(RHIST==0.and.multipl==1) goto 80005 
        If(E2==0.0) goto 80006
*
* 
        If(E1==0.0) Call TheSmallestEd(E1)

              Call E_default(E1,E2, T,NT)

* number of MC events
        If(RHIST==0.or.multipl==1)            tHen
                                      Call NHIST_default(T,NT, NHIST)  
        if(multipl==1) then
* here RHIST from input will considerdd as multiplication coefficient
        Do i=1,NT
                       RRR=RHIST*NHIST(i)
        NHIST(i)=idint(RRR+0.0001d0)
        Enddo 
                       endif
                                              eLse  
* here RHIST/=0 and multipl=0
* all T()-energies have the same NHIST
        Do i=1,NT
        NHIST(i)=idint(RHIST+0.0001d0)
        Enddo 
                                              eNdif

                                                             Else ! 1)
*
* Case: one energy  (many =0)
* --------------------------
        Num=iwords(C)
        RHIST=0.0
* if many=0 and there are 3 entries => error
                                                   if(Num==3) goto 80009
        if(Num>=2) then 
                         Read(C,*,err=80007,end=80007) EE,RHIST
                      else               
                         Read(C,*,err=80008,end=80008) EE
                      endif 
                                                   If(EE<=0.0) iestop=1
        NT=1
        T(1)=dabs(EE)

        If(RHIST==0.or.multipl==1)            tHeN
                                      Call NHIST_default(T,NT, NHIST)  
        if(multipl==1) then
        Do i=1,NT
                       RRR=RHIST*NHIST(i)
        NHIST(i)=idint(RRR+0.0001d0)
        Enddo 
                       endif
                                              eLsE  
        Do i=1,NT
        NHIST(i)=idint(RHIST+0.0001d0)
        Enddo 
                                              eNdIf
                                                             Endif ! 1)
        Do i=1,NT
        ir=ir+1
                                               If(ir.gt.MAXE) goto 90000
        EIN(ir)=T(i)
        NH(ir)=NHIST(i)
        KEIN=ir
        Enddo         
*
        Return
*
*
80001  CLabel=' 80001'; goto 88888
80002  CLabel=' 80002'; goto 88888
80003  CLabel=' 80003'; goto 88888
80004  CLabel=' 80004'; goto 88888
80005  CLabel=' 80005'; goto 88888
80006  CLabel=' 80006'; goto 88888
80007  CLabel=' 80007'; goto 88888
80008  CLabel=' 80008'; goto 88888
80009  CLabel=' 80009'; goto 88888
80010  CLabel=' 80010'; goto 88888                    
80011  CLabel=' 80011';                               
88888  Print '(/a/)',
     c'Energie(s) or number of MC events is entered incorrect!'
       Print '(2a//a)','Subr. Energies_and_number_MC_events    Label ',
     c Clabel(1:7),'Read rules in "read.me!"'
       Print '(/a)','Incorrect input line:'
       Print '(a)',Cline(1:70)
       print *,'                              press <Enter>...'   
       pause;   stop
90000  print *,' T O O   M U C H   I N P U T   E N E R G I E S  (E)!'
       print *,' Change parameter MAXE in the code !'
       print *,'                                 press any key...'
       pause; stop
       End
*
*
***********************************************************************
*
        Subroutine ENT1UNDL(C500,iletzte)
c Entfernen alle erste und letzte Luecke and geben die Position 
c letzten nicht Null-Symbols 
        Character C500*500, CTMP*500
        N=500;   j=0;  ctmp=' '; i1=0
        do i=1,n;if(C500(i:i).ne.' ') then;i1=i;goto 1; endif; enddo
    1   if(i1.eq.0) then; iletzte=0; return; endif
        do iii=1,n; i2=n-iii+1; if(C500(i2:i2).ne.' ') goto 2;  enddo
    2   j=0
        do i=i1,i2; j=j+1; CTMP(j:j)=C500(i:i); enddo
        iletzte=j; C500=' '
        do i=1,iletzte; C500(i:i)=CTMP(i:i);  enddo
        return
        end 
*
*
***************************************************************************
*
        Subroutine ENTLUECKEN(C500,iletzte)
        Character C500*500, CTMP*500; ctmp=' ';j=0;do 2 i=1,500
        if(C500(i:i).eq.' ') goto 2;j=j+1; ctmp(j:j)=c500(i:i);
   2    continue; c500=ctmp; iletzte=j; return
        end 
*
************************************************************************
*
         Subroutine error0(phrase,I)
*        --------------------------
         Character phrase*4
         write(6,1)phrase,I
1        Format(1x,'        ???   ',a4/1x,
     *   'ERROR !!!          number=',i7)
         print *,'                       press <Enter>...'   
         pause
         stop
         end
*
************************************************************************
*  
         Real*8 FUNCTION F(X) 
*        -------------
* Scattering f(x)= f(t^1/2) function
*
         implicit real*8(A-H,O-Z)
         Common/PARAM01/IDSDT
         Common/JUPITER/ALP1,ALP2,BET1,BET2,BET3,BET4
*
         If(IDSDT.eq.0)  then
*
         F=ALP1*(X**BET1)*(   ( 1.+( ALP2*(X**BET2) )**BET3)**BET4  )
         Return
                         else
*
* Burenkov et al function
*
         F=FBUR(X)
         Return
                         endif
         End
*
************************************************************************
*
         Real*8 FUNCTION FBUR(X) 
*        ---------------
        implicit real*8(A-H,O-Z)
* Burenkov et al function
         If(X.le.0.04) then
           RJ=1.
           A1=0.088
           A2=1.
           A3=0.2
           goto 1
           endif
         If(0.04.lt.X  .and.  X.le.1.0) then
           RJ=1.
           A1=0.23
           A2=1.3
           A3=0.4
           goto 1
           endif
         If(1.0.lt.X  .and.  X.le.40.) then
           RJ=0.0
           A1=0.4563
           A2=0.0
           A3=0.3
           goto 1
           endif
         If(X.gt.40.) then
           RJ=0.0
           A1=0.5
           A2=0.0
           A3=0.0
           endif
1        FBUR=A1*(X**(RJ/2.))*(X+A2)/(  (X+A3)**2 )
         Return
         End
*
*
****************************************************************************
*
        Subroutine FindenUB(LineWo,LineWas,IPos)
* finden die Phrase ohne den Unterschied zwischen groen und kleinen
*   Buchstaben
*
*  finden Phrase suchen Wort Woerter Worte search words
*  translation uebersetzung
*
        Character*500 Line, C500, LineWo, LineWas
        Character*29 LineG, LineK
            LineK='qwertyuiopasdfghjklzxcvbnm'
            LineG='QWERTYUIOPASDFGHJKLZXCVBNM'
        Line=LineWo; C500=LineWas
*
         Do 1 i=1,500
         Do 1 j=1,28
         If(line(i:i).eq.LineG(j:j)) line(i:i)=lineK(j:j)
         If(C500(i:i).eq.LineG(j:j)) C500(i:i)=lineK(j:j)
    1    Continue
*
        Do ic2=1,500; ic=500-ic2+1; if(C500(ic:ic).ne.' ') goto 2; Enddo
        ic=0
    2   Laenge=ic
                  IPos=0
        Do i=1,500
          i1=i
          i2=i+Laenge-1
          if(i2.gt.500) Return
          if(Line(i1:i2).eq.C500(1:Laenge)) then; IPos=i1; Return; Endif
        Enddo
        Return
        End
*Feb1207
*
************************************************************************
*
        Subroutine FIRST_ION(IK,IE,T00,T0,P0,P0X,P0Y,P0Z,X0,Y0,Z0,IDE,
     @                       IGEN,IDION)
*       ----------------------------------------------------------------
*
        parameter (maxe=50001)
        implicit real*8(A-H,O-Z)
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/WHATION/IDI
        Common/EIN2/XX(maxe),YY(maxe),ZZ(maxe),COSX(maxe),COSY(maxe),
     @              COSZ(maxe)
*
        T0=T00
        P0=dSqrt(2.*A1*T0)
        P0X=P0*COSX(ie)
        P0Y=P0*COSY(ie)
        P0Z=P0*COSZ(ie)
*
* cm
        X0=XX(ie)
        Y0=YY(ie)
        Z0=ZZ(ie)
*
        IK=1        
        IDE=-1
        IGEN=0
c
        IDI=1
        IDION=1
        Return
        End
*
******************************************************************
*
         Subroutine FT12CHOICE(idsdt)
*        --------------------------
* Main formula
* f(x)=Lambda* x**(1-2m) [1+ {2*Lambda*x**(2*(1-m)}**q ]**(-1/q)
*
* Parameters are taken mainly from   W.Eckstein, "Computer Simulation
* of Ion-Solid Interactions"  Springer, Berlin, 1991, p.59, Table 4.8
*
*
* alp1 = L,  bet1 = (1-2*m),  alp2 = 2*L
* bet2 = 2*(1-m), bet3= q,    bet4 = -1/q
*
         implicit real*8(A-H,O-Z)
         Common/JUPITER/ALP1,ALP2,BET1,BET2,BET3,BET4
         Common/AUX1/rlambda,rm,q
*
         if(idsdt.eq.1) return   ! --> Burenkov et al function
         if(idsdt.eq.0) goto 10   
         goto(888,888,888,888,888,888,888,888,888,10,
     #        11,12,13,14,15), idsdt
         goto 888
*
* Original Winterbon et al parameters
10       rlambda=1.309
         rm=1./3.
         q=2./3.
         goto 777
*
* Thomas-Fermi-Sommerfeld
11       rlambda=1.7
         rm=0.311
         q=0.588
         goto 777
*
* Bohr
12       rlambda=2.37
         rm=0.103
         q=0.570
         goto 777
* 
* Lenz-Jensen
13       rlambda=2.92
         rm=0.191
         q=0.512
         goto 777
* 
* Moliere
14       rlambda=3.07
         rm=0.216
         q=0.530
         goto 777
*
* U.Littmark, J.F.Ziegler, "Handbook of Range Distributions"
* Kr-C potential
15       rlambda=3.35
         rm=0.2328
         q=0.4445
*
*
777      alp1=rlambda
         bet1=1.-2.*rm
         alp2=2.*rlambda
         bet2=2.*(1.-rm)
         bet3=q
         bet4=-1./q
!
         idsdt=0
         Return 
*
  888    Print 999,idsdt
  999    Format(' ERROR:    Parameters of f(t^1/2) are not known !'/
     #   '           idsdt=',i5,' is not correct.')      
         Print *,'                     press any key...'
         pause
         stop
         End
C
************************************************************************
         REAL*8 FUNCTION FTRN(X) 
************************************************************************
         IMPLICIT REAL*8(A-H,O-Z)
         COMMON/NRT1SL/ATRN,BTRN,GTRN
         COMMON/NRT2SL/COEFF
         COMMON/ED1SL/ED
         Common/PARAM01/IDSDT
         Common/JUPITER/ALP1,ALP2,BET1,BET2,BET3,BET4
*
* LNS general expression,  f(x)
* -----------------------------
         If(IDSDT.eq.0) then
*
         F=ALP1*(X**BET1)*(   ( 1.+( ALP2*(X**BET2) )**BET3)**BET4  )
         goto 1
                        else
* Burenkov
* --------
         F=FBUR(X)
                        endif
*
*
  1          TT=1000.*COEFF*(X**2)     ! T --> keV
             TT1=TT
c
         IF(TT.le.2.*ED*1000.) TT=2.*ED*1000.
*                              *1000 from T(MeV) --> keV
         CF=(0.8/(2.*ED*1000.))*TT/
     #   (1.+ATRN*TT+BTRN*(TT**0.75)+GTRN*(TT**0.1666666666))     
c
         FTRN=F*CF/(TT1/1000.)
         Return
         End
*
*
************************************************************************
*
        Subroutine GetInputValues1(CC,
     c                          IDSDT,par_st1,par_st2,ieveprint,keytpka)
        implicit real*8(A-H,O-Z)
        Character CC*500
*
        IDSDT=0
           par_st1=0.0
              par_st2=0.0
                 ieveprint=0
                     keytpka=0

        nwords=iwords(CC)

        if(nwords==5) Read(CC,*,err=80005,end=80005) 
     c                        IDSDT,par_st1,par_st2,ieveprint,keytpka
        if(nwords==4) Read(CC,*,err=80004,end=80004) 
     c                        IDSDT,par_st1,par_st2,ieveprint
        if(nwords==3) Read(CC,*,err=80003,end=80003) 
     c                        IDSDT,par_st1,par_st2
        if(nwords==2) Read(CC,*,err=80002,end=80002) 
     c                        IDSDT,par_st1
        if(nwords==1) Read(CC,*,err=80001,end=80001) 
     c                        IDSDT
*
*
* default values
* ==============
*
        if(par_st1==0.0) par_st1=0.1d0
        if(par_st2==0.0) par_st2=0.05d0

        if(keytpka==0) keytpka=+1

        Return
*
80001  Call error0('nw=1',80001)
80002  Call error0('nw=2',80002)
80003  Call error0('nw=3',80003)
80004  Call error0('nw=4',80004)
80005  Call error0('nw=5',80005)
        End 
*
************************************************************************
*  
        Real*8 Function GETSIN(QCOS)
*       ---------------------
        implicit real*8(A-H,O-Z)
        ARG=(1.-QCOS**2)
        if(ARG.lt.0.0) ARG=0.0
        GETSIN=DSqrt(ARG)
        Return
        End
*
*
************************************************************************
*
        Subroutine gnu_comment(Cline,cgnu)
        implicit real*8(A-H,O-Z)
        Character cgnu*1,Cline*500
                                        cgnu='#' 
        do i=1,500
        if(Cline(i:i)=='"') then; cgnu='"'; Cline(i:i)=' '; endif
        enddo
        Return
        End
*
************************************************************************
*
      Subroutine GRAPH(Y,F,N3,IALOG)                                     
*     ------------------------------
* IALOG .ne.0 : Log scale for Y             
      implicit real*8(A-H,O-Z)
      COMMON/MAIIPR/IPR1                                                
      DIMENSION Y(N3),F(N3),F1(11250)                                     
      INTEGER A1(40),B1,C1,D1,D2,D3,D4,D5,D6                            
      DATA B1,C1,D1,D2,D5,D6/1H*,1H ,1H!,1H-,1HI,1H./                   
       IF(N3.GT.11250)then
       Print*,' BAD operation in the code GRAPH'
       STOP
       endif
      N1=1                                                              
      W=F(1)                                                            
      DO 1 L=1,N3                                                       
      IF(ABS(W).GT.ABS(F(L)))GOTO 1                                     
      W=F(L)                                                            
    1 CONTINUE                                                          
      IF(W.NE.0.)GOTO 70                                                
      WRITE(IPR1,41)                                                    
   41 FORMAT(1X,' GRAPH:  maximal value identically equal to zero')      
      RETURN                                                            
   70 IF(IALOG.NE.0)GOTO 199                                            
      WRITE(IPR1,60)                                                    
   60 FORMAT(/3X,'   Z           D       ',4X,4('.........!'))          
      T=40./ABS(W)                                                      
      DO 300 I=1,N3                                                     
  300 F1(I)=F(I)                                                        
      GOTO 7                                                            
  199 WMIN=1.E+10                                                       
      DO 200 I=1,N3                                                     
      IF(F(I).NE.0..AND.F(I).LT.WMIN)WMIN=F(I)                          
  200 CONTINUE                                                          
      IMAX=-8                                                           
  210 IF(W.LE.10.**IMAX)GOTO 220                                        
      IMAX=IMAX+1                                                       
      GOTO 210                                                          
  220 IMIN=IMAX                                                         
  230 IF(WMIN.GE.10.**IMIN)GOTO 240                                     
      IMIN=IMIN-1                                                       
      GOTO 230                                                          
  240 R10=10.**IMIN                                                     
      IF(IMIN.EQ.IMAX)GOTO 250                                          
      WW1=dfloat(IMIN)                                                   
      WW=dfloat(IMAX-IMIN)                                               
      R20=10.**IMAX                                                     
      WRITE(IPR1,62)R10,R20                                             
   62 FORMAT(1X,5X,'semilogarithmic net        '/3X,23X,E8.2,32X,E8.2)  
      GOTO 260                                                          
  250 WW1=dlog10(WMIN)                                                  
      WW=dlog10(WMAX)-dlog10(WMIN)                                      
  260 DO 270 I=1,N3                                                     
      FF=F(I)                                                           
      IF(FF.EQ.0.)FF=R10                                                
  270 F1(I)=dlog10(FF)-WW1                                              
      WRITE(IPR1,60)                                                    
      T=40./WW                                                          
    7 CONTINUE                                                          
      DO 3 I=1,N3                                                       
      X=F1(I)                                                           
      N=IDINT(X*T)                                                        
      IF(I.EQ.N3)GOTO 105                                               
      IF(I.EQ.N1*10)GOTO 107                                            
      D4=C1                                                             
      GOTO 108                                                          
  105 D4=D6                                                             
      GOTO 108                                                          
  107 D4=D2                                                             
      N1=N1+1                                                           
  108 N2=1                                                              
      DO 4 J1=1,40                                                      
      IF(J1.EQ.20)GOTO 110                                              
      IF(J1.EQ.1.OR.J1.EQ.40)GOTO 24                                    
      D3=D4                                                             
      GOTO 25                                                           
   24 D3=D5                                                             
   25 CONTINUE                                                          
      GOTO 111                                                          
  110 D3=D1                                                             
      N2=N2+1                                                           
  111 CONTINUE                                                          
      IF(J1.EQ.N)GOTO 101                                               
      A1(J1)=D3                                                         
      GOTO 102                                                          
  101 A1(J1)=B1                                                         
  102 CONTINUE                                                          
    4 CONTINUE                                                          
      WRITE(IPR1,61)Y(I),F(I),A1                                        
   61 FORMAT(1PE12.5,1X,E12.5,5X,40A1)                                  
    3 CONTINUE                                                          
      RETURN                                                            
      END                                                               
*
*
************************************************************************
*
        Subroutine Identify_MD_results(IZ0, CID,NCID, MDname, ID,Note)
*       --------------------------------------------------------------
        implicit real*8(A-H,O-Z)
        Character*500 NOTE,CID(ncid), MDname, C, CIDread, MDread
*
* typical CID
*       CID(13)='13  13  Bacon (2000) und Almazouzi (1999)'
*

        Do 1111 i=1,NCID
        C=CID(i)
                                            if(C==' ') goto 1111
        Read(C,*,err=80000,end=80000)IZread
                                            If(IZ0/=IZread) goto 1111
        Call Lesen_ein_Wort(C,3,MDread,imd)
                                            If(MDname/=MDread) goto 1111
* found!
        Call Lesen_ein_Wort(C,2,CIDread,icc)
        Read(CIDread,*,err=80000,end=80000)ID

        NOTE=' '
        Call delwords(C,2); Call ENT1UNDL(C,iletzte)
                         NOTE=C
        Return        
*
 1111   Continue
*
*
                                               Call LetzteZ(MDname,immm)
        Print 79000,MDname(1:50)!,immm
c79000   Format(a,i10)
        Stop
c
79000   Format(//'Message from Subroutine Identify_MD_results.'///
     c  'The following name of MD results is UNKNOWN:'/a//
     c  'Change input data file or Subroutine MDPARAM'/)
        pause; 
        Stop
80000   Print 80001,CID(1:60)
80001   Format(//'Message from Subroutine Identify_MD_results.'///
     c  'The following CID( ) is INCORRECT:'/a//)
        pause; 
        Stop
        End
*
************************************************************************
*
       Subroutine INCREASE_DATA_ARRAY
*      ------------------------------
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
*
       Common/dEdxMain01/Ex01(MAXC1,1501), dEdx01(MAXC1,1501),
     # Rp01(MAXC1,1501), dEdxN01(MAXC1,1501),NdE01(MAXC1)
*
       Common/Lindhard01/Energy01(MAXC1,MAXC,1701),  
     # dSdX01(MAXC1,MAXC,1701), dEdX_Nuc01(MAXC1,MAXC,1701), 
     # dEdX_Nuc_0Ed01(MAXC1,MAXC,1701), 
     # dEdX_Nuc_Ed_Tmax01(MAXC1,MAXC,1701),  
     # CST01(MAXC1,MAXC,1701), NSL01(MAXC1,MAXC)
*
* corresponds to /dEdxMain01/
       Common/SKY1/dEdx(MAXC1,10002),dEdxN1(MAXC1,10002),
     # Rp1(MAXC1,10002)
* corresponds to /Lindhard01/
       Common/STARS1/ dSdX1(MAXC1,MAXC,10002), 
     # dEdXNuc1(MAXC1,MAXC,10002), 
     # dEdXNuc0Ed1(MAXC1,MAXC,10002), dEdXNucEdTm1(MAXC1,MAXC,10002), 
     # CST1(MAXC1,MAXC,10002), NMAX
*
       Common/istop/istop
       Dimension TMP1(1701),TMP2(1701),TMP3(1701),TMP4(1701),
     #           TMP5(1701),TMP6(1701)
*
* =1 test printing, 0 no  
       itestxs=0 
*
       If(itestxs.ne.0) open(21,file='test.xs')
       If(itestxs.ne.0) Write(21,1000)
1000   Format('   I       E        dSdX      dEdX_Nuc',
     # '    dEdX_Nuc     dEdX_Nuc      CST'/
     # '                               (tot)      [0-Ed]',
     # '       [Ed-Tmax]    (barn)'/77('-'))
*
*
      NK1=NK+1
*
*
* General arrays preparation
*****************************
*
*
                               if(istop.ne.-1) goto 3001
* Ziegler data
* ============
*
      Do 2000 IK=1,NK1   
*     -------------
* IK - id of the moving ion
*
        NdE01tmp=NdE01(IK)
        Do II=1, NdE01tmp
        TMP1(II)=Ex01(IK,II)
        TMP2(II)=dEdx01(IK,II)
        TMP3(II)=dEdxN01(IK,II)
        TMP4(II)=Rp01(IK,II)
        Enddo
*
        Emaxtmp=dmin1(5000.,TMP1( NdE01tmp) )
        Do I=1,999999999
*
* J=(lg(E)+6)*1000+1  means that energy can changes from 10**-6 MeV
* If 10002 array dimension will be increased change also 1000 below
* and in other subroutines (i.e. MODEL, DEDX_SPAR)
        RLG=dfloat(I-1)/1000. -6.
        E=10.**RLG
* E > 5000 MeV is not considered
        If(E.gt.Emaxtmp) goto 2000
! Attention. NMAX is the same for all material components, it is
* supposed that SL_LNS code which is executed before IOTA code 
* was stopped at the same energy for all components
        NMAX=I
        If(NMAX.gt.10002) Call error0('NMAX',10002)
        Call ARRAYINT(0,TMP1,TMP2, NdE01tmp,E,2, RES1)
        Call ARRAYINT(0,TMP1,TMP3, NdE01tmp,E,2, RES2)
        Call ARRAYINT(0,TMP1,TMP4, NdE01tmp,E,2, RES3)
          dEdx(IK,NMAX)  =RES1
          dEdxN1(IK,NMAX)=RES2
          Rp1(IK,NMAX)   =RES3
        Enddo    !  Do I1=1,999999999
 2000   Continue !  Do IK=1,NK1
*
*
*
* Cross-sections obtained by Lindhard approach
* ============================================
*
 3001                          continue
*
      Do 3 IK=1,NK1   
*     -------------
*
* IK - id of the moving ion
* MK - id of the material component
*
      Do 2 MK=1,NK
*     ------------
*
      If(itestxs.ne.0) Write(21,11) IK,MK
11    Format('Interaction (ion id)  ',i2,' +',i3)
*
        NSL01tmp=NSL01(IK,MK)
        Do II=1, NSL01tmp
        TMP1(II)=Energy01(IK,MK,II)
        TMP2(II)=dSdX01(IK,MK,II)
        TMP3(II)=dEdX_Nuc01(IK,MK,II)
        TMP4(II)=dEdX_Nuc_0Ed01(IK,MK,II)
        TMP5(II)=dEdX_Nuc_Ed_Tmax01(IK,MK,II)
        TMP6(II)=CST01(IK,MK,II)
        Enddo
*
      Emaxtmp=dmin1(5000.,TMP1( NSL01tmp) )
      Do I=1,999999999
*
* J=(lg(E)+6)*1000+1  means that energy can changes from 10**-6 MeV
* If 10002 array dimension will be increased change also 1000 below
* and in other subroutines ( MODEL, DEDX_SPAR, ...)
        RLG=dfloat(I-1)/1000. -6.
        E=10.**RLG
* E > 5000 MeV is not considered
        If(E.gt.Emaxtmp) goto 2
        NMAX=I
        If(NMAX.gt.10002) Call error0('NMAX',10002)
*
*        
        Call ARRAYINT(0,TMP1,TMP2, NSL01tmp,E,2, RES1)
        Call ARRAYINT(0,TMP1,TMP3, NSL01tmp,E,2, RES2)
        Call ARRAYINT(0,TMP1,TMP4, NSL01tmp,E,2, RES3)
        Call ARRAYINT(0,TMP1,TMP5, NSL01tmp,E,2, RES4)
        Call ARRAYINT(0,TMP1,TMP6, NSL01tmp,E,2, RES5)
       If(itestxs.ne.0) Write(21,1)I,E,RES1,RES2,RES3,RES4,RES5
1      Format(i5,g12.5,5g12.5)
          dSdX1(IK,MK,NMAX)        =RES1  
          dEdXNuc1(IK,MK,NMAX)     =RES2
          dEdXNuc0Ed1(IK,MK,NMAX)  =RES3
          dEdXNucEdTm1(IK,MK,NMAX) =RES4
* barn ---> cm2
          CST1(IK,MK,NMAX)         =RES5*1.e-24
       EndDo
*
*
   2   Continue
   3   Continue
*
        If(itestxs.ne.0) close(21)
        Return
        End
*
************************************************************************
*
        Subroutine INDICATOR(IK,T,IDE)
*       ------------------------------
        implicit real*8(A-H,O-Z)
        Common/EKIN1/EKIN(405),HEK,MEK ! MEK can be less than 405
*
        If(IK.ne.1) goto 2000
        Do I=1,405
        IDE=I
        If(T.le.EKIN(i)) Return
        Enddo
*
        Print *,'SUBR. INDICATOR   T SEEMS STRANGE =',T
        Call error0('IDE ',00000)
* to check IDE for non primary particle
2000    If(IDE.gt.0.and.IDE.le.405)   Return
* IDE <= 0 or > 405
*
        Print *,'SUBR. INDICATOR:   E R R O R !   IDE =',IDE
        Call error0('IDE ',00000)
        End
*
************************************************************************
*
       Subroutine Initialize_and_Zeroize(T00)
*      --------------------------------------
       parameter (maxc1=22)
       implicit real*8(A-H,O-Z)
       Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
       Common/SKY1/dEdx(MAXC1,10002),dEdxN1(MAXC1,10002),
     # Rp1(MAXC1,10002)
*
       Common/urand1/iyg
       Common/SUN/Vel1L(405),Tmean1,Vel2Tm(405),Vel3Pl(405),
     #            R1,R1p,Tplay1,Vel4(405),Nel(405)
       Common/Interr/Interr1
       Common/MOON/XX(105),DD(105),DDF(105),TK(105),HST
       COMMON/RECSTORE/ATOM(50003,9),NKO(50003),INDIC(50003),
     !                 KGEN(50003),NREC
       COMMON/MEMORY/NFRENKEL(405)
       Common/CUT1/rmaxpl,itot,icut
       Common/EKIN1/EKIN(405),HEK,MEK ! MEK can be less than 405
       Common/SUN2/ZV5,Vel5,NN(405)
       Common/SUNDI/DIVel1(405),DIFRENKEL(405),DIVel5
               iyg=1
       T0=T00
*
*
*                                             Ziegler Range
       JE=idint((dlog10(T0)+6.)*1000.)+1
                   If(JE.le.0.or.JE.gt.10002) Call error0(' JE ',11111)
*
* Ziegler Range for projectile
       RZ=Rp1(1,JE)
*
       RFULL=(1.+0.333333*A2/A1)*RZ     !  For effective A2
*   
       HST=RFULL/20.
       XXX=-HST
*
       Do i=1,105
       XXX=XXX+HST
       XX(i)=XXX
       DD(i)=0.0
       DDF(i)=0.0
       TK(i)=0.0
       enddo
*
*   
         MEK=200       ! should be less than 405 
         HEK=T0/dfloat(MEK)
         EEE=-HEK+0.5*HEK
*
         Do i=1,405
         EEE=EEE+HEK
         EKIN(i)=EEE
         enddo
*
* indent for Z where the primary energy lost = 5 %
         ZV5= 0.05*T0/dEdx(1,JE)
         Vel5=0.0 
         DIVel5=0.0 
*
* Zeroize 
* -------
*
        Do i=1,405
        Nel(i)   =0
        NN(i)    =0
        Vel1L(i) =0.
        DIVel1(i)=0.
        Vel2Tm(i)=0.
        Vel3Pl(i)=0.
        Vel4(i)  =0.
        Enddo
*
        Tmean1=0.
        R1=0.
        R1p=0.
        Tplay1=0.0
*
        Interr1=0
        Icut=0
        Itot=0
*
        Do i=1,50003
        NKO(i)=0
        KGEN(i)=0
        Do j=1,9
        ATOM(i,j)=0.0
        enddo 
        enddo 
        NREC=0
*
        Do i=1,405
        NFRENKEL(i)=0
        DIFRENKEL(i)=0.0
        Enddo
c
        Return
        End
*
************************************************************************
*
           Subroutine INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
*          ---------------------------------------------------
           implicit real*8(A-H,O-Z)
           If(INTS.eq.1) goto 1
           If(INTS.eq.2) goto 2
           If(INTS.eq.3) goto 3
           If(INTS.eq.4) goto 4
           If(INTS.eq.5) goto 5
           Print *,
     #     'This interpolation scheme ',INTS,' is not supported'
           Print *,'                        press any key...'
           pause
           Stop
* Histogr
1          RESINT =  Y1  
           Return
* Lin-lin
2          Call REGR1(X1,X2,Y1,Y2,AAA,BBB)  
           RESINT =  AAA * WL + BBB 
           Return
* Lin(lg)-lin
3          aX1=dlog10(x1) 
           aX2=dlog10(x2) 
           aY1=y1 
           aY2=y2 
           aWL=dlog10(wl)
           Call REGR1(aX1,aX2,aY1,aY2,AAA,BBB)  
           RESINT =  AAA * aWL + BBB  
           Return
* Lin-lin(lg)
4          aX1=x1 
           aX2=x2 
           aY1=dlog10(y1)
           aY2=dlog10(y2) 
           aWL=wl
           Call REGR1(aX1,aX2,aY1,aY2,AAA,BBB)  
           RESINT = 10.**( AAA * aWL + BBB ) 
           Return
* Lin(lg)-lin(lg)
5          aX1=dlog10(x1) 
           aX2=dlog10(x2) 
           aY1=dlog10(y1) 
           aY2=dlog10(y2) 
           aWL=dlog10(wl)
           Call REGR1(aX1,aX2,aY1,aY2,AAA,BBB)  
           RESINT = 10.**(   AAA * aWL + BBB  )
           Return
           End
*
*
***********************************************************************
*
       Integer Function iwords(A)
       Character A*500,L*1,Z*1,L1*1
       Integer W; Z=' '; NNN=500; W=0; NNNmax=NNN-1;  L=A(1:1)
       If(L.ne.Z) W=W+1; Do 1 I=1,NNNmax; L=A(I:I); I1=I+1
       L1=A(I1:I1); If(L.eq.Z .and. L1.ne.Z) W=W+1         
1      Continue;IWords=W; Return
       End
*
*
***********************************************************************
* + Subr Lesen_Woerter_getrennt()
* + Funct iwords
         Subroutine Lesen_ein_Wort(Cgelesen,Num,Cextrakt,ice)
*
         Character*500 Cgelesen, Cextrakt, Wort, CTMP
         Dimension Wort(num),LWort(num)
         CTMP=Cgelesen; LL=iwords(Cgelesen); if(Num.le.LL) then
         Call Lesen_Woerter_getrennt(CTMP,Num,Wort,LWort)          
         Cextrakt=Wort(Num); ice=Lwort(num)
         else;Cextrakt=' '; ice=1; endif
         Return 
         End
*
*
***********************************************************************
*                                                      
       Subroutine Lesen_Woerter_getrennt(Zeile,N,Wort,Lwort) 
* Lesen die ersten N Woerter aus Zeile (a500)
*   LWort ist die LAnge jedes Wort( ), das max. 500 Symbole hat
       Character Zeile*500, Wort*500
       Dimension Wort(N),LWort(N); if(N.le.0) Return;  NNN=500
       Do 1234 K=1,N;  Wort(k)=' '; do i=1,NNN; i1=i; 
       if(Zeile(i:i).ne.' ') goto 1; enddo; call error0('lewo',3000)
    1   j=0; do i=i1,NNN; i2=i-1; if(Zeile(i:i).eq.' ') goto 2
        j=j+1; Wort(K)(j:j)=Zeile(i:i); enddo;  
        call error0('lewo',3001)
    2   LWort(K)=j; Do i=i1,i2;  Zeile(i:i)=' '; Enddo 
 1234   Continue; Return
        End
*
*
***********************************************************************
*                                                      
        Subroutine LetzteZ(Cread,IC)
        Character Cread*500
        Do ic2=1,500; ic=500-ic2+1
        if(Cread(ic:ic).ne.' ') Return; Enddo; ic=0
        End    
*
************************************************************************
*
       Subroutine LINDINT(T00)
*      -----------------------
*
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       Common/SKY1/dEdx(MAXC1,10002),dEdxN1(MAXC1,10002),
     # Rp1(MAXC1,10002)
*
       Common/STARS1/ dSdX1(MAXC1,MAXC,10002), 
     # dEdXNuc1(MAXC1,MAXC,10002),  dEdXNuc0Ed1(MAXC1,MAXC,10002), 
     # dEdXNucEdTm1(MAXC1,MAXC,10002), CST1(MAXC1,MAXC,10002), NMAX
       Common/Edmin/Edmin ! It is not minimal displacement energy
       Common/BASIC/Z1,A1,Z2,A2,AW,RO,RN0  
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       Common/SUN/Vel1L(405),Tmean1,Vel2Tm(405),Vel3Pl(405),
     #            R1,R1p,Tplay1,Vel4(405),Nel(405)
*
       T=T00
       X=0.0
*
       IK=1  ! primary particle
*
*
*                                             Ziegler Range
       JE=idint((dlog10(T)+6.)*1000.)+1
                   If(JE.le.0.or.JE.gt.10002) Call error0(' JE ',11111)
*
* Ziegler Range for projectile
       RZ=Rp1(1,JE)
*
       RFULL=(1.+0.333333*A2/A1)*RZ     !  For effective A2
*
        DO 1000 ILIL=1,11111111
* Get "energy indicator number" for current T 
*   IDE corresponds only to the energy of primary particle (IK=1)
       Call INDICATOR(IK,T,IDE)
* general array index        
       JE=Idint((dlog10(T)+6.)*1000.)+1
                   If(JE.le.0.or.JE.gt.10002) Call error0(' JE ',11111)
*
c Define STEP for x(STEP) and dT (DT)
c (energy step is 0.01 from current energy of particles)
         STOPPING=dEdx(IK,JE)
         DT=0.01*T
         STEP=DT/STOPPING
*
         dSdx=0.0
         Do MK=1,NK
         dSdx=dSdx+dSdx1(IK,MK,JE)*FR(MK)
         Enddo
*
         Vel4(IDE)=Vel4(IDE)+dSdx*STEP
cc         Write(551,*)'T,STEP,VEL4,DT=',T,STEP,VEL4,DT
         T=T-DT
*
* stop option
         If(T.lt.EDmin) goto 2000
         X=X+STEP
***      if(X.gt.RFULL)  goto 2000
*                  
*
1000     Continue
                                                call error0('str ',1000)
2000     Continue
*
         Return
         End 
* August 2017 
* New Subroutine 
*
* 06.06.2011
* V, 20 K (Bjorkas, NIMB 267 (2009) 3204 )
*
*
* 13.12.2010
* Ti, 100 K (Bacon, JNM 276 (2000) 1 )
*
*
* 28.10.2010 
* Zr, 600K ( Gao, JNM 294 (2001) 288; Voskoboinikov NIMB 242 (2006) 68 )
*
*
* 17.09.2010 
* Al hinzugefgt (Bacon 276 (2000) 1, aber die Resultate sind von Almazouzi)
*
*
* 01.09.2010
* fr Cu CMD(4) korrigiert
*
*
* 23.03.2009
*
* Ni : Bacon (2000)
* Fe und Cr: Voertler (2008)
*
*
*Feb0107:   EdMD is added
*
************************************************************************
*
        Subroutine MDPARAM(IZ0,MDname, NOTE)
*       --------------------------------------------
        implicit real*8(A-H,O-Z)
        Character*500 NOTE,CID(999), MDname
        Common/MERCURY/CMD(5),Ecrit,EdMD,MD
                                            do i=1,999; cid(i)=' ';enddo
*
*
* Explanation of the information required to use MD results in the code
* =====================================================================
*
*
*  CID(jj)=' Z  ID  Identifier  any other information '
*
*      jj: any unique number from 1 to 999. This number does not play 
*          any special role.  It should not be given in asceding or 
*          in descending oder, can go  not in succession (mozhet idti 
*          ne podryad, imet' propuski). See below the example for 
*          iron (2 times)
*
*            Z : atomic number of material (Integer)
*
*                ID:  the label in the code, where the corresponding
*                     information is presented. See below "if(ID=="
*
*                   Identifier: corresponds to the name (MDname), which 
*                               will be used in the input- file to identify 
*                               the MD results. (!) Should have at least
*                               one space before and after (!). It is the
*                               3rd (!) word in each CID( )- line.
*
*                       any other information: any information, which will
*                                              appear in the output
*
* The number of spaces in CID( ) is not important.
* 
* Al
        CID(13)='13  13  Bacon (2000) und Almazouzi (1999)'
* Ti
        CID(22)='22  22  Bacon'
* V
        CID(23)='23  23   Bjorkas et al'
*
* Cr is taken = Iron  ("2601")
        CID(24)='24  2601   Voertler  (= Iron)'
*
* Fe (1) 
        CID(2)='26  2601   Voertler'
* Fe (2) 
        CID(1)='26  2602   Stoller '
* Ni
        CID(28)='28  28     Bacon'
* Cu
        CID(29)='29  29       Caturla et al'
* Zr
        CID(40)='40  40   Gao et al'
* W
        CID(74)='74   74  Caturla et al'
*
*
*
        Call Identify_MD_results(IZ0,CID,999, MDname, ID,Note)
*
*
        If(ID.eq.  13) goto   13 
        If(ID.eq.  22) goto   22
        If(ID.eq.  23) goto   23
        If(ID.eq.2601) goto 2601
        If(ID.eq.2602) goto 2602
        If(ID.eq.  28) goto   28
        If(ID.eq.  29) goto   29
        If(ID.eq.  40) goto   40
        If(ID.eq.  74) goto   74
                                                             goto 99999
c
*
*
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
*
*       a) C(1)-C(3)
*       b) C(4):   eMD(keV) the lowest energy, below which the 
*                    efficiency is a constant
*       c) C(5):   eMD(keV) the highest energy, above which the
*                    efficiency is a constant
*       d) Ecrit (keV):   eMD < Ecrit: MD;  eMD > Ecrit: BCA
*       e) EdMD (MeV): Ed used in MD for the comparison with NRT
*
* Note! eMD is not the incident ion energy, eMD is equal (approximately)
*         to the damage energy (Tdamage) in the NRT formula
*
*
*
c Aluminium
c ----------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
c
  13    CMD(1) = 0.544725  ! = 8.07 / (0.8/(2*Ed=0.027keV))
        CMD(2) =-0.17      ! = 0.83-1.
        CMD(3) = 0.0
        CMD(4) = 0.0
        CMD(5) = 20.0      !
        Ecrit  = 20.0      !  wenn hier 40 eV ist die bereinstimmung
*                               mit Reaktoren Daten ist schlimmer                
        EdMD   = 27.0e-06
        return
c
c Titanium
c --------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
c
  22    CMD(1) = 0.601
        CMD(2) =-0.2    
        CMD(3) = 0.0
        CMD(4) = 0.0
        CMD(5) = 20.0      !
        Ecrit  = 20.0      !
        EdMD   = 40.0e-06
        return
c
c Vanadium
c --------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
c
  23    CMD(1) = 0.40247
        CMD(2) = -0.30720
        CMD(3) = 3.0751E-03
        CMD(4) = 5.1707923e-03
        CMD(5) =    20.00
        Ecrit  =    30.00
        EdMD   = 40.0e-06
        return
c
c Eisen und Chrom
c ----------------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
*
* Voertler
*
 2601   CMD(1) = 4.6/10.
        CMD(2) = 0.71-1.
        CMD(3) = 0.0
        CMD(4) = 0.0
        CMD(5) = 20.0      !
        Ecrit  = 40.0      !  Ecrit.ne.CMD(5)
        EdMD   = 40.0e-06
        return
*
* Stoller
*
 2602   CMD(1) = 0.5608
        CMD(2) =-0.3029
        CMD(3) = 3.227e-03
        CMD(4) = 0.0
        CMD(5) = 40.0
        Ecrit  = 40.0
        EdMD   = 40.0e-06
        return
c
c Nickel
c ------
* General formula for efficiency :  eff=C(1)*eMD**C(2) + C(3)*eMD
c
  28    CMD(1) = 4.37/10.
        CMD(2) = 0.74-1.
        CMD(3) = 0.0
        CMD(4) = 0.0
        CMD(5) = 30.0      !
        Ecrit  = 40.0      !  Ecrit.ne.CMD(5)
        EdMD   = 40.0e-06
        return
c
c Copper
c ------
c
  29    CMD(1) = 0.7066
        CMD(2) =-0.437
        CMD(3) = 2.28E-03 
cccc        CMD(4) = 0.451
        CMD(4) = 0.45277
        CMD(5) = 20.00
        Ecrit  = 20.00
        EdMD   = 30.0e-06
        return
c
c Zirconium
c ---------
c
  40    CMD(1) =  0.39277
        CMD(2) = -0.61669
        CMD(3) =  7.7334E-03
        CMD(4) =  0.22
        CMD(5) =  25.
        Ecrit  =  25.
        EdMD   = 40.0e-06
        return
c
c Tungsten
c --------
c
  74    CMD(1) = 1.0184
        CMD(2) =-0.667
        CMD(3) = 5.06E-03
        CMD(4) = 1.0
        CMD(5) = 31.02
        Ecrit  = 31.02
        EdMD   = 90.0e-06
        return
*
*
*
99999   Print 1,IZ0
        Write(33,1)IZ0 
    1   Format(/' Parameters for calculation of efficiency',
     #  ' of defect production '/'           according to MD',
     #  ' are ABSENT for Z=',i3,'  !!!'/20x,'Check Subr. MDPARAM !'/)
        Print *,'Chiao !'
        Print *,'                      press any key...'
        pause
        stop
        end
*
*
************************************************************************
*
       Subroutine MODEL(IK,T0,P0,P0X,P0Y,P0Z,X0,Y0,Z0,IDE,IGEN,IDION) 
*      --------------------------------------------------------------
*
* IK  = 1 primary ion, 2,3,... =material component
* Example:
* dEdx(1,10002) is the full stopping power for the INITIAL particle +
*               composite material
* dEdx(2,10002) is the full stopping power for the FIRST component
*               of the material with the composite material  etc.
* dSdX1(1,1,10002) is the stopping power "considering defect production"
*               for the interaction of the INITIAL particle with 
*               the energy transfer to FIRST material component (this
*               PKA is moving in the media with the effective Z,A (see
*               separate code SL_LNSXX, XX=ver))
* dSdX1(1,2,10002) is for the INITIAL particle and energy
*               transfer to the SECOND material component
* dSdX1(2,1,10002) is for the FIRST material component and energy
*               transfer to the same FIRST material component
* dSdX1(2,2,10002) is for the FIRST material component and energy
*               transfer to the SECOND material component
* etc.
* NK            is the number of material components (max 7)
*
* IGEN          is the generation number (first PKA is 1)
* IDION         identifies the moving ion
*  
*
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
       Common/BASIC/Z1,A1,Z2,A2,AW,RO,RN0  
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       Common/Edmin/Edmin ! Edmin is not minimal displacement energy
       Common/STARS1/ dSdX1(MAXC1,MAXC,10002), 
     # dEdXNuc1(MAXC1,MAXC,10002), dEdXNuc0Ed1(MAXC1,MAXC,10002),
     # dEdXNucEdTm1(MAXC1,MAXC,10002), CST1(MAXC1,MAXC,10002), NMAX
       Common/SKY1/dEdx(MAXC1,10002),dEdxN1(MAXC1,10002),
     # Rp1(MAXC1,10002)
       Common/Interr/Interr1
       Common/SUN/Vel1L(405),Tmean1,Vel2Tm(405),Vel3Pl(405),
     #            R1,R1p,Tplay1,Vel4(405),Nel(405)
       Common/MOON/XX(105),DD(105),DDF(105),TK(105),HST
       Common/MEMORY/NFRENKEL(405)
       Common/SUN2/ZV5,Vel5,NN(405)
       Common/SATURN/TcritLAB(MAXC1)
       Common/WHATION/IDI
       Common/keytpka/keytpka
       Common/parpar/par_st1,par_st2
       Dimension CSS(MAXC)
*
* 
       T=T0
       Tcrit=TcritLAB(ik)
* general array index        
       JE=Idint((dlog10(T)+6.)*1000.)+1
                   If(JE.le.0.or.JE.gt.10002) Call error0(' JE ',11111)
*
*
*
         TplH1=0.0   ! Tplay for single history
*
  1      Continue      ! General loop
* Get "energy indicator number" for current T 
*   IDE corresponds only to the energy of primary particle 
*   and is not changed for any other generations
       Call INDICATOR(IK,T,IDE)
*
       If(IK.eq.1) NN(ide)=NN(ide)+1
*
*
* Estimation "elastic path" 
* general array index        
       JE=Idint((dlog10(T)+6.)*1000.)+1
                   If(JE.le.0.or.JE.gt.10002) Call error0(' JE ',11111)
* define total cross-section
       CSS(1)=FR(1)*CST1(IK,1,JE)
       If(NK.eq.1) goto 2
       DO MK=2,NK
       CSS(MK)=CSS(MK-1)+FR(MK)*CST1(IK,MK,JE)
       Enddo
 2     CSelT=CSS(NK)
                   If(CSelT.le.0.0) goto 2000
*
       dLel=1./(CSelT*RN0)  ! xsect in cm2
*
*
* STEP definition :
*
* Alternative  counting   DT0=dEdx(IK,JE)*STEP
! DT1 = only electronic component
       DT1=(   dEdx(IK,JE)-dEdxN1(IK,JE)  )
! DT2 = nucl stopp power for Tk < Ed
             dEdXNuc0Ed=0.0
             Do MK=1,NK 
             dEdXNuc0Ed=dEdXNuc0Ed+dEdXNuc0Ed1(IK,MK,JE)*FR(MK)
             Enddo 
       DT2=dEdXNuc0Ed
*
       DT3=DT1+DT2
* Free path/10.    ST1=dLel/10.
       ST1=par_st1*dLel
                                                      ST2=1.e+20
* Change of T = 0.05 due to el.loss and nucl.loss < Ed
*      If(DT3.gt.0.0) ST2=0.05*T/DT3
*
       If(DT3.gt.0.0) ST2=par_st2*T/DT3
       STEP=dmin1(ST1,ST2)
*
*
* Play if ELASTIC interaction occurs (for the transferring of the
* energy > Ed)
c
        PREL=STEP/dLel
        PR0=RANDOMg(0)
        IEL=0 
        COST=1.0
*
        if(PR0.le.PREL)               then
*"Elastic" interaction occurs !
        IEL=1
*
* Define (play) the type of the component of the composite material
        PR00=RANDOMg(0)
            If(NK.eq.1) then
            LK=1
            goto 3
            endif
        DO MK=1,NK 
        LK=MK
        If(PR00 .le. CSS(MK)/CSelt) goto 3
        ENDDO 
        print *,' It is not corr play:',CSS
  3     Continue
*
             Tmean=dEdXNucEdTm1(IK,LK,JE)/(CSelT*RN0)
        If(IK.eq.1 ) then 
             Nel(IDE)=Nel(IDE)+1
             DISPLL=dSdx1(IK,LK,JE)/(CSelT*RN0)
             Vel1L(IDE)=Vel1L(IDE)+DISPLL
ccc             Tmean=dEdXNucEdTm1(IK,LK,JE)/(CSelT*RN0)
             Tmean1=Tmean+Tmean1
             Vel2Tm(IDE)=Vel2Tm(IDE)+CF(LK+1,LK,Tmean)   ! LK
                      endif
* play T of PKA basing on dS/dT above Ed
        if(keytpka.lt.0) then
                         TPVA=  TPKAOLD(IK,LK,T,Tmean)                
                         else
                         TPVA=  TPKA(IK,LK,T,Tmean)                
                         endif
*
        if(IK.eq.1)  then
           Tplay1=Tplay1+TPVA
           Vel3Pl(IDE)=Vel3Pl(IDE)+CF(LK+1,LK,TPVA)     ! LK
                     endif
* 
******* If(T.le.Tcrit) goto 7000    !   MD
        Call smoothtransition(T,Tcrit,iweiter)
                                               if(iweiter==0) goto 7000
*
        CALL AFTER_INTERACTION(IK,LK,T,P0, P0X, P0Y, P0Z, TPVA,
     $                                 PVA,PVAX,PVAY,PVAZ)
*
        TplH1=TplH1+TPVA   ! Tplay for single history
*
*
******* If(TPVA.gt.Tcrit) then
        Call smoothtransition(TPVA,Tcrit,iweiter)
                                               if(iweiter==0) goto 6000

* identify new atom 
        IDI=IDI+1
*
        IGENPKA=IGEN+1
        Call WRITE99B(IK,LK,TPVA,X0,Y0,Z0,IGENPKA,IDION,IDI,T)
*
        CALL STORE_IN(LK,TPVA,PVA,PVAX,PVAY,PVAZ,X0,Y0,Z0,IDE,IGENPKA,
     @                IDI)
* number of Frenkel pairs
        NFRENKEL(IDE)=NFRENKEL(IDE)+1      
                                                              goto 6001
*******                   else  ! do not remember this particle
* MD
 6000                     Frcut=0.0  
        If(TPVA.gt.0.0)   FRcut=CF2(LK+1,LK,TPVA) +0.5
        NFRENKEL(IDE)=NFRENKEL(IDE)+Idint(FRcut)
******                    endif
 6001   continue 
*
********If(T.le.Tcrit) goto 7000    !   MD
        Call smoothtransition(T,Tcrit,iweiter)
                                               if(iweiter==0) goto 7000
*
*
        If(dsqrt(X0**2+Y0**2+Z0**2).le.ZV5) Vel5=Vel5+1.
*
        Do IR=1,105
        If(Z0.le.XX(IR)) then
        DDF(IR)=DDF(IR)+ 1.  ! Direct summing
        goto 499
        endif
        enddo
*
*
499     If(IK.ne.1) goto 510
        Do IR=1,105
        If(Z0.le.XX(IR)) then
        DD(IR)=DD(IR)+ DISPLL  ! Lindhard component is summing
        goto 500
        endif
        enddo
                                      endif !  if(PR0.le.PREL)
 500    continue
*End ---elastic
*
        Do IR=1,105
        If(Z0.le.XX(IR)) then
        TK(IR)=TK(IR)+ T*STEP
        goto 510
        endif
        enddo
*
510     continue
ccc        Write(777,*)(DT1+DT2)*STEP/T
*
******  If(T.le.Tcrit) goto 7000    !   MD
        Call smoothtransition(T,Tcrit,iweiter)
                                               if(iweiter==0) goto 7000
*
*
        T2=T-DT3*STEP
        If(T2.le.0.0) goto 550
        P2=dSqrt(T2/T)*P0
        P0X=P0X*P2/P0
        P0Y=P0Y*P2/P0
        P0Z=P0Z*P2/P0
        P0=P2
        T=T2
550     continue
*
*
******  If(T.le.Tcrit) goto 7000    !   MD
        Call smoothtransition(T,Tcrit,iweiter)
                                               if(iweiter==0) goto 7000
*
* stop option
*
cccccc      If(TplH1.gt.T00) then
cccccc      Interr1=Interr1+1
cccccc      goto 2000
cccccc      endif
*
* usual end of history
         If(T.lt.EDmin) goto 2000
         X0=X0+STEP*(P0X/P0)
         Y0=Y0+STEP*(P0Y/P0)
         Z0=Z0+STEP*(P0Z/P0)
*
*
*
         Goto 1
*
*
*
2000     continue
         Call WRITE99C(IK,IDION,T,X0,Y0,Z0,IGEN)
         If(IK.eq.1) then 
         R1=R1+dSqrt(X0**2+Y0**2+Z0**2)
         R1p=R1p+Z0  
                     endif
         Return
*
*
*
* Interrupt history taking MD results for the rest energy
7000    continue
*noalloy, because
        LK=1
                       Frcut=0.0  
cccc    If(T.gt.0.0)   FRcut=CF2(LK+1,LK,T) +0.5
        If(T.gt.0.0)   FRcut=CF2(IK,LK,T) +0.5
        NFRENKEL(IDE)= NFRENKEL(IDE)+idint(FRcut)
        goto 2000 
c
c
        End 
C
C
************************************************************************
      Real*8 FUNCTION  NAIGUS(A,B,F,EPS,MAX,IER)
************************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
C  Calculation of def. integral using Gauss formula
      DIMENSION          Z(8),C(8)
      DOUBLE PRECISION  Z,C,H,ARG,HAG,SUM,IN,IN1,X,S1,Q
c     REAL*8 NAIGUS
      DATA              Z(1)/0.01985507D0/
      DATA              Z(2)/0.10166676D0/
      DATA              Z(3)/0.23723379D0/
      DATA              Z(4)/0.40828268D0/
      DATA              Z(5)/0.59171732D0/
      DATA              Z(6)/0.76276621D0/
      DATA              Z(7)/0.89833324D0/
      DATA              Z(8)/0.98014493D0/
      DATA              C(1)/0.05061427D0/
      DATA              C(2)/0.11119052D0/
      DATA              C(3)/0.15685332D0/
      DATA              C(4)/0.18134139D0/
      DATA              C(5)/0.18134139D0/
      DATA              C(6)/0.15685332D0/
      DATA              C(7)/0.11119052D0/
      DATA              C(8)/0.05061427D0/
      IER = 0
      SUM = 0.0
      IN = 0.0
      IN1 = 0.0
      H = B -A
      ARG = A
      N = 1
      N2 = 1
      HAG = H
    5 DO 20 K = 1,N2
        DO 10 I = 1,8
          X = ARG + HAG*Z(I)
          S1 =C(I)*F(X)
          SUM = SUM+S1
   10   CONTINUE
        ARG = ARG+HAG
   20 CONTINUE
      IN1 = HAG*SUM
      Q = ABS(IN1-IN)
      IF (Q .LT. EPS) GO TO 40
      IF (N .GT. MAX) GO TO 30
      N = N+1
      N2 = N2*2
      HAG = HAG/2
      ARG = A
      IN = IN1
      SUM = 0.0
      GO TO 5
   30 IER = 1
   40 NAIGUS =IN1
      RETURN
      END
* 
*
************************************************************************
*
        Subroutine NHIST_default(T,NT, NHIST)
*       -------------------------------------
        implicit real*8(A-H,O-Z)
        Character*500 Cline,C,CLabel
        Dimension T(12345),NHIST(12345)
*
        Do i=1,NT
        E=T(i)
                           MC= 50 
           if(E < 10.0d0 ) MC=100
           if(E <  1.0d0 ) MC=500

        NHIST(i)=MC
        Enddo 
*
        Return
*
*
80001  CLabel=' 80001'; goto 88888
80002  CLabel=' 80002'; goto 88888
80003  CLabel=' 80003'; goto 88888
80004  CLabel=' 80004'; goto 88888
80005  CLabel=' 80005'; goto 88888
80006  CLabel=' 80006'; goto 88888
80007  CLabel=' 80007'; goto 88888
80008  CLabel=' 80008'
88888  Print '(a)',
     c'Energie(s) or number of MC events is entered incorrect!'
       Print '(2a/a)','Subr. NHIST_default      Label ',
     c Clabel(1:7),'     Read rules in "read.me!"'
       print *,'                              press <Enter>...'   
       pause;   stop
90000  print *,' T O O   M U C H   I N P U T   E N E R G I E S  (E)!'
       print *,' Change parameter MAXE in the code !'
       print *,'                                 press any key...'
       pause; stop
       End
*
************************************************************************
*
          Subroutine NRT_COEFF(Z1,Z2,A1,A2,ANRT,BNRT,GNRT)
*         -----------------------------------------------
          implicit real*8(A-H,O-Z)
          PI=3.1415926
          A0=0.52918E-08    ! Bohr radius, cm
          EL=4.8E-10        ! electron charge
C Classical NRT, Nucl.Eng.Des., 1975 :
C         RK0=0.1337*(Z1**(1./6.))*DSQRT(Z1/A1)                            
C Robinson
          RK0=0.0793*(Z1**0.6666666)*DSQRT(Z2)*((A1+A2)**1.5)/        (
     #    (A1**1.5)*DSQRT(A2)*((Z1**0.666666666+Z2**0.66666666)**0.75))
C
          AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )/
     #          DSQRT(Z1**0.6666666+Z2**0.6666666)
          E0=Z1*Z2*(EL**2)*(A1+A2)/(AA*A2)
            E0=E0/1.6E-06    !  erg ---> MeV
            E0=1000.*E0      !      ---> keV
            EE=1./E0
C
         ANRT=RK0*EE         
         BNRT=0.40244*RK0*(EE**0.75)                                          
         GNRT=3.4008*RK0*(EE**0.1666666666)                                   
         RETURN
         END
*
*
************************************************************************
*
       Subroutine Output_filenames(Cline,OUTNAM,OUTNAM2,OUTNAM3)
       implicit real*8(A-H,O-Z)
       Character*500 Cline,OUTNAM,OUTNAM2,OUTNAM3
*   
*
       NN=iwords(Cline)
*
* default names will be assigned
       If(NN==0)                                   Then    
          OUTNAM ='output.001'        
          OUTNAM2='output.002'        
          OUTNAM3='output.003'        
                                                   Endif
* Only one name is given
       If(NN==1)                                   Then
       Call Lesen_ein_Wort(CLine,1,OUTNAM,ice)
                                              Call ENTLUECKEN(OUTNAM,il)
       OUTNAM2=OUTNAM(1:il)//'.2'
           write(6,'(a50)')OUTNAM2(1:50)
       OUTNAM3=OUTNAM(1:il)//'.3'
                                                   Endif
* Two names are given
       If(NN==2)                                   Then
       Call Lesen_ein_Wort(CLine,1,OUTNAM,ice)
       Call Lesen_ein_Wort(CLine,2,OUTNAM2,ice)
                                              Call ENTLUECKEN(OUTNAM,il)
       OUTNAM3=OUTNAM(1:il)//'.3'
                                                   Endif
* Three or more names are given    
       If(NN>=3)                                   Then
       Call Lesen_ein_Wort(CLine,1,OUTNAM,ice)
       Call Lesen_ein_Wort(CLine,2,OUTNAM2,ice)
       Call Lesen_ein_Wort(CLine,3,OUTNAM3,ice)
                                                   Endif
       Return
       End          
*
************************************************************************
*
        Subroutine PRECALCULATION
*       -------------------------
        parameter (maxc=21,maxc1=22,maxe=50001)
        implicit real*8(A-H,O-Z)
        Character INPNAM_XS*500, INPNAM_DEDX*500, OUTNAM*500
        Character CTASK_NAME*80, C50*500, cformat*500
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/PKA/ALPHA2(MAXC1,MAXC),E0(MAXC1,MAXC)
        COMMON/NRT1/ANRT(MAXC1),BNRT(MAXC1),GNRT(MAXC1)
        Common/Edmin/Edmin 
        Common/PARAM01/IDSDT
        Common/FILENAMES/INPNAM_XS(MAXC1,MAXC),INPNAM_DEDX(MAXC1),
     #  OUTNAM
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
        Common/DATATAB1/WTAB(101),ROTAB(101),RITAB(101),IATAB(101)
        Common/ISTOP/ISTOP
        Common/VENUS/RI(MAXC)
        Common/EARTH/CTASK_NAME,C50
        Common/AUX1/rlambdaft12,rmft12,qft12
        Common/SATURN/TcritLAB(MAXC1)
        Common/EIN/EIN(MAXE),NH(MAXE),KEIN
        Common/events_printing/ieveprint
        Common/Sep0717/i_ecrit_input
        Common/Sep1317/inordlund
        Common/URANUS/carc,barc,MDarc
        Dimension TmpEn(MAXE)
*
                            AVO=6.022E+23     ! Avogadro
        IZ1=idint(Z1+0.001)
*
* Get masses, density and <I> 
        Call DATATAB
* 
* Get projectile A, if absent
        If(A1.le.0.0) then 
                      A1=WTAB(IZ1)
                      endif
                      If(A1.le.0.0) Call error0(' A1 ',000)
                      IA1=idint(A1+0.001) 
* 
* Get A for material components, if absent
        do i=1,nk
        If(AT(i).le.0.0) then 
                      IZT=idint(ZT(i)+0.001)              
                      AT(i)=WTAB(IZT)
                      endif
                      If(AT(i).le.0.0) Call error0(' AT ',i)
        enddo
*
* Density
        if(RO.le.0.0) then
                      IZT=idint(ZT(NK)+0.001)  ! check for NK=1 in sub read_inp
                      RO=ROTAB(IZT) 
                      endif
                      If(RO.le.0.0) Call error0(' RO ',NK)
* 
* Mean ionization potential for SPAR calculation, if chosen
        if(istop.eq.1) then
        do i=1,nk
        IZT=idint(ZT(i)+0.001)              
        RI(i)=RITAB(IZT)*1.E-6  ! eV --> MeV (SPAR)
        If(RI(i).le.0.0) Call error0(' RI ',i)
        enddo
                       endif
*
*
* Normalize fractions on unity
           sum=0.0
           do i=1,nk
           sum=sum+FR(i)
           enddo
           Do i=1,nk
           FR(I)=FR(I)/SUM
           Enddo
*
* Get effective Z and A
           Z2=0.0
           A2=0.0
        Do i=1,nk
        Z2=Z2+FR(I)*ZT(I)
        A2=A2+FR(I)*AT(I)
        Enddo
           AW=A2
*
* Atoms (molecules)
        RN0=AVO*RO/AW     ! at/cm3
        DA=(1./RN0)**0.33333333  ! ave dist betw at (not used)
*
* Min ED for the composite material
* ! Edmin is not minimal displacement energy
        Edmin=1.E+10
        do i=1,nk
        If(ED(i).lt.Edmin) Edmin=ED(i)
        enddo
*
* omit input energies < Edmin
        ke=0        
        Do i=1,KEIN
        If(EIN(i).ge.Edmin) then
        ke=ke+1
        TmpEn(ke)=EIN(i)
                            endif
        Enddo
        Do i=1,ke
        EIN(i)=TmpEn(i)
        Enddo
        KEIN=KE
*
        NK1=NK+1
* 
* NRT coefficients for effective material Z,A
        Do IK=1,NK1
         If(IK.eq.1) then
                     Z111=Z1
                     A111=A1
                     endif
         If(IK.ne.1) then
                     Z111=ZT(IK-1)
                     A111=AT(IK-1)
                     endif
        Call NRT_COEFF(Z111,Z2,A111,A2,ATRN,BTRN,GTRN)
        ANRT(IK)=ATRN
        BNRT(IK)=BTRN
        GNRT(IK)=GTRN
        Enddo
*
* For joint BCA-MD calculations define "critical" energy for each ion
       If(MD.eq.1) Call CRITICAL_ENERGY
*
*
* Data for Lindhard F(x) function
* -------------------------------
          PI=3.1415926
          EL=4.8E-10        ! electron charge
          A0=0.52918E-08    ! cm
*
* IK =1, 2...  1 = projectile, other material component
* MK =1, 2...    = material component
*
*
         DO IK=1,NK1
         If(IK.eq.1) then
                     Z111=Z1
                     A111=A1
                     endif
         If(IK.ne.1) then
                     Z111=ZT(IK-1)
                     A111=AT(IK-1)
                     endif
         DO MK=1,NK
         Z222=ZT(MK) 
         A222=AT(MK) 
c
* LNS:
          AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )
     #         /DSQRT(Z111**0.6666666+Z222**0.6666666)
* Firsov
          If(IDSDT.ne.0) 
     #    AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )
     #         /(   ( DSQRT(Z111)+DSQRT(Z222) )**0.666666666   )
*
*
          E0(IK,MK)=Z111*Z222*(EL**2)*(A111+A222)/(AA*A222)
            E0(IK,MK)=E0(IK,MK)/1.6E-06    !  erg ---> MeV
          ALPHA2(IK,MK)=4.*A111*A222/((A111+A222)**2)
          PIA2=Pi*(AA**2)            
          ENDDO 
          ENDDO 
*
*********************************************************************
* open main output file and write basic information 
*
        open(33,file=OUTNAM)
        Write(33,*)' I O T A   C O D E'
        Write(33,'(a80)')CTASK_NAME
        Write(33,*)' '
*
        Write(33,1000)IZ1,A1
 1000   Format(1x,'Primary ion (Z,A)',i3,f8.2) 
        Write(33,1001)
 1001   Format(' Material      at %    Ed (eV)')
        Do IK=1,NK
        IZ=Idint(ZT(IK)+0.0001)
        FR0=FR(IK)*100.
        Write(33,1002)IZ,AT(ik),FR0,ED(IK)*1.e+06
 1002   Format(i3,f8.2,f9.2,f9.1)
        Enddo
        If(IDSDT.eq.0) Write(33,1003)rlambdaft12,rmft12,qft12
 1003   Format(' F(t1/2) function: LNS   L=',f6.3,
     #  '  m=',f6.3,'  q=',f6.3)
        If(IDSDT.ne.0) Write(33,1004)
 1004   Format(' F(t1/2) function: Burenkov et al')
*

        If(MD==0) goto 8000
*
* MD and arc-dpa
*
         If(MDarc==0)                                        Then ! 1)
* MD
          Write(33,'(/t27,a)')'Joint BCA-MD simulation'
                                                 Call LetzteZ(C50,ic50) 
          Write(33,'(2a)')' Parameterized MD results : ',C50(1:ic50)

          If(i_ecrit_input==1) then
          Write(33,'(a,f7.2,2a)')
     c   ' MD results are used below eMD energy (Ecrit) =',ECRIT,' keV',
     c   ' (from input)'
                               else
          Write(33,'(a,f7.2,a)')
     c   ' MD results are used below eMD energy (Ecrit) =',ECRIT,' keV'
                               endif
                                                            Else  ! 1)
* arc-dpa
          Write(33,'(/t27,a)')'BCA + arc-dpa simulation'
          If(inordlund==0) then
           Write(33,'(a,t32,a,f8.5,a,f9.5,a)')
     c      ' arc-dpa : systematics','( Carc=',carc,' Barc=',barc,' )'
                           else 
           Write(33,'(a,t32,a,f8.5,a,f9.5,a)')
     c      ' arc-dpa : Nordlund','( Carc=',carc,' Barc=',barc,' )'
                           endif 
          If(i_ecrit_input==1) then
          Write(33,'(a,f7.2,a)')
     c   ' arc-dpa model is used below eMD energy (Ecrit) =',ECRIT,
     c  ' keV (from input)'
                               else
          Write(33,'(a,f7.2,a)')
     c   ' arc-dpa model is used below eMD energy (Ecrit) =',ECRIT,
     c  ' keV'
                               endif
                                                            Endif ! 1)
*
       if(TcritLAB(1)*1000..lt.1.e+3)                          then
        Write(33,7021)TcritLAB(1)*1000.,TcritLAB(2)*1000.
7021    Format(' Corresponding projectile energy =',f7.2,' keV, target i
     con energy =',f7.2,' keV')
                                                               else
        Write(33,7022)TcritLAB(1)*1000.,TcritLAB(2)*1000.
7022    Format(' Corresponding projectile energy =',g12.5,' keV, target 
     cion energy =',f7.2,' keV')
                                                              endif

        If(TcritLAB(1).ge.100.) Write(33,7023)TcritLAB(1)
7023    Format(70('*')/'*         Energy Tcrit =',g12.5,' MeV',
     #  ' is not realistic',T70,'*'/70('*'))
*
        If(MDarc==0)                                         Then ! 2)
             Write(33,703)(CMD(i),i=1,3)
703          Format(' efficiency(MD)=',f7.4,'*( eMD**(',f8.4,') ) +',
     #       1pe10.3,'*eMD')
             Write(33,704)CMD(4),CMD(5)
704          Format(' constant efficiency(MD) below',f7.3,
     c' keV and above',f7.2,' keV'/)
                                                             Else ! 2)
      Write(33,'(2a/)')' efficiency(arc)=(1.-Carc)*',
     c  ' { [( 0.8d0/(2.*Ed(keV)) ) *Tdam]**Barc }+Carc'
                                                             Endif ! 2)

 8000   If(istop.eq.-1) Write(33,*)' Stopping power: Ziegler, SRIM'
        If(istop.eq. 1) Write(33,*)' Stopping power: Armstrong, SPAR'
*
*
          Write(33,1005)RO,RN0
 1005     Format(' Density =',f8.4,' g/cm3    n0=',1pe12.5,' 1/cm3')
          Write(33,1006)Z2,A2
 1006     Format(' Z(eff) =',f6.2,'    A(eff)=',f7.2)
          Write(33,1007)
 1007     Format(' Note. Nuclear nonelastic interactions ',
     #    'are not considered here')
*
* Write general information in "events" file
        If(ieveprint/=0) then
                              open(99,file='events')
                         else
                              open(99,status='scratch')
                         endif
        Write(99,*)' RECORDS OF SUCCESFUL INRTERACTIONS RESULTING',
     #  ' IN ATOM DISPLACEMENTS'
        Write(99,*)' '
        Write(99,'(a80)')CTASK_NAME
        Write(99,*)' '
        Write(99,1000)IZ1,A1
        Write(99,1008)
 1008   Format(4x,' Material      at %    Ed (eV)')
        Do IK=1,NK
        Write(99,1009)IK,Idint(ZT(IK)+0.0001),AT(ik), FR(IK)*100.,
     #                ED(IK)*1.e+06
 1009   Format(i2,')',i4,f8.2,f9.2,f9.1)
        Write(99,*)' '
        Enddo
        Return
        End 
* 
*
************************************************************************
*
       Subroutine PRINT(T0,Nhist)
*      --------------------------
       implicit real*8(A-H,O-Z)
       parameter (maxc=21,maxc1=22)
       Character INPNAM_XS*500, INPNAM_DEDX*500, OUTNAM*500
       Character CTdamageNRT*15
       Common/FILENAMES/INPNAM_XS(MAXC1,MAXC),INPNAM_DEDX(MAXC1),
     # OUTNAM
*
       Common/BASIC/Z1,A1,Z2,A2,AW,RO,RN0  
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       Common/SKY1/dEdx(MAXC1,10002),dEdxN1(MAXC1,10002),
     # Rp1(MAXC1,10002)
       Common/SUN/Vel1L(405),Tmean1,Vel2Tm(405),Vel3Pl(405),
     #            R1,R1p,Tplay1,Vel4(405),Nel(405)
       Common/STARS1/ dSdX1(MAXC1,MAXC,10002), 
     # dEdXNuc1(MAXC1,MAXC,10002), dEdXNuc0Ed1(MAXC1,MAXC,10002),
     # dEdXNucEdTm1(MAXC1,MAXC,10002), CST1(MAXC1,MAXC,10002), NMAX
       Common/Interr/Interr1
       Common/MOON/XX(105),DD(105),DDF(105),TK(105),HST
       COMMON/MAIIPR/IPR1                                                
       COMMON/MEMORY/NFRENKEL(405)
       Common/CUT1/rmaxpl,itot,icut
       Common/OPTIONS1/igraph,maxplay
       Common/EKIN1/EKIN(405),HEK,MEK ! MEK can be less than 405
       Common/SUN2/ZV5,Vel5,NN(405)
       Common/SUNDI/DIVel1(405),DIFRENKEL(405),DIVel5
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
       Common/ISTOP/ISTOP
       Common/Sep0817/Tdamage
       Common/URANUS/carc,barc,MDarc
       Dimension EKIN2(405)
*
* Output file is opened in Subr. Read_input
*
*
       JE=Idint((dlog10(T0)+6.)*1000.)+1
                   If(JE.le.0.or.JE.gt.10002) Call error0(' JE ',11111)
* SRIM or SPAR range for projectile
       RZ=Rp1(1,JE)
       if(istop.eq.-1) RFULL=(1.+0.333333*A2/A1)*RZ     !  for effective A2
       if(istop.eq. 1) RFULL=RZ                      
*
*
            RNel=0.0
            Do i=1,405
            RNel=RNel+dfloat(Nel(i))/dfloat(Nhist)
            Enddo
*
        Do i=1,405
        Vel1L(i) =Vel1L(i) /dfloat(Nhist) 
        Vel2Tm(i)=Vel2Tm(i)/dfloat(Nhist)
        Vel3Pl(i)=Vel3Pl(i)/dfloat(Nhist)
        Enddo
*
        Vel5=Vel5/dfloat(Nhist)
*
* Sum
              Vel1LS =0.0
              Vel2TmS=0.0
              Vel3PlS=0.0
              Vel4S  =0.0
        Do i=1,405
        Vel1LS =Vel1LS +Vel1L(i)
        Vel2TmS=Vel2TmS+Vel2Tm(i)
        Vel3PlS=Vel3PlS+Vel3Pl(i)
        Vel4S  =Vel4S  +Vel4(i)  
        Enddo
*
* delta = Root[ M(ksi**2) -M**2 ] /M
        DIS1= DIVel1(405)/dfloat(Nhist) -Vel1LS**2 
* additional dividing /N  (  see Barashenkov,Toneev (4.6)  )
        DIS1= DIS1/dfloat(Nhist)
        DEL11=SQRT1(  DIS1  )
                          ERR1=100.
        If(Vel1LS.ne.0.0) ERR1=100.*DEL11/Vel1LS
*
        Tmean1=Tmean1/dfloat(Nhist)
        Tplay1=Tplay1/dfloat(Nhist)
        R1=R1/dfloat(Nhist)
        R1p=R1p/dfloat(Nhist)
ccccc   Vel4=Vel4/dfloat(Nhist)
*
        If(MD.eq.1)                             then
        if(MDarc==0) then 
          Write(33,701)
701       Format(35(1H*),'BCA+MD',37(1H*))
                     else
          Write(33,7011)
7011      Format(33(1H*),'BCA+arc-dpa',34(1H*))
                     endif 
                                                else
        Write(33,1)
1       Format(78(1H*))
                                                endif
        Write(33,2)T0, Nhist
2       Format(1x,'Primary energy ',1pg12.5,' MeV'/1x,
     #  ' Number of events ',i7) !1x,60('-'))
*
        CFNRT=0.0
                    TdamageNRT=0.0
        CFARC=0.0
        Do MK=1,NK
*Feb0107
        if(MD.eq.0) then 
        CFNRT=CFNRT+CF(1,MK,T0)*FR(MK)
                    else
*noalloy, check:
        CFNRT=CFNRT+CFEDMD(1,T0)*FR(MK)
                    endif 
* it is reasonable only for NK=1 :
        TdamageNRT=TdamageNRT+Tdamage*FR(MK)
        Enddo   
      
* only for NK=1:
        if(MDarc/=0) CFARC=CFARC+CFEDMD_arc(1,T0)

                        CTdamageNRT=' '
        If(NK==1) Write(CTdamageNRT,'(1pg15.5)')TdamageNRT
*
        Write(33,*)'                             ',
     #  '                           error %      /NRT '
        If(MD.eq.0)                                             Then

        If(NK/=1) thEn
        Write(33,30)CFNRT,1.0
30      Format(1x,
     #  'NRT-formula prediction for Z(eff), A(eff)   =',g12.5
     #  ,t69,f6.3,'  (1)')
                  elSe
        Write(33,3000)CFNRT,1.0
3000    Format(1x,
     #  'NRT-formula prediction                      =',g12.5
     #  ,t69,f6.3,'  (1)')
                  enDif 
                                                               Else
        Write(33,301)EdMD*1.e+6,CFNRT,1.0
301     Format(1x,
     #  'Simple NRT-formula prediction (Ed=',f5.1,' eV) =',g12.5
     #  ,t69,f6.3,'  (1)')
                                                               Endif  
*Feb(end)
*
        If(MD.eq.0) Write(33,3)Vel1LS,ERR1, R_atio(Vel1LS,CFNRT)
3       Format(1x,
     #'Number of vacancies (Lindhard, free path )  =',f8.2,
     # '  (',f6.2,')'
     #  ,t69,f6.3,'  (2)')
*
        Write(33,31)Vel4S,R_atio(Vel4S,CFNRT)
31      Format(1x,
     #'Number of vacancies (Lindhard, integration) =',f8.2
     #  ,t69,f6.3,'  (3)')
*
        FRENK1=0.0
        Do i=1,405
        FRENK1=FRENK1+dfloat(NFRENKEL(i))/dfloat(Nhist) 
        Enddo

* delta 
        DISF=  DIFRENKEL(405)/dfloat(Nhist) - FRENK1**2
        DISF=  DISF/dfloat(Nhist)
        DELF=SQRT1(  DISF )
                          ERRF=100.
        If(FRENK1.ne.0.0) ERRF=100.*DELF/FRENK1
*
        Write(33,32)
32      Format(76('-'))

        Write(33,9)FRENK1,ERRF,R_atio(FRENK1,CFNRT)
9       Format(1x,
     #  'Number of Frenkel pairs (direct counting)   =',f8.2
     #  ,'  (',f6.2,')'
     #  ,t69,f6.3,'  (4)')
*
* unit=55
        If(NK==1)                                            then  ! 1)
          If(MDarc==0)    then
        Write(55,555)
     c  T0, R_atio(FRENK1,CFNRT),   FRENK1, CFNRT, TdamageNRT
555     Format(1pg12.5,  0pf8.3,  f13.2,  f14.2, 1pg15.5)
                          else
        Write(55,5551)
     c  T0, R_atio(FRENK1,CFNRT),   FRENK1, CFNRT, TdamageNRT, 
     c    R_atio(CFARC,CFNRT), CFARC
5551    Format(1pg12.5,  0pf8.3,  f13.2,  f14.2, 1pg15.5, 0pf10.3,f13.2)
                          endif  
                                                             else  ! 1)
        Write(55,5552)
     c  T0, R_atio(FRENK1,CFNRT),   FRENK1, CFNRT
5552    Format(1pg12.5,  0pf8.3,  f13.2,  f14.2)
                                                             endif ! 1)
*
*
        Write(33,32)
*
* "Modified" counting = direct count *0.8 ( "as in NRT" )
        If(MD.eq.0) Write(33,10)0.8*FRENK1, ERRF, 
     c                                          0.8*R_atio(FRENK1,CFNRT)
10      Format(1x,
     #  'Modified counting                           =',f8.2
     #  ,'  (',f6.2,')'
     #  ,t69,f6.3/)
*
        CFTRN=0.0
*
* NRT formula for pure material weighted with given fractions
        If(NK.eq.1) goto 1000 
* 
        CFTRN=0.0
        Do MK=1,NK
             Z222=ZT(MK)
             A222=AT(MK)
             ED2=ED(MK)
        Call NRT_COEFF(Z1,Z222,A1,A222,ATRN,BTRN,GTRN)
        CFTRN=CFTRN+FR(MK)*CF1(ED2,ATRN,BTRN,GTRN,T0)
        Enddo
        Write(33,11)CFTRN  
11      Format(1x,
     #  'NRT-formula for pure material components weighted =',f8.2
     #  ,T69,'      ','  (5)')
 1000   continue
*
        If(MD.eq.0) Write(33,4)Vel2TmS,R_atio(Vel2TmS,CFNRT)
4       Format(1x,
     #  'Number of vacancies from Tmean calc               =',f8.2
     #  ,t69,f6.3)
*
        If(MD.eq.0) Write(33,5)Vel3PLS,R_atio(Vel3PLS,CFNRT)
5       Format(1x,
     #  'Number of vacancies from Tplay calc               =',f8.2
     #  ,t69,f6.3)
*
* Get displacement cross-sections
* Lindhard, code SL_LNS :
        CSDL=0.0
        Do MK=1,NK
        CSDL=CSDL+FR(MK)*dSdx1(1,MK,JE)/RN0
        Enddo
        CSDL=CSDL*1.e+24
* Direct counting :
cc        CSelT=0.0
cc        DO MK=1,NK
cc        CSelT=CSelT+FR(MK)*CST1(1,MK,JE)
cc        Enddo
cc        Call INDICATOR(1,T0,IDE)
cc        if(IDE.eq.1) EKINCHECK=0.5*  EKIN(ide) 
cc        if(IDE.ge.1) EKINCHECK=0.5*( EKIN(ide)+ EKIN(ide-1) )
cc        CSDDIR1=CSelT*dfloat(NFRENKEL(ide))/NN(ide) !dfloat(Nhist)
cc        CSDDIR1=CSDDIR1*1.e+24
c
ccccc        CSDDIR3=CSelT*1.e+24*Vel1L(ide)*dfloat(Nhist)/NN(ide)
cc
        CSDDIR=1.e+24*Vel5/(RN0*ZV5)
* 
* delta
        DISCS= DIVEL5/dfloat(Nhist) - Vel5**2
        DISCS= DISCS/dfloat(Nhist)
        DELCS=SQRT1(  DISCS )
                                          ERRCS=100.
        If(CSDDIR.ne.0.0.and.Vel5.ne.0.0) ERRCS=100.*DELCS/Vel5
*
        If(NK.eq.1) Write(33,51)CSDL
  51    Format(/
     #  ' Displacement cross-section (Lindhard, integr)   (b) =',
     #  1pg12.5,
     #  T69,'      ','  (6)')
        If(NK.ne.1) then
        Write(33,52)CSDL
  52    Format(/
     #  ' Displacement cross-section (Lindhard, weighted) (b) =',
     #  1pg12.5,
     #  T69,'      ','  (6)')
        Write(33,53) (dSdx1(1,MK,JE)/(1.e-24*RN0),MK=1,NK)
  53    Format(' Components: ',1pg12.5,4g12.5)
                     endif
        If(MD.eq.0) Write(33,54)CSDDIR,ERRCS
  54    Format(
     #  ' Displacement cross-section (direct counting)    (b) =',
     #  1pg12.5,  ' (',  0pf6.2,   ') (7)' )
*
        If(MD.eq.0) Write(33,55)0.8*CSDDIR,ERRCS
  55    Format(
     #  '                            (modified count )    (b) =',
     #  1pg12.5,  ' (',  0pf6.2,   ')    ')
    
* Tdamage only for 1-component material 
        IF(NK==1)                                               then
                        Write(33,56)TdamageNRT
  56    Format(' Damage energy (Tdamage) from NRT formula (keV)      =',
     c  1pg12.5,t77,'(8)')
          If(MDarc==1) then
                        Write(33,57)CFARC, R_atio(CFARC,CFNRT)
  57    Format(' Number of displacements due to pure arc-dpa formula ='
     c, f12.2, f8.3,'  (9)'/)
                       else
        Write(33,*)
                       endif
                                                                endif

ccc        Write(33,*)EKINCHECK
*
*
                  XXX3=Vel1LS; XXX8=CSDDIR
        If(MD==1) then; XXX3=0.0   ; XXX8=0.0; endif

* unit=44
        If(NK==1)                                             then  ! 1)
          If(MDarc==0) then
        Write(44,111)T0,CFNRT,XXX3,Vel4S,FRENK1,CFTRN,CSDL,XXX8,
     c  TdamageNRT
 111    Format(1pg12.5,   0pf10.2,  4f10.2,1pg12.4,g12.4,g15.5)
                       else
        Write(44,1111)T0,CFNRT,XXX3,Vel4S,FRENK1,CFTRN,CSDL,XXX8,
     c  TdamageNRT,CFARC
1111    Format(1pg12.5,   0pf10.2,  4f10.2,1pg12.4,g12.4,g15.5, 0pf15.2)
                       endif
                                                              else  ! 1)
        Write(44,1112)T0,CFNRT,XXX3,Vel4S,FRENK1,CFTRN,CSDL,XXX8
1112    Format(1pg12.5,   0pf10.2,  4f10.2,1pg12.4,g12.4)
                                                              endif ! 1)
*         
*
*
        If(MD.eq.0) Write(33,6)Tmean1,Tplay1
6       Format(1x,'Tmean =',1pe12.5,' MeV     Tplay=',g12.5) 
*
        If(MD.eq.0) then  
cccc        if(istop.eq.-1) Write(33,7)RZ,RFULL,R1
cccc   7    Format(
cccc     #' Path (Ziegler,evl)=',1pe10.3,' cm,  total=',e10.3,' cm'/
cccc     #' Path (total,calc )                      =',e10.3,' cm')
cccc        if(istop.eq.1) Write(33,8)RFULL,R1
cccc   8    Format(' Total path (SPAR)=',1pe10.3,' cm',
cccc     #'   path (total,calc)=',e10.3,' cm')
        if(istop.eq.-1) Write(33,7)RZ,R1,100.*abs(RZ-R1)/RZ
   7    Format(' Path (Ziegler,evl)=',1pe10.3,' cm',
     #  '   path (calc )=',e10.3,' cm','   (',0pf5.1,' %)')
        if(istop.eq.1) Write(33,8)RFULL,R1
   8    Format(' Path (SPAR)=',1pe10.3,' cm',
     #'   path (total,calc)=',e10.3,' cm')
                    else
        if(istop.eq.-1) Write(33,17)RZ
  17    Format(' Path (Ziegler,evl)=',1pe10.3,' cm')
        if(istop.eq.1) Write(33,18)RFULL
  18    Format(' Total path (SPAR)=',1pe10.3,' cm')
                    endif
*
*
        Write(33,81)Interr1
81      Format(1x,' Histories interrupted (subr model)=', i12)
                      tpc=0.0
        if(itot.ne.0) tpc=100.*dfloat(icut)/dfloat(itot)
*
        If(maxplay.gt.1) then
        Write(33,82)tpc,maxplay
  82    Format(1x,' T play was cut (TPKA rout) =',f16.3,
     #  '  %    Maxplay=',i9)
                         endif
        If(maxplay.lt.0) then
        Write(33,821)tpc
 821    Format(1x,' T play was cut (TPKA rout) =',f16.3,
     #  '  %    no limitation on Maxplay')
                         endif
        If(tpc.gt.5.0.and.maxplay.gt.1) write(33,83)tpc
  83    Format(26('*'),' W A R N I N G ',30('*')/'*',
     #  f15.3,' is too much,  increase Maxplay in input',
     #  ' file         *'/26('*'),' W A R N I N G ',30('*'))
*
* GRAPHs preparation
* 
        Sum=0.0
        Sumf=0.0
        Sumt=0.0
        do i=1,105
*
        DD(i)=DD(i)/dfloat(Nhist)
        DDF(i)=DDF(i)/dfloat(Nhist)
c recalculation to the fluens 1/cm2
        DD(i)=DD(i)/(HST*RN0)
        DDF(i)=DDF(i)/(HST*RN0)
*
        TK(i)=TK(i)/(HST*dfloat(Nhist))
        sum=sum+DD(i)
        sumf=sumf+DDF(i)
        sumt=sumt+TK(i)
        enddo
*
* check the maximal i-number, where DD .ne. 0
        do i=1,105
        j=105-i+1
        if(DD(j).ne.0.0) goto 100
        enddo
        j=105
 100    if(j.le.105-2) j=j+2
        jddmax=j
*
c
c For BCA-MD no damage profile
        If(MD.eq.1.and.igraph.ne.0) then
                                               If(MDarc==0) then
                                    Write(33,101)
 101    Format(/' (no damage profiles for joint BCA-MD calculations)')
                                                            else
                                    Write(33,1011)
1011    Format(/' (no damage profiles for BCA+arc-dpa calculations)')
                                                            endif
                                    igraph=0
                                    endif
        If(igraph.eq.0) goto 2000
*
        IPR1=33
        DD(1)=0.0
        Write(33,12)
  12    Format(/
     #  ' Profile of damage from Lindhard dS/dx (free path )')
*
        Write(33,13)
  13    Format(
     # ' [Z]=cm, [D]=(dpa), result is normalized on primary ',
     # 'ion fluence 1/cm**2')
*
        Call GRAPH(XX,DD,jddmax,0)                                         
*
        Write(33,14)Sum,Sum*(HST*RN0)
  14    Format(
     # ' Sum(Y)=',1pe13.5,' dpa','    (unnormalized)= ',g12.5/)
*
        Write(33,15)
  15    Format(/
     #  ' Profile of damage from direct counting            ')
        Write(33,13)
*
        Call GRAPH(XX,DDF,jddmax,0)                                         
        Write(33,14)Sumf,Sumf*(HST*RN0)
*
*        
2000    continue
*
*
*
* Get cascade function for different primary energies 
*
* energy corresponds to the middle of interval
        Do i=2,405
        EKIN2(i)=0.5*( EKIN(i)+ EKIN(i-1) )
        Enddo
        EKIN2(1)=EKIN(1)/2. ! (see subr.Initialize_)
*
        MEK1=MEK+1
        If(MD.eq.0) then
        Write(33,16) 
  16    Format(' Number of vacancies at different',
     #' primary energies from current calculation'/
     #'                                   ',
     #'    [explanation (2),(3),(4) see above]'/75('-')/
     #'    Energy     dS/dx(free path)  ',
     #' dS/dx(integr)     Direct counting'/
     #'     (MeV)          (2)       ',
     #  '        (3)               (4)')
              Vel1LS2 =0.0
              Vel4S2  =0.0
              FRENK2  =0.0
        Do i=1,MEK1
              Vel1LS2 =Vel1LS2 +Vel1L(i)
              Vel4S2  =Vel4S2  +Vel4(i)
              FRENK2  =FRENK2  +dfloat(NFRENKEL(i))/dfloat(Nhist)
        Write(33,19) EKIN2(i),Vel1LS2, Vel4S2,FRENK2
  19    Format(1pg12.4,4x,     0pg12.5, 2(6x,g12.5))
        Enddo
                    endif ! If(MD.eq.0)
*
        Write(33,*)' '
        Write(33,*)' '
        Return
        End 
*
*
************************************************************************
*
      Subroutine Print_auxiliary_information_about_alphaS_PartMD
     c                                             (MDarc,alphaS,PartMD) 
      implicit real*8(A-H,O-Z)
      character C3*3
      C3=' MD'; if(MDarc==1) C3='arc'

      Write(333,'(3a,g12.5,a)')
     c  ' Part of',C3,' events at T=Tcrit = ',PartMD*100.,' %'
*
      If(PartMD==0.0d0)                                            then
      Write(333,'(a)')' no smoothing for transition to BCA at T=Tcrit as
     c it was in IOTA-2004'
                                                                   else
      Write(333,'(a,g12.5)')' alphaS (see Subr. Smoothtransition) = ',
     c alphaS
                                                                   endif
      Return           
      End 
*
*
************************************************************************
*
      Subroutine Print_auxiliary_information_about_Ed(ED0,EdMD)
      implicit real*8(A-H,O-Z)
      Common/URANUS/carc,barc,MDarc

      IEdMD=idint(EdMD*1.e+6+0.001d0)
      IEd0=idint(Ed0        +0.001d0)

      If(MDarc==0)                                            Then
*
* default Ed (Ed=0) with MD
        if(ED0<=0.0) THEn
        Write(333,'(a,f6.1,a)')
     c'! Ed is taken according to information from Subr. MDPARAM =',
     c  EdMD*1.e+6,' eV  '
                     ELSe
        If( IEdMD==IEd0 ) Return
        Write(333,'(a,f6.1,a)')
     c'!! Ed is redefined according to information from Subr. MDPARAM ='
     c  ,EdMD*1.e+6,' eV'
                     ENDif

                                                              Else
*
* default Ed (Ed=0) 
        if(ED0<=0.0) THEn
        Write(333,'(a,f6.1,a)')
     c'! Ed is taken as in Subroutine ARC_DPA_PARAMETERS =',
     c  EdMD*1.e+6,' eV  '
                     ELSe
        If( IEdMD==IEd0 ) Return
        Write(333,'(a,f6.1,a)')
     c'!! Ed is redefined according Subroutine ARC_DPA_PARAMETERS ='
     c  ,EdMD*1.e+6,' eV'
                     ENDif
                                                              Endif
       Return
       End 
*
*
************************************************************************
*  
        Subroutine PurifyCData(CDataSystematics,CDataNordlund)
        implicit real*8(A-H,O-Z)
        Character*9999 CDataSystematics,CDataNordlund

        Do i=1,9000
        If(CDataSystematics(i:i)=='S') CDataSystematics(i:i)=' '
        If(CDataSystematics(i:i)=='E') CDataSystematics(i:i)=' '
        If(CDataSystematics(i:i)=='x') CDataSystematics(i:i)=' '
        If(CDataSystematics(i:i)=='p') CDataSystematics(i:i)=' '

        If(CDataNordlund(i:i)=='Z') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)=='=') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)=='E') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)=='d') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)=='C') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)=='a') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)=='r') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)=='c') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)=='B') CDataNordlund(i:i)=' '
        If(CDataNordlund(i:i)==';') CDataNordlund(i:i)=' '

        Enddo

        Return
        End
* 
*
************************************************************************
*
       Real*8 function R_atio(XXX,TRN)
       implicit real*8(A-H,O-Z)
                     R_atio=0.0 
       If(TRN > 0.0) R_atio=XXX/TRN
       Return
       End
* gleich  Compaq Visual Fortran
*
************************************************************************
*
       Real*8 Function RANDOMG(IT MEANS NOTHING)
*      --------------------------------
*
* random number generator
*
* Compaq Visual Fortran 
*
         RANDOMG=RAND(0)
****
**** GNU Fortran pseudo random generator:
****
****
****      RANDOMG=RAND(0)
**
**
** WATCOM Fortram pseudo random number generator
** generator is initialized in Subroutine Initialize_and_Zeroize
** See   Common/urand1/iyg;    iyg=1
**
**      Common/urand1/iyg
**      RANDOMG=URAND(iyg)
**
       Return
       End
*
************************************************************************
*
        Subroutine READ_DATA
*       --------------------
        parameter (maxc=21,maxc1=22)
        implicit real*8(A-H,O-Z)
        Character INPNAM_XS*500, INPNAM_DEDX*500, OUTNAM*500
        Common/FILENAMES/INPNAM_XS(MAXC1,MAXC),INPNAM_DEDX(MAXC1),
     #  OUTNAM
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
*
        Common/dEdxMain01/Ex01(MAXC1,1501), dEdx01(MAXC1,1501),
     #  Rp01(MAXC1,1501), dEdxN01(MAXC1,1501),NdE01(MAXC1)
*
        Common/Lindhard01/Energy01(MAXC1,MAXC,1701), 
     #  dSdX01(MAXC1,MAXC,1701), 
     #  dEdX_Nuc01(MAXC1,MAXC,1701), dEdX_Nuc_0Ed01(MAXC1,MAXC,1701),
     #  dEdX_Nuc_Ed_Tmax01(MAXC1,MAXC,1701),
     #  CST01(MAXC1,MAXC,1701), NSL01(MAXC1,MAXC)
*
        Common/istop/istop
*
        Dimension Ex01tmp(1501), dEdx01tmp(1501),Rp01tmp(1501), 
     #  dEdxN01tmp(1501) ! NdE01tmp
c
c
c
      NK1=NK+1
*
      if(istop.ne.-1) goto 2
* 
* istop=-1
*
* Reading dE/dx from SRIM/Ziegler OUTPUT
* ---------------------------------------
      Do IK=1,NK1
*
                                                        IR=21
      open(IR,file=INPNAM_DEDX(IK))
      read(ir,*,end=90003);  backspace ir
*                                    
      Call dEdX_ZIEGLER_READ(IK, IR, RO, Ex01tmp, dEdx01tmp, Rp01tmp,
     #                       NdE01tmp,   dEdxN01tmp)
* Now units for range and stopping power are Rp(cm), Ex(MeV), dEdx(MeV/cm)
       NdE01(IK)=NdE01tmp
* fill arrays
       do J=1,NdE01tmp
       Ex01(IK,J)   =Ex01tmp(J)   
       dEdx01(IK,J) =dEdx01tmp(J) 
       Rp01(IK,J)   =Rp01tmp(J)   
       dEdxN01(IK,J)=dEdxN01tmp(J)
       enddo
*
       close(IR)
       Enddo ! Do IK=1,NK1
*
*
  2    continue
*
*
* Reading data prepared by SL_LNSxx code
* --------------------------------------
      Do IK=1,NK1   
*
      if(IK.eq.1) then
                  IZP=idint(Z1+0.001)
                  IAP=idint(A1+0.001)
                  else
                  IZP=idint(ZT(IK-1)+0.001)
                  IAP=idint(AT(IK-1)+0.001)
                  endif
*
* IK - id of the moving ion
* MK - id of the material component
*
      Do MK=1,NK
      IZC=idint(ZT(MK)+0.001)
      IAC=idint(AT(MK)+0.001)
                                                         IR=21
      open(IR,file=INPNAM_XS(IK,MK))
        Read(IR,*,end=90001)Z10,A10,Z20,A20
        IZ10=idint(Z10+0.001)
        IA10=idint(A10+0.001)
        IZ20=idint(Z20+0.001)
        IA20=idint(A20+0.001)
ccc     If(IZ10.ne.IZP .or. IA10.ne.IAP .or. 
ccc  #     IZ20.ne.IZC .or. IA20.ne.IAC) goto 90002

        iadif1=iabs(IA10-IAP)
        iadif2=iabs(IA20-IAC)

        If(IZ10.ne.IZP .or. IZ20.ne.IZC) goto 90002
* difference in "1" for A is accepted
        If(iadif1 > 1 .or. iadif2 > 1 ) goto 90002

        do iii=1,MAXC
        read(IR,*) 
        enddo
*
        NSL01tmp=1
        Energy01(IK,MK,NSL01tmp)=0.0
        dSdX01(IK,MK,NSL01tmp)  =0.0
        dEdX_Nuc01(IK,MK,NSL01tmp)=0.0
        dEdX_Nuc_0Ed01(IK,MK,NSL01tmp)=0.0
        dEdX_Nuc_Ed_Tmax01(IK,MK,NSL01tmp)=0.0
        CST01(IK,MK,NSL01tmp)=0.0
*
        Do iii=1,111111111
* 1    2     3               4               5                  6 
* T0,  DSDX, DEDX_nuc_total, DEDX_nuc_0_Ed,  DEDX_nuc_Ed_Tmax,  CS_Ed_Tmax
           Read(IR,*,end=4000) XXX1, XXX2, XXX3, XXX4, XXX5, XXX6
           NSL01tmp=NSL01tmp+1
           If(NSL01tmp.gt.1701) Call error0('Dime',1701)
*
           Energy01(IK,MK,NSL01tmp)=XXX1
           dSdX01(IK,MK,NSL01tmp)  =XXX2
           dEdX_Nuc01(IK,MK,NSL01tmp)=XXX3
           dEdX_Nuc_0Ed01(IK,MK,NSL01tmp)=XXX4
           dEdX_Nuc_Ed_Tmax01(IK,MK,NSL01tmp)=XXX5
           CST01(IK,MK,NSL01tmp)=XXX6
*
        Enddo ! Do iii=1,111111111
        Call error0('????',IR)
*
4000    continue
*
        NSL01(IK,MK)=NSL01tmp
*
        close(IR)
*
        Enddo !   Do MK=1,NK
        Enddo !   Do IK=1,NK1   
*
check if data are prepared by SL_LNS code up to the same energy
        Do IK=1,NK1   
        Do MK=1,NK
        If(NSL01(IK,MK).ne.NSL01(1,1)) goto 90004
        enddo
        enddo
*
        Return
*
*
90001   Print *,' File with the cross-sections from SL_LNS ',
     #  ' code is ABSENT'
        print *,' for ',IZP,IAP,' +',IZC,IAC,' interactions !'
        print *,'                       press any key...'
        pause
        stop
90002   Print 90012,INPNAM_XS(IK,MK)(1:72),
     c                 IZP,IAP,IZC,IAC,Z10,A10,Z20,A20
90012   Format(1x,' Input file with the cross-sections: '/a72
     c  /1x,
     #  ' for ',i3,i5,' +',i3,i5,' interactions '/1x,
     #  '     contains the information '/1x,
     #  ' for ',2f6.1,' +',2f6.1,' interactions - E R R O R')
        print *,'                       press any key...'
        pause
        stop
90003   Print 90013,INPNAM_DEDX(IK)(1:72)
90013   Format(//30x,'E  R  R  O  R'
     #  //' There are NO input file from SRIM (Ziegler)',
     #  ' code '//1x,'                          NAME =  '/a72//)
        print *,'                       press any key...'
        pause
        stop
90004   Print 90014
90014   Format(//30x,'E  R  R  O  R'
     #  //' Data prepared by SL_LNS code for different components ',
     #  ' do not coincide !'//1x,'  Delete corresponding files and ',
     #  ' run SL_LNS again.'//)
        print *,'                                     press any key...'
        pause
        stop
        End
* 
*
************************************************************************
*
        Subroutine Read_E_HIST_POS(ir,X0,Y0,Z0,COSX0,COSY0,COSZ0,iestop)
*       ----------------------------------------------------------------
        parameter (maxe=50001)
        implicit real*8(A-H,O-Z)
        Common/EIN/EIN(MAXE),NH(MAXE),KEIN
        iestop=0
*
* Read 8 values
        Read(Line,*,err=90000,end=90000)
     c                             EE1,NHH1,X0,Y0,Z0,COSX0,COSY0,COSZ0
        EE=EE1
        NHH=NHH1
                                                  if(EE.lt.0.0) iestop=1

        ir=ir+1
                                               If(ir.gt.MAXE) goto 90010
        EIN(ir)=ABS(EE)
        NH(ir)=NHH
        KEIN=ir

        Return
*
*
90000   Print *,' (!!)  Error in INPUT information'
        Print *,' ---> EE1,NHH1,X0,Y0,Z0,COSX0,COSY0,COSZ0 are not corre
     cctly entered '
        print *,'                              press <Enter>...'   
        pause
        stop
90010   print *,' T O O   M U C H   I N P U T   E N E R G I E S  !'
        print *,' Change parameter MAXE in the code !'
        print *,'                                 press any key...'
        pause; stop
        End
*
*
************************************************************************
*
        Subroutine READ_INPUT(Cinp)
*       ---------------------
* + write general information in output file
c
        parameter (maxc=21,maxc1=22,maxe=50001)
        implicit real*8(A-H,O-Z)
        Character CTASK_NAME*80, cgnu*1
        Character INPNAM_XS*500, INPNAM_DEDX*500, OUTNAM*500,OUTNAM2*500
        Character*500 OUTNAM3, MDNAME, ctmp
        Character NF(MAXC)*500,  C50*500, C80*80, Cinp*500, CLine*500
        Common/FILENAMES/INPNAM_XS(MAXC1,MAXC),INPNAM_DEDX(MAXC1),
     #  OUTNAM
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/EIN/EIN(MAXE),NH(MAXE),KEIN
        Common/OPTIONS1/igraph0,maxplay
        Common/CUT1/rmaxpl,itot,icut
        Common/PARAM01/IDSDT
        Common/MERCURY/CMD(5),Ecrit,EdMD,MD
        Common/ISTOP/ISTOP
        Common/EARTH/CTASK_NAME,C50
        Common/SATURN/TcritLAB(MAXC1)
        Common/EIN2/XXX(maxe),YYY(maxe),ZZZ(maxe),COSX(maxe),COSY(maxe),
     $              COSZ(maxe)
        Common/keytpka/keytpka
        Common/Tlim0/Tlim
        Common/events_printing/ieveprint
        Common/parpar/par_st1,par_st2
        Common/Sep0717/i_ecrit_input
        Common/URANUS/carc,barc,MDarc
        Common/Sep1317/inordlund
        Common/Sep2117/alphaS,PartMD
        Common/Sep2217/IDSDToriginal
*
        Open(333,file='inform.txt')    
c
* Input file
        open(1,file=Cinp,status='old',err=90002)
c
* now CTASK_NAME is not used
        CTASK_NAME=' '
                                                Call Letztez(Cinp,icinp)
        Write(333,2900)Cinp(1:icinp)
c
*
* 1. Read
*    ----
c
c find line with graph printing option and maxplay
        call star(1)
c dS/dT
c IDSDT=0, 10(=0), 11-15 LNS expression; 
c      =1                Burenkov et al
c
c Tlim maximal energy for SL_LNS code
c
*    ieveprint =0 : "events" file will not be printed
*
        read(1,'(a)')CLine;          Call Delete_exlamation_point(Cline)
                                            Call gnu_comment(Cline,cgnu)
*
* par_st1, par_st2 define the accuracy of calculations in Subr. Model
*  in alter Version par_st1=0.1, par_st2=0.05
*
* old algorithm keytpka=-1, new =+1, if =0 (default) =new algorithm (+1)
*
        Call GetInputValues1(CLine,
     c                       IDSDT,par_st1,par_st2,ieveprint,keytpka)
 
                                                    IDSDToriginal=IDSDT
*
* now igraph0 is fixed
        igraph0=1
*
c
c MAXPLAY: maximal number of attempts to get the recoil energy by
c MC "exception " method  for recoil spectra simulation
c          < 0 old and slow algorithm is used. It is the same as
c              for AMXPLAY > 0 described in Manual, Aug 2004
c          > 0 or =0 new fast algorithm  
*
* July 2017: MAXPLAY is fixed
        maxplay=500000
*
*
          if(keytpka==-1)               then
          maxplay=-maxplay
          rmaxpl=-dfloat(maxplay) 
                                        else
c new algorithm (fast)
          rmaxpl= dfloat(maxplay) 
                                        endif
c
c now Tlim is fixed (if you want increase it change also other
c                    instructions in other Subroutines
        Tlim=5200.
*
        Write(333,3000)IDSDToriginal,Tlim,par_st1,par_st2,ieveprint,
     c                                               keytpka, maxplay
c
c Define f(t^1/2) function parametrs 
        Call FT12CHOICE(IDSDT)
c
c
        If(IDSDT.ne.0.and.IDSDT.ne.1) then
        Print *,'           E R R O R  in INPUT file       '
        Print *,'  IDSDT parameter is incorrect'
        Print *,'                          press any key...'
        pause
        stop
        endif
*
*
* 2. Read
*    ----
c
c find line with Z1, A1 of projectile and file for stopping power
*                                   if Ziegler, SRIM data will be used
        call star(1)
        read(1,'(a)')CLine
                                     Call Delete_exlamation_point(Cline)
                                          If(iwords(CLine)<2) goto 90004
* Now if the file with stopping power exists =Ziegler,
*  if absent = SPAR
*
        If(iwords(CLine)==3) then
* Ziegler
        Call Lesen_ein_Wort(CLine,3,INPNAM_DEDX(1),ice)
        istop=-1
                             else
* SPAR  
        istop=1
                             endif
*
        read(Cline,*,err=9929)Z1,A1
*
*
* 3. Read
*    ----
c
c find line with RO (density of the material), number of material components
c and name of MD results, if they will be applied
        call star(1)
        read(1,'(a)')CLine
                                     Call Delete_exlamation_point(Cline)
                                          If(iwords(CLine)<2) goto 90007
        read(Cline,*,err=90005)RO, NK
c
        If(NK.gt.MAXC) then 
        Print *,'Number of components > ',MAXC,' !'
        print *,'                       press any key...'
        pause; stop
        endif
c
c 
        If(RO.le.0. .and. NK.ne.1) then
        Print *,' '
        Print *,
     #  '      NO  default density for compounds !!!'
        print *,'                           press any key...'
        pause; stop
        endif
*
* if there is more than 2 entries here, they are interpreted
*  as information about MD calculations
       if(iwords(Cline) >=3)                                     THEN

        MD=1
        Call Lesen_ein_Wort(CLine,3,MDname,imdn)
                                                        carc=0.;barc=0.0
                                           MDarc=0
        If(MDname=='arc-dpa'.or.MDname=='arc'.or.MDname=='arcdpa')
     c                                     MDarc=1
*
* alphaS is used in Subr. Smoothtransition
cccc    PartMD=dexp( -(1.-alphaS)/alphaS )
* 3 %
        PartMD= 3. *0.01
        alphaS=1.d0/(1.d0-dlog(PartMD))

                                                 i_ecrit_input=0 
        if(iwords(Cline) >= 4)  then
           Call Lesen_ein_Wort(CLine,4,CTMP,ictmp)
           Read(CTMP,*,end=90008,err=90008)Ecrit_input 
                                                 i_ecrit_input=1
           If(Ecrit_input<=0.0) i_ecrit_input=0 
                                endif 

* Part of MD (or arc-dpa) processes at T=Tcrit
        if(iwords(Cline) >= 5)  then
           Call Lesen_ein_Wort(CLine,5,CTMP,ictmp)
           Read(CTMP,*,end=90009,err=90009)PartMD  ! percent

        PartMD=0.01d0 *PartMD
            if(PartMD > 1.0d0) PartMD= 1.0d0
            if(PartMD <= 0.0d0) PartMD= 0.0d0

        if(PartMD/=0.0d0) alphaS=1.d0/(1.d0-dlog(PartMD))
                                endif 
*
        Call Print_auxiliary_information_about_alphaS_PartMD
     c                                             (MDarc,alphaS,PartMD) 

                                                                 ELSE
        MD=0
            Do itcritlab=1,maxc1
            TcritLAB(itcritlab)=-1.E+6
            Enddo
                                                                 ENDIF
        If(MD.ne.0 .and. NK.ne.1) then
        Print *,
     #  'Joint BCA-MD calculations are not tested for compounds yet !'
        Print *,
     #  '  (!!!)  See comments *noalloy in Subr MODEL and READ_INP'
        print *,'                        press any key...'
        pause; stop
        endif
*
*
* 5.(or more) Read
*             ----
c
c find lines with the description of material componets
        Do IK=1,NK
        call star(1)
        read(1,'(a)')CLine
                                     Call Delete_exlamation_point(Cline)
                                          If(iwords(CLine)<4) goto 90006
        read(Cline,*,err=90000)ZZ,AA, FR0, ED0
* default Ed (Ed=0) without MD
                       If(MD==0.and.ED0<=0.0) ED0=40.0  ! default = 40 eV

        If(iwords(CLine)==4.and.istop==-1.or.
     c     iwords(CLine)==5.and.istop==+1)       then
       Print *,' '
       Print *,
     c ' In this version is not possible to mix Ziegler and SPAR data !'
       print *,'                           press any key...'
       pause
       stop;                                    endif
*
        if(iwords(CLine)==5) 
     c     Call Lesen_ein_Wort(CLine,5,INPNAM_DEDX(IK+1),ice)

        IZ=idint(ZZ+0.001)
*
*
*
* Parameters for MD efficiency from Subr. MDPARAM orc arc-dpa parameters
* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*noalloy
        If(MD.eq.1)                                            Then ! 1)
          If(MDarc==0)                                 THen ! 2)
* MD results
* ----------
                          Call MDPARAM(IZ,MDname,C50)
                                                       ELse ! 2)
*
* arc-dpa
* -------
        Call arc_parameters(IZ,ECRIT,Edarc,inordlund)
        EdMD=Edarc*1.e-6

                                                       ENdif ! 2)

        Call Print_auxiliary_information_about_Ed(ED0,EdMD)

        ED0=EdMD*1.e+6
*
* redefine ECRIT, if available in input
        If(i_ecrit_input==1) ECRIT=Ecrit_input
                                                               Endif ! 1)
*
*
        ZT(IK)=ZZ
        AT(IK)=AA
        FR(IK)=FR0
        ED(IK)=ED0 * 1.e-06    ! eV --> MeV
c
*
*
        Enddo ! Do IK=1,NK
       
*
* 6.(or more) Read
*             ----
*
* Output file name
*
        call star(1)
        read(1,'(a)')CLine
                                     Call Delete_exlamation_point(Cline)
        Call Output_filenames(Cline,OUTNAM,OUTNAM2,OUTNAM3)
*
*
*
*
*Feb1207
* initialize the position
        Do ie=1,maxe 
        XXX(ie)=0.0
        YYY(ie)=0.0
        ZZZ(ie)=0.0
        COSX(ie)=0.0
        COSY(ie)=0.0
        COSZ(ie)=1.0
        Enddo
*
*
* Read
* ----
*
*
* Lines with energies, MC events (and position)
*
        ir=0; KEIN=0
        Do 7777 while (.not.eof(1))
                                  call star(1)
*
        read(1,'(a)')CLine;          Call Delete_exlamation_point(Cline)
*
        If(iwords(Cline)==8)                             Then
        Call Read_E_HIST_POS(ir,X0,Y0,Z0,COSX0,COSY0,COSZ0,iestop)
                        XXX(ir)=X0
                        YYY(ir)=Y0
                        ZZZ(ir)=Z0
                        COSX(ir)=COSX0
                        COSY(ir)=COSY0
                        COSZ(ir)=COSZ0
                                                         Else
        Call Energies_and_number_MC_events(Cline,ir,iestop)
                                                         Endif
*
                                                if(iestop==1) goto 8000

 7777   Continue  !  Do 7777 while (.not.eof(1))

 8000   Close(1)
        If(KEIN==0) goto 90012
        
        Do ir=1,KEIN;   If(TLIM.lt.EIN(ir)) goto 90011;  Enddo 
     
        Write(333,'(/a)')' Input energies and MC numbers'
        do ir=1,KEIN
        Write(333,'(1pg16.8,i8)')EIN(ir),NH(ir);enddo
        Write(333,*)
*
*
****************************************************************************
* open part of output files (units 44,55)
* (main output file is open in subr precalculation)
*
        open(44,file=OUTNAM2)
        open(55,file=OUTNAM3)
                                              Call LetzteZ(OUTNAM,ioutn)
        Write(44,2000)cgnu,OUTNAM(1:ioutn),cgnu
 2000   Format(a,' See explanation of (1), (2),...',
     #  ' in main output file:  "',a,'"'/a)
*
        If(NK==1)                                       then   ! 1)
          If(MDarc==0)                       then
        Write(44,2002)cgnu,cgnu
 2002   Format(a,
     #  ' E(MeV)        (1)       (2)',
     #  '       (3)       (4)       (5)       (6)          (7)',
     c'       (8)=Tdamage (keV)'/a,106('-'))

        Write(55,2003)cgnu,cgnu,cgnu,cgnu,cgnu,cgnu,cgnu
 2003   Format(a,' Efficiency (4)/(1)= N(direct counting)/N(NRT), i.e. = 
     c "(4)"/"(1)", see first output file'/a/a/a/
     ca,'              (4)/(1)      (4)           (1)        (8)'/
     ca,'  T0(MeV)   Efficiency  N(dir.count.)   N(NRT)    Tdamage(keV)',
     c/a,64('-'))
                                             else
        Write(44,20021)cgnu,cgnu
20021   Format(a,
     #  ' E(MeV)        (1)       (2)',
     #  '       (3)       (4)       (5)       (6)          (7)',
     c'       (8)=Tdamage (keV)   (9)=arc-dpa'/a,121('-'))

        Write(55,20031)cgnu,cgnu,cgnu,cgnu,cgnu,cgnu,cgnu
20031   Format(a,' Efficiency (4)/(1)= N(direct counting)/N(NRT), i.e. = 
     c "(4)"/"(1)", see first output file'/a/a,' Efficiency (9)/(1)= arc
     c-dpa formula/N(NRT), i.e. = "(9)"/"(1)", ibidem'/a/
     ca,'              (4)/(1)      (4)           (1)        (8)',
     c'          (9)/(1)        (9)'/
     ca,'  T0(MeV)   Efficiency  N(dir.count.)   N(NRT)    Tdamage(keV)',
     c'  Efficiency    arc-dpa'/a,87('-'))
                                             endif 
                                                        else   ! 1)
        Write(44,20022)cgnu,cgnu
20022   Format(a,
     #  ' E(MeV)        (1)       (2)',
     #  '       (3)       (4)       (5)       (6)          (7)',
     c/a,88('-'))
        Write(55,20032)cgnu,cgnu,cgnu,cgnu,cgnu,cgnu,cgnu
20032   Format(a,' Efficiency (4)/(1)= N(direct counting)/N(NRT), i.e. = 
     c "(4)"/"(1)", see first output file'/a/a/a/
     ca,'              (4)/(1)      (4)           (1)'/
     ca,'  T0(MeV)   Efficiency  N(dir.count.)   N(NRT)',
     c/a,50('-'))
                                                        endif  ! 1)
*
*        
*
        Print *,' Wait a bit...'
        Return
*
 2900 Format('  input file = "',a,'"')
 3000 Format('  input data'/'       IDSDT =',i2/'        Tlim =',f8.1/
     c'     par_st1 =',g12.5/'     par_st2 =',g12.5/  
     c'   ieveprint =',i5/'     keytpka =',i5/'     maxplay =',i9)
 9919   Call error0(' MD ',9919)
 9929   Call error0('Z,A ',9929)
90000   print 90001
90001   Format(/'  E R R O R  in input file INPUT !!!'
     #  /'  Possible reason:  dE/dx model chosen is inconsistent ',
     #  /'                    with the file names introduced in INPUT'  
     #  /'  Note:   SPAR option - names should be omitted'
     #  /'          SRIM option - names should be given')
        print *,'                              press any key...'
        pause;   stop
90002   print 90003,Cinp(1:70)
90003   Format(/' The following input file is ABSENT:'/a70/'!!!'/)
        print *,'                              press any key...'
        pause;  stop
90004   call error0('badr',90004)
90005   call error0('badr',90005)
90006   call error0('badr',90006)
90007   call error0('badr',90007)
90008   Print *,' Error by reading of Ecrit energy !'
        call error0('badr',90008)
90009   Print *,' Error by reading of PartMD (%) !'
        call error0('badr',90009)
90011   Print *,'           E R R O R  in INPUT file      '
        Print *,'Input energy  ',EIN(ir),'  > TLIM ! '
        Print *,'                      press any key...'
        pause; stop
90012   Print *,'           E R R O R  in INPUT file      '
        Print *,' Initial energie(s) is/(are) not enetered !'
        Print *,'                      press any key...'
        pause; stop
        End
C
C***********************************************************************
C
        Subroutine REGR1(x1,x2,y1,y2,a,b)                             
        implicit real*8(A-H,O-Z)
        Rr=x2-x1                                                      
        A=(y2-y1)/rr                                                  
        B=(y1*x2-x1*y2)/rr                                            
        Return                                                        
        End
* 
*
************************************************************************
*
        Subroutine SL_LNS50
        parameter (maxc=21)
        IMPLICIT REAL*8(A-H,O-Z)
        Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
        Common/BasicSL/Z1sl,A1sl,Z2sl,A2sl,AWsl,ROsl,RN0sl
        Common/ZAEFFSL/Zeff,Aeff
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/Z2A2SL/ZTsl(MAXC),ATsl(MAXC),FRsl(MAXC),EDsl(MAXC),NKsl
        Common/ZAINISL/Zini,Aini
        Common/PARAM01/IDSDT
        Common/PARAM01SL/IDSDTSL
        Common/AUX1/rlambdaft12,rmft12,qft12
        Common/AUX1SL/rlambdaft12sl,rmft12sl,qft12sl
*
*
* Get effective Z and A
           Zeff=0.0
           Aeff=0.0
        Do i=1,nk
        Zeff=Zeff+FR(I)*ZT(I)
        Aeff=Aeff+FR(I)*AT(I)
        Enddo
          Write(333,1004)Zeff,Aeff
 1004     Format(' Z(eff) =',f6.2,'    A(eff)=',f7.2)

        Zini=Z1
        Aini=A1

        Z1sl= Z1;        A1sl= A1;        Z2sl= Z2
        A2sl= A2;        AWsl= AW;        ROsl= RO
        RN0sl=RN0

        NKsl=NK
        Do i=1,NK
          ZTsl(i)=ZT(i); ATsl(i)=AT(i);  FRsl(i)=FR(i); EDsl(i)=ED(i)
        Enddo
         IDSDTSL=IDSDT

         rlambdaft12sl=rlambdaft12
         rmft12sl     =rmft12
         qft12sl      =qft12      

        Call SL_LNS5

        Return
        End
*
* July 2017
*
* Previously this code should be run before IOTA code with the same
* input. Now it is the part of IOTA
*
* It prepares the cross-sections for the transferring of the 
* energy T to PKA and other data 
*  
* Ver *Jan04
*
* Pay attention ! Zeff, Aeff here are equal to Z2,A2 in main IOTA code
*
* Atom concentration is defined for the fractions normalized to unity.
* (see AW=)
* 
*
*  OUTPUT DATA:
*  1 col: energy
*  2 col: N0 * ( Int[Ed to Tmax] nu(T)sig(T)dt )  (units: 1/cm)
*         cascade function Nu(T) is calculated for effective Z,A
*         of the composite target material, nu(T) includes 0.8/2Ed 
*
*  3 col: N0 * ( Int[ 0 to Tmax]   T* sig(T)dt )  (units: MeV/cm)
*  4 col: N0 * ( Int[ 0 to Ed  ]   T* sig(T)dt )  (units: MeV/cm)
*  5 col: N0 * ( Int[Ed to Tmax]   T* sig(T)dt )  (units: MeV/cm)
*  6 col:      ( Int[Ed to Tmax]      sig(T)dt )  (units: barn  )

c
c Double precision !
c
        Subroutine SL_LNS5
        parameter (maxc=21,maxc1=22)
        IMPLICIT REAL*8(A-H,O-Z)
        Character INPNAM_XS*500, INPNAM_DEDX*500, OUTNAM*500
        REAL*8 NAIGUS
        EXTERNAL F,FTRN, CS
        Common/FILENAMES/INPNAM_XS(MAXC1,MAXC),INPNAM_DEDX(MAXC1),
     c  OUTNAM
        Common/BasicSL/Z1,A1,Z2,A2,AW,RO,RN0
        Common/ZAEFFSL/Zeff,Aeff
        Common/ZAINISL/Zini,Aini
        Common/Z2A2SL/ZT(MAXC),AT(MAXC),FR(MAXC),ED0(MAXC),NK
C
        COMMON/NRT1SL/ATRN,BTRN,GTRN
        COMMON/NRT2SL/COEFF
        COMMON/ED1SL/ED
        Common/Tlim0/Tlim
        Common/PARAM01SL/IDSDT
        Common/AUX1SL/rlambdaft12,rmft12,qft12
        DIMENSION TARRAY(1499)
c          
c======================================================================
*
* define initial energies
          CALL T0_DEFINITION(TARRAY,NTAR)  
*
          ACCUR=0.01
          MAXN=15
C
c======================================================================
          NK1=NK+1
c
*
* IK =1, 2...  1 = projectile, other material component
* MK =1, 2...    = material component
*
cycle for primary ion
          Do 8888 IK=1,NK1
          If(IK.eq.1) then
                      Z1=Zini
                      A1=Aini
                      endif
          If(IK.ne.1) then
                      Z1=ZT(IK-1)
                      A1=AT(IK-1)
*Mar24
* Omit this calculation Z,A materials = Z,A projectile.Data are alredy
* prepared
cccc2017          If(  dabs(Z1-Zini).lt.0.001d0 
cccc2017     *   .and. dabs(A1-Aini).lt.0.001d0) goto 8888 
                      endif
cycle for PKA
          Do MK=1,NK 
                      Z2=ZT(MK)
                      A2=AT(MK)
* pay attention !  Z2,A2 is PKA moving in Zeff,Aeff material 
          CALL NRT_COEFF(Z2,Zeff,A2,Aeff,ATRN,BTRN,GTRN)  
C
          ED=ED0(MK)
C
          PI=3.1415926
c
c
          EL=4.8E-10        ! electron charge
          A0=0.52918E-08    ! cm
          DA=(1./RN0)**0.33333333  ! dist between atoms
* LNS:
          AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )
     #         /SQRT(Z1**0.6666666+Z2**0.6666666)
* Firsov
          If(IDSDT.ne.0) 
     #    AA=A0*(  (9.*Pi*Pi/128.)**0.333333333  )
     #         /(   ( SQRT(Z1)+SQRT(Z2) )**0.666666666   )
*
*
          E0=Z1*Z2*(EL**2)*(A1+A2)/(AA*A2)
            E0=E0/1.6E-06    !  erg ---> MeV
          ALPHA2=4.*A1*A2/((A1+A2)**2)
          PIA2=Pi*(AA**2)            
*
* output file name
          Call Define_Filename_for_SL_LNS(Z1,A1,Z2,A2,INPNAM_XS(IK,MK))

         open(900,file=INPNAM_XS(IK,MK),status='new',err=1)
                                                             goto 100 
* File exists, but it can contain not all energies up to Tlim
* (it happens, when the code was interrupted before)
    1    open(900,file=INPNAM_XS(IK,MK))
         Call Check_Tlim(Tlim,keyOK)
                                     if(keyOK==1) goto 8000
         rewind 900
*
  100    Write(900,111)Z1,A1,Z2,A2,Zeff,Aeff
         Write(900,222)
         If(IDSDT.eq.0) Write(900,223)rlambdaft12,rmft12,qft12
         If(IDSDT.ne.0) Write(900,224)
c
c
          Print *,' '
          If(IDSDT.eq.0) Print *,'            LNS F(t1/2) function'
          If(IDSDT.ne.0) Print *,'            Burenkov F(t1/2) function'
*
          Print *,' '
          Print 333,Z1,A1,Z2,A2
333       Format(' INTERACTION  ',2f6.1,' +',2f6.1,'    energies:')
*
                                                     i2i2=0
          DO 7777 III=1,NTAR
c
          T0=TARRAY(III)
          If(T0.gt.Tlim) goto 8500
*
          If(T0.le.0.1) Print 443
443       Format(\'.')
*
          If(T0.gt.0.1) then
          if(i2i2.eq.0) then
                        print *,' '
                        print *,'low energies were treated.'
                        endif
          i2i2=1
          Print 444,T0
444       Format(1pg10.2\)
          endif
C
          EPS= T0/E0
C
          Tmax=ALPHA2*T0
C
          COEFF=ALPHA2*E0/EPS
*
            XminNRT= DSQRT( EPS*ED /(ALPHA2*E0) )
            XminT  = DSQRT( 0.0d0 /(ALPHA2*E0) )
            Xmax= DSQRT( EPS*Tmax/(ALPHA2*E0) )
c
c
c int nu(T)dS/dt
                                DSDX=0.0
         If(XminNRT.lt.Xmax) then
           RES = NAIGUS(XminNRT,Xmax,FTRN,ACCUR,MAXN,IER)
           DSDX=RES*RN0 * PIA2* COEFF
         endif
c
c int TdS/dt from 0 to Tmax
                                DEDX_nuc_total=0.0
         If(XminT.lt.Xmax) then
           RES = NAIGUS(XminT,Xmax,F,ACCUR,MAXN,IER)
           DEDX_nuc_total=RES*RN0 * PIA2* COEFF
         endif
c
c int TdS/dt from 0 to Ed (or to Tmax, if it is less Ed)
                                DEDX_nuc_0_Ed=0.0
         If(0.0d+0.lt.XminNRT) then
           X10=0.0d+0
           X20=DMIN1( XminNRT, Xmax)
           RES = NAIGUS(X10,X20,F,ACCUR,MAXN,IER)
           DEDX_nuc_0_Ed=RES*RN0 * PIA2* COEFF
         endif
c
c int TdS/dt from Ed to Tmax
                                DEDX_nuc_Ed_Tmax=0.0
         If(XminNRT.lt.Xmax) then
           RES = NAIGUS(XminNRT,Xmax,F,ACCUR,MAXN,IER)
           DEDX_nuc_Ed_Tmax=RES*RN0 * PIA2* COEFF
         endif
c
c int dS/dt from Ed to Tmax (!!! cross-section integration)
c units: barn
                                CS_Ed_Tmax=0.0
         If(XminNRT.lt.Xmax) then
           RES = NAIGUS(XminNRT,Xmax,CS,ACCUR,MAXN,IER)
           CS_Ed_Tmax=RES* PIA2* COEFF *1.E+24  ! cm2--> barn
         endif
*
*  1 col: energy
*  2 col: N0 * ( Int[Ed to Tmax] nu(T)sig(T)dt )  (units: 1/cm)
*  3 col: N0 * ( Int[ 0 to Tmax]   T* sig(T)dt )  (units: MeV/cm)
*  4 col: N0 * ( Int[ 0 to Ed  ]   T* sig(T)dt )  (units: MeV/cm)
*  5 col: N0 * ( Int[Ed to Tmax]   T* sig(T)dt )  (units: MeV/cm)
*  6 col:      ( Int[Ed to Tmax]      sig(T)dt )  (units: barn  )
          Write(900,'(6g12.5)')T0,DSDX,DEDX_nuc_total,
     #    DEDX_nuc_0_Ed, DEDX_nuc_Ed_Tmax,  CS_Ed_Tmax
c
C
C This is nuclear stopping power
CCC         DTDX_Ziegler_units= DTDX/(RO*1000.)
C
7777     Continue !   DO 7777 III=1,NTAR
           goto 8500

*
8000                                  Call Letztez(INPNAM_XS(IK,MK),icc)
                 Write(333,8001)INPNAM_XS(IK,MK)(1:icc)
8001             Format(1x,' File ',a<icc>,' exists already! Check: OK')
8500     Close (900)
*
         Enddo ! Do MK=1,NK 
*
8888     Continue !  End of  Do IK=1,NK 
c
c
         Return

  111    Format(2f6.1,5x,2f6.1,'    Z1, A1 + Z2,A2  for Zeff,Aeff=',
     c   2f6.1,'      (7 lines:comments)')
  222    Format(' 1 col: energy'/
     *' 2 col: N0 * ( Int[Ed to Tmax] nu(T)sig(T)dt )  (units: 1/cm)'/
     *' 3 col: N0 * ( Int[ 0 to Tmax]   T* sig(T)dt )  (units: MeV/cm)'/
     *' 4 col: N0 * ( Int[ 0 to Ed  ]   T* sig(T)dt )  (units: MeV/cm)'/
     *' 5 col: N0 * ( Int[Ed to Tmax]   T* sig(T)dt )  (units: MeV/cm)'/
     *' 6 col:      ( Int[Ed to Tmax]   sig(T)dt    )  (units: barn  )')
  223   Format(' LNS  F(t1/2) FUNCTION IS USED.    Lambda=',f6.3,
     *  '  m=',f6.3,'  q=',f6.3)
  224    Format(' BURENKOV ET AL F(t1/2) FUNCTION IS USED  ')
         End
*
*
************************************************************************
*
       Subroutine Smoothtransition(T,Tcrit,iweiter)
       implicit real*8(A-H,O-Z)
       Common/MERCURY/CMD(5),Ecrit,EdMD,MD
       Common/Sep2117/alphaS,PartMD

                               iweiter=1
       if(MD==0) Return

*                        part of MD or arc =0.0 at T=Tcrit: no smoothing
       If(PartMD==0.0d0) then 
                                If(T <= Tcrit) iweiter=0
                                Return 
                         endif

       TcaS=Tcrit*alphaS

       If(T <= TcaS)   then
                               iweiter=0
                       else
*
* probability of MD or arc-dpa 

       Prob=Dexp(-(T-TcaS)/TcaS)
       If(randomg(0) <= Prob)  iweiter=0
                       endif
      
       Return
       End
*
*                                                Armstrong,Chandler SPAR
************************************************************************
*
       Subroutine SPAR0(ZPR, APR, E, dEdxTOTS, dEdxNS ,JJ)
*      ---------------------------------------------------
       parameter (maxc=21,maxc1=22)
       implicit real*8(A-H,O-Z)
*
       Common/Basic/Z1,A1,Z2,A2,AW,RO,RN0
       Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
       Common/VENUS/RI(MAXC)
       Dimension iza_(maxc)
*
*
       Write(*,'(///2a//2a//a//a///)')
     c'Unfortunately, the text of SPAR subroutines is ',
     c'not included in the package.',
     c'However, the executable file performs all necessary ',
     c'computations.',
     c'If you want to get the text of SPAR, please, send an email to',
     c'alexander.konobeev@kit.edu  or/and  konobeev@yahoo.com'
       pause
       stop
       end                                                               
*
*
************************************************************************
*
       Real*8 Function SQRT1(X)
*      -----------------
       implicit real*8(A-H,O-Z)
       If(X.ge.0.0)                                      Then
                    SQRT1=DSQRT(X)
                                                         Else
       If(X.ge.-0.9999999d0) then
                                SQERT1=0.0d0
                             else
                                SQRT1=-100.
                             endif
                                                         Endif
       Return
       End
*
************************************************************************
*
       Subroutine star(k)
*      ------------------
       implicit real*8(A-H,O-Z)
       character c1*1
1      read(1,'(a1)',end=1000)c1
       if(c1.eq.'*'.or.c1.eq.'c'.or.c1.eq.'C'.or.c1.eq.'!') goto 1
       backspace 1
       return
1000   if(k.eq.0) return 
       Print *,' U N E X P E C T E D   E N D   O F   I N P U T '
       print *,'                        press any key...'
       pause
       stop
       end 
*
************************************************************************
*                       
      Subroutine STORE_IN(MK,T,P,PX,PY,PZ,X,Y,Z,IDE,IGEN,IDI)
*     -------------------------------------------------------
      implicit real*8(A-H,O-Z)
      COMMON/RECSTORE/ATOM(50003,9),NKO(50003),INDIC(50003),
     !                KGEN(50003),NREC
*
      NREC=NREC+1      
               If(NREC.gt.50003) Then
               Print *,'Dimension of ATOM(),.. is not sufficient !'
               Print *,'Check COMMON/RECSTORE/  in the code      !'
               call error0('ATOM',50003)
               endif
      ATOM(NREC,1)=T
      ATOM(NREC,2)=P
      ATOM(NREC,3)=PX
      ATOM(NREC,4)=PY
      ATOM(NREC,5)=PZ
      ATOM(NREC,6)=X
      ATOM(NREC,7)=Y
      ATOM(NREC,8)=Z
      ATOM(NREC,9)=dfloat(IDI)
*
      NKO(NREC) =MK
      KGEN(NREC) =IGEN
      INDIC(NREC)=IDE
      RETURN
      END
*
************************************************************************
*
      Subroutine STORE_OUT(MK,T,P,PX,PY,PZ,X,Y,Z,IDE,IGEN,IDION)
*     ----------------------------------------------------------
      implicit real*8(A-H,O-Z)
      COMMON/RECSTORE/ATOM(50003,9),NKO(50003),INDIC(50003),
     !                KGEN(50003),NREC
*
      NREC=NREC-1
      If(NREC.lt.0) Return      
      T =ATOM(NREC+1,1)
      P =ATOM(NREC+1,2)
      PX=ATOM(NREC+1,3)
      PY=ATOM(NREC+1,4)
      PZ=ATOM(NREC+1,5)
      X =ATOM(NREC+1,6)
      Y =ATOM(NREC+1,7)
      Z =ATOM(NREC+1,8)
      IDION =idint(ATOM(NREC+1,9)+0.001)
*
      MK=NKO(NREC+1)
      IDE=INDIC(NREC+1)
* generation number
      IGEN=KGEN(NREC+1)
      RETURN
      END
************************************************************************
          Subroutine T0_DEFINITION(TARRAY,N)  
************************************************************************
          IMPLICIT REAL*8(A-H,O-Z)
          DIMENSION TARRAY(1499), TBAS(591)
c
          TB=1.0d0 - 0.1d0
c
          Do iii=1,11111111
          TB=TB+0.1d0
          if(TB.ge.9.9999d0) goto 1 
          imax=iii
                   If(iii.gt.591) then
                   Print *,' Dimension of TBAS is not sufficient !'
                   stop
                   endif  
          TBAS(iii)=TB
          Enddo
c
  1       j=0          
c
          RM=1.D-07
c
          Do irm=1,11
          RM=RM*10.d+0          
c
          Do i=1,imax
          j=j+1
                   If(j.gt.1499) then
                   Print *,' Dimension of TARRAY is not sufficient !'
                   stop
                   endif  
          TARRAY(j)=TBAS(i)*RM            
          Enddo
          Enddo
          N=j
ccc          write(333,111)(tarray(i),i=1,n)
ccc111       format(1x,1pe15.7)
ccc          stop
          return
          end
*
************************************************************************
*  
       Real*8 Function TDAM(IK,TkeV)
*      ------------------------
       parameter (maxc1=22)
       implicit real*8(A-H,O-Z)
       COMMON/NRT1/ANRT(MAXC1),BNRT(MAXC1),GNRT(MAXC1)
       TT=TkeV
*
       Tdam= TT/
     # (1.+ANRT(IK)*TT+BNRT(IK)*(TT**0.75)+GNRT(IK)*(TT**0.16666666666))     
       RETURN
       END
* 
*
************************************************************************
*
        Subroutine TheSmallestEd(E1)
*       -------------------------
        parameter (maxc=21)
        implicit real*8(A-H,O-Z)
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK

        E1=ED(1)
        if(NK==1) Return

        do i=2,NK
        If( ED(i) < E1 ) E1=ED(i)      
        enddo

        Return
        End
*05Apr07
*
************************************************************************
*  
        Real*8 Function TPKA(IK,MK,T0,Tmean)
*       -----------------------------
*
* play lgE and change probability distribution correspondingly 
*
        parameter (maxc=21,maxc1=22)
        implicit real*8(A-H,O-Z)
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/PKA/ALPHA2(MAXC1,MAXC),E0(MAXC1,MAXC)
        Common/CUT1/rmaxpl,itot,icut
        itot=itot+1
*
        Emin=ED(MK)
        Tmax=ALPHA2(IK,MK)*T0
                             If(Tmax.le.Emin) then
                             TPKA=Emin+0.0001
                             return
                             endif
        EPS= T0/E0(IK,MK)
        COEFF=ALPHA2(IK,MK)*E0(IK,MK)/EPS
*
        Xmin= DSQRT( Emin/COEFF )
c x(T)  X= SQRT( T0/COEFF )
*
* dx= (1/2) * (1/coeff)**0.5 / T**0.5
        RM=F(Xmin)/(Emin**1.5)      ! 3/2:  1 from x**2 and 0.5 from dx
* redefinition: function*E
        RM=RM*Emin
*       
*
        rn=0.
1000    TT=dlog10(Emin)+RANDOMg(0)*dlog10(Tmax/Emin)
        TPKA=10.**TT
        XX= DSQRT( TPKA/COEFF )
        rn=rn+1.
                       if(rn.gt.rmaxpl) then
                       icut=icut+1
                       TPKA=Tmean 
                       return
                       endif
1900    continue
* redefinition: function*E 
        If( RM*RANDOMg(0)-F(XX)*TPKA/(TPKA**1.5) )2000,2000,1000
*
2000    If(TT.gt.T0)then
        Print *,' T0=',T0,'  Tplay=',TT,' ALPHA2=',ALPHA2
        endif 
* 
         Return
         End
* old slow algorithm
*
************************************************************************
*  
        Real*8 Function TPKAOLD(IK,MK,T0,Tmean)
*       -----------------------------
        parameter (maxc=21,maxc1=22)
        implicit real*8(A-H,O-Z)
        Common/Z2A2/ZT(MAXC),AT(MAXC),FR(MAXC),ED(MAXC),NK
        Common/PKA/ALPHA2(MAXC1,MAXC),E0(MAXC1,MAXC)
        Common/CUT1/rmaxpl,itot,icut
        itot=itot+1
*
        Emin=ED(MK)
        Tmax=ALPHA2(IK,MK)*T0
                             If(Tmax.le.Emin) then
                             TPKAOLD=Emin+0.0001
                             return
                             endif
        EPS= T0/E0(IK,MK)
        COEFF=ALPHA2(IK,MK)*E0(IK,MK)/EPS
*
        Xmin= DSQRT( Emin/COEFF )
c x(T)  X= SQRT( T0/COEFF )
*
* dx= (1/2) * (1/coeff)**0.5 / T**0.5
        RM=F(Xmin)/(Emin**1.5)      ! 3/2:  1 from x**2 and 0.5 from dx
*       
*
        rn=0.
ccc     Tmax=dmin1( 10.*Tmean,Tmax)
*
1000    TT=Emin+RANDOMg(0)*(Tmax-Emin)
        XX= DSQRT( TT/COEFF )
        rn=rn+1.
             if(rn.gt.rmaxpl) then
             icut=icut+1
             TPKAOLD=Tmean !
ccc         Write(888,123)IK,MK,T0,Tmean,Tmax
123      Format(1x,60('-')/1x,' IK,MK,T0,Tmean,Tmax=',2i4,3g12.5)
             return
             endif
1900    continue
ccc     Write(888,*)TT, F(XX)/TT**1.5, RM
        If( RM*RANDOMg(0)-F(XX)/(TT**1.5) )2000,2000,1000
*
2000    TPKAOLD=TT
        If(TT.gt.T0)then
        Print *,' T0=',T0,'  Tplay=',TT,' ALPHA2=',ALPHA2
        endif 
* 
         Return
         End
*
************************************************************************
*  
        Subroutine TRANSFORM_ROTATE_TO_USUAL(P0X,P0Y,P0Z,P1XS,P1YS,P1ZS
     $                                      ,P1X,P1Y,P1Z)
*       ----------------------------------------------------------
        implicit real*8(A-H,O-Z)
        Dimension XS(3),YS(3),ZS(3)
        Dimension XU(3),YU(3),ZU(3)
        ALP=1.
        XU(1)=1.
        XU(2)=0.
        XU(3)=0.
            YU(1)=0.
            YU(2)=1.
            YU(3)=0.
        ZU(1)=0.
        ZU(2)=0.
        ZU(3)=1.
           XS(1)=ALP
           XS(2)=0.
check
           if(p0z.eq.0.0) p0z=1.e-10
           XS(3)=-ALP*P0X/P0Z
        YS(1)=-P0Y*ALP*P0X/P0Z
        YS(2)=ALP*P0X*P0X/P0Z+P0Z*ALP
        YS(3)=-ALP*P0Y
           ZS(1)=P0X
           ZS(2)=P0Y
           ZS(3)=P0Z
c
        P1X=P1XS*cosdd(XS,XU)+P1YS*cosdd(YS,XU)+P1ZS*cosdd(ZS,XU)
        P1Y=P1XS*cosdd(XS,YU)+P1YS*cosdd(YS,YU)+P1ZS*cosdd(ZS,YU)
        P1Z=P1XS*cosdd(XS,ZU)+P1YS*cosdd(YS,ZU)+P1ZS*cosdd(ZS,ZU)
        Return
        End  
*Feb1207
*
************************************************************************
*
      Subroutine WRITE99A(T00,IE,NHIST)
*     ------------------------------
* Write general information in "events" file
*
* See first records in "events" file in Subr PRECALCULATION
      parameter (maxe=50001)
      implicit real*8(A-H,O-Z)
      Common/MERCURY/CMD(5),Ecrit,EdMD,MD
      Common/EIN2/XX(maxe),YY(maxe),ZZ(maxe),COSX(maxe),COSY(maxe),
     $            COSZ(maxe)
      Common/events_printing/ieveprint
      if(ieveprint==0) Return
*
      Write(99,1)T00
    1 Format(1x,'Primary energy ',1pg12.5,' MeV')
*
      Write(99,10)XX(ie), YY(ie), ZZ(ie)
   10 Format(1x,'Position x,y,z = (',
     $       1pe11.3,',',e11.3,',',e11.3,' ) cm') 
      Write(99,2)COSX(ie),COSY(ie),COSZ(ie)
    2 Format(' Direction cos(i) = (',f8.4,',',f8.4,',',f8.4,' )')
*
      Write(99,3)NHIST
    3 Format(' Number of MC simulations',i7/)
      Write(99,4)
    4 Format(
     !' Moving    : moving ion identified by the material ',
     !'component number '/
     !'             (see above) [type] and by the virtual ',
     !'unique number [id].'/
     !'             Primary ion: [type]=0, [id]=1'/
     !' PKA       : primary knock-on atom created in the ',
     !'interaction with the'/
     !'             moving atom. PKA is identified by the ',
     !'material component'/
     !'             number [type] and by the virtual unique',
     !' number [id]'/
     !' T         : kinetic energy of PKA (MeV)'/
     !' X,Y,Z     : position (cm)'/
     !' Generation  reflects sequence of interactions: '/
     !'     1: PKA is created due to the interaction with primary ion'/
     !'     2: PKA is produced in the interaction with the ion from',
     !' 1st generation'/'     etc'/)
      Write(99,5)
    5 Format(
     !' Ion "stops", if its energy is below Ed'//
     !'  Moving         PKA       T(PKA)        X          Y',
     !'          Z    Generation',
     !'    T(incident ion after interaction)'/
     !' type, id     type, id '/115('~'))
*
      If(MD.eq.1) Write(99,6)
    6 Format(/
     !' W A R N I N G :'//' No records for BCA-MD calcualations')
      Return
      End
*
************************************************************************
*
      Subroutine WRITE99B(IK,LK,TPKA,X,Y,Z,IGEN,IDION,IDI,T)
*     ------------------------------------------------------
      implicit real*8(A-H,O-Z)
      Common/MERCURY/CMD(5),Ecrit,EdMD,MD
      Common/events_printing/ieveprint
      if(ieveprint==0) Return
      If(MD.eq.0) Write(99,1)IK-1,IDION,LK,IDI,TPKA,X,Y,Z,IGEN,T
ccc    1 Format(2i4,i9,i4,1x,1pe12.3,2x,3e11.3,0pi6,1pe21.3)
    1 Format(i4,i5,i9,i5,1x,1pe12.3,2x,3e11.3,0pi6,1pe21.3)
      Return
      End
*
************************************************************************
*
      Subroutine WRITE99C(IK,IDION,T,X,Y,Z,IGEN)
*     ------------------------------------------
      implicit real*8(A-H,O-Z)
      Common/MERCURY/CMD(5),Ecrit,EdMD,MD
      Common/events_printing/ieveprint
      if(ieveprint==0) Return
      If(MD.eq.0) Write(99,1)IK-1,IDION,T,X,Y,Z,IGEN
c    1 Format('s',i3,i4,t23,1pe12.3,2x,3e11.3,i6,'  stops')
    1 Format('s',i3,i5,t25,1pe12.3,2x,3e11.3,i6,'  stops')
      Return
      End
*
************************************************************************
*
        Subroutine ZIEION(C500,Z,A)
        implicit real*8(A-H,O-Z)
        Character C500*500
c
c Ex:   C500=' Ion = Tungsten [74] , Mass = 183.951 amu'
c
        open(29,status='scratch')
c
        Do i=1,500
        i1=i
        If(C500(i:i).eq.'[') goto 1000
        enddo
        Print *,' Subr. ZIEION   Symbol "[" not found !'
        print *,'                           press any key...'
        pause
        stop
c
 1000   Do i=i1,500
        i2=i
        If(C500(i:i).eq.']') goto 1001
        enddo
        Print *,' Subr. ZIEION   Symbol "]" not found !'
        print *,'                           press any key...'
        pause
        stop
c
 1001   if((i2-i1).eq.2) then
        k=i1+1     
        write(29,'(a1)')C500(k:k)
                        endif
        if((i2-i1).eq.3) then
        k1=i1+1     
        k2=i1+2
        write(29,'(a2)')C500(k1:k2)
                        endif
        if((i2-i1).ne.2.and.(i2-i1).ne.3) then
        Print *,' Subr. ZIEION    Error:   i2-i1=',i2-i1
        print *,'                        press any key...'
        pause
        stop
                        endif                      
c
        Do i=i2,500
        j1=i
        If(C500(i:i).eq.'=') goto 2000
        enddo
        Print *,' Subr. ZIEION    Second symbol "=" not found !'
        print *,'                                press any key...'
        pause
        stop
c
 2000   Do i=j1,500
        j2=i
        If(C500(i:i).eq.'a') goto 2001
        enddo
        Print *,' Subr. ZIEION   "amu" not found !'
        print *,'                       press any key...'
        pause
        stop
c
 2001   k1=j1+1
        k2=j2-1 
        write(29,'(a12)')C500(k1:k2)
        rewind 29
c
        read(29,*)Z
        read(29,*)A
        close(29)
        Return                
        end
